(*==============*)
        // AN EVENT IS RAN
(*--------------*)
        // A MESSAGE IS POSTED OR SENT
(*++++++++++++++*)
        // AN EXCEPTION IS RAISED




// v4.0
//##############################################################################
//#################                CORE                       ##################
//##############################################################################


        (*
          DEFINE THREADSAFE TO MAKE ALL THE OBJECTS THREADSAFE.
          || TAApplication
          || TABasicForm
          || TAFormManager
        *)
        {$DEFINE THREADSAFE}


        (*
          DEFINE $R AND THE FILENAME TO LOAD AN ICON FOR THE APPLICATION.
        *)
        {$R 'ICON'}


        (*
          DEFINE USE_FAST_PAINT TO ENABLE FAST CM_PAINT MESSAGE
          DELIVERY TO ALL WINDOWS.
        *)
        {$DEFINE USE_FAST_PAINT}


        (*
          DEFINE USE_HOOKS TO ENABLE USAGE OF HOOKS ON APPLICATION
          MESSAGING WHICH MAY SLOW IT DOWN.
        *)
        {$DEFINE USE_HOOKS}


//##############################################################################
//#################                CORE                       ##################
//##############################################################################
Unit UCore;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,
                                                  HMessages,
                                                  HMultimedia,
                                                  HNetwork,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine,
                                                  ADevices;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //################## MESSAGE CONSTANTS #################


  // CM_X MESSAGES ARE ONLY SEND FOR TABASICFORMS. IN A LAYERED ENVIROMENT THEY
  // ARE NOT RECIVED IN PROCESSMESSAGE. THEY SHOULD NOT BE USED, ALTHOUGH THEY
  // ARE USED INTERNALLY TO SYNCRONIZE LAYERMANAGER AND FORMMANAGER SETTINGS.
  // AM_X MESSAGES WILL BE REROUTED IN A TAFORM TO REACH PROCESSMESSAGE IF IT'S
  // NOT A MANAGER MESSAGE, AND TO REACH ALL LAYERS OTHERWISE.

  AM_FIRST      = WM_USER + 1;
  AM_FIRST_CORE = AM_FIRST + 1;
  AM_LAST_CORE  = AM_FIRST_CORE + 30;
  AM_LAST       = WM_USER + $7FFF;

                        //######################################################
                        //#################### MOUSE MESSAGES ##################

    AM_MOUSE_FIRST              = WM_MOUSEFIRST;
    //   || Wparam = mouse keys
    //   || LparamLo = X cursor client position
    //   || LparamHi = Y cursor client position
    AM_MOUSE_DOWNL              = WM_LBUTTONDOWN;
    AM_MOUSE_DOWNR              = WM_RBUTTONDOWN;
    AM_MOUSE_DOWNM              = WM_MBUTTONDOWN;
    AM_MOUSE_UPL                = WM_LBUTTONUP;
    AM_MOUSE_UPR                = WM_RBUTTONUP;
    AM_MOUSE_UPM                = WM_MBUTTONUP;
    AM_MOUSE_MOVE               = WM_MOUSEMOVE;
    // these three messages will not have the type MT_HOVER because they
    // are not sent by the system and will not be subject to capture control.
    AM_MOUSE_CLICKL             = AM_FIRST_CORE + 1;    // not in WM_MOUSEFIRST..WM_MOUSELAST
    AM_MOUSE_CLICKM             = AM_FIRST_CORE + 2;    // not in WM_MOUSEFIRST..WM_MOUSELAST
    AM_MOUSE_CLICKR             = AM_FIRST_CORE + 3;    // not in WM_MOUSEFIRST..WM_MOUSELAST
    AM_MOUSE_DBLCLICKL          = WM_LBUTTONDBLCLK;
    AM_MOUSE_DBLCLICKR          = WM_RBUTTONDBLCLK;
    AM_MOUSE_DBLCLICKM          = WM_MBUTTONDBLCLK;
    //   || WparamLo = mouse keys
    //   || WparamHi = wheel rotation in delta multiples
    //   || LparamLo = X cursor client position
    //   || LparamHi = Y cursor client position
    AM_MOUSE_WHEEL              = WM_MOUSEWHEEL;
    //   || Wparam = old hover form (object)
    CM_MOUSE_ENTER              = AM_FIRST_CORE + 4;
    CM_MOUSE_LEAVE              = AM_FIRST_CORE + 5;
    AM_MOUSE_LAST               = WM_MOUSELAST;

                        //######################################################
                        //###################### KEY MESSAGES ##################

    AM_KEY_FIRST                = WM_KEYFIRST;
    //   || Wparam = virtual key
    //   || Lparam = key data
    AM_KEY_DOWN                 = WM_KEYDOWN;
    //   || Wparam = virtual key
    //   || Lparam = key data
    AM_KEY_UP                   = WM_KEYUP;
    //   || Wparam = virtual key
    //   || Lparam = key data
    AM_SYSKEY_DOWN              = WM_SYSKEYDOWN;
    //   || Wparam = virtual key
    //   || Lparam = key data
    AM_SYSKEY_UP                = WM_SYSKEYUP;
    //   || Wparam = character
    //   || Lparam = key data
    AM_KEY_CHAR                 = WM_CHAR;
    //   || Wparam = character
    //   || Lparam = key data
    AM_SYSKEY_CHAR              = WM_SYSCHAR;
    AM_KEY_LAST                 = WM_KEYLAST;

                        //######################################################
                        //################## OWN WINDOW MESSAGES ###############

    // because overriding window messages may interfere with formmanager a the
    // most used messages are replaced with these ones. they should be used
    // instead of their system-sent relatives.
    CM_SHOW                     = AM_FIRST_CORE + 6;
    CM_HIDE                     = AM_FIRST_CORE + 7;
    CM_BOUNDS_CHANGE            = AM_FIRST_CORE + 8;
    //   || WparamLo = by X
    //   || WparamHi = by Y
    //   || LparamLo = from X
    //   || LparamHi = from Y
    CM_MOVE                     = AM_FIRST_CORE + 9;
    //   || WparamLo = by X
    //   || WparamHi = by Y
    //   || LparamLo = from X
    //   || LparamHi = from Y
    CM_SIZE                     = AM_FIRST_CORE + 10;
    CM_SET_ALWAYSONTOP          = AM_FIRST_CORE + 11;
    CM_RELEASE_ALWAYSONTOP      = AM_FIRST_CORE + 12;
    //   || Wparam = old focused form (object)
    CM_SET_FOCUS                = AM_FIRST_CORE + 13;
    CM_RELEASE_FOCUS            = AM_FIRST_CORE + 14;
    //   || Wparam = old capture form (object)
    CM_SET_CAPTURE              = AM_FIRST_CORE + 15;
    CM_RELEASE_CAPTURE          = AM_FIRST_CORE + 16;
    AM_CREATE_HANDLE            = AM_FIRST_CORE + 17;
    AM_DESTROY_HANDLE           = AM_FIRST_CORE + 18;
    // WM_PAINT messages are only processed when the message queue has
    // no other messages. this causes a large delay in paint so we check
    // for WM_PAINT messages in the queue and notify the form to paint
    // by posting this messages.
    CM_PAINT                    = AM_FIRST_CORE + 19;

                        //######################################################
                        //################### APPLICATION MESSAGES #############

    AM_APPLICATION_MINIMIZE             = AM_FIRST_CORE + 20;
    AM_APPLICATION_RESTORE              = AM_FIRST_CORE + 21;
    //   || Wparam = allowmenu (bool)
    //   || LparamLo = X cursor screen position
    //   || LparamHi = Y cursor screen position
    AM_APPLICATION_SHOW_MENU            = AM_FIRST_CORE + 22;
    //   || Wparam = allowmenu (bool)
    //   || LparamLo = X cursor screen position
    //   || LparamHi = Y cursor screen position
    AM_APPLICATION_HIDE_MENU            = AM_FIRST_CORE + 23;
    //   || Wparam = allowmenu (bool)
    //   || LparamLo = X cursor screen position
    //   || LparamHi = Y cursor screen position
    AM_APPLICATION_UPDATE_MENU          = AM_FIRST_CORE + 24;

                        //######################################################
                        //################### FORMMANAGER MESSAGES #############

    //   || Wparam = new capture form (object)
    //   || Lparam = old capture form (object)
    AM_FORMMANAGER_SET_CAPTURE          = AM_FIRST_CORE + 25;
    //   || Wparam = old capture form (object)
    AM_FORMMANAGER_RELEASE_CAPTURE      = AM_FIRST_CORE + 26;
    //   || Wparam = new focus form (object)
    //   || Lparam = old focus form (object)
    AM_FORMMANAGER_SET_FOCUS            = AM_FIRST_CORE + 27;
    //   || Wparam = old focus form (object)
    AM_FORMMANAGER_RELEASE_FOCUS        = AM_FIRST_CORE + 28;
    //   || Wparam = new hover form (object)
    //   || Lparam = old hover form (object)
    AM_FORMMANAGER_UPDATE_HOVER         = AM_FIRST_CORE + 29;

                        //######################################################
                        //################### SETBOUNDS RESULT #################

  SB_NONE       = 0;
  SB_MOVE       = 1;
  SB_SIZE       = 2;

                        //######################################################
                        //################### HOOK MESSAGE RANGE ###############

  HMR_ALL       = 0;
  HMR_MOUSE     = 1;
  HMR_KEY       = 2;
  HMR_TIMER     = 3;




                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //################ APPLICATION INIT EVENT ##############

  TExecuteEvent = procedure;

                        //######################################################
                        //##################### HOOK MANAGEMENT ################

  THookEvent = procedure(AHandle: Cardinal; Msg, WParam, LParam: Integer; AId: Integer);

  THookRec = record
    Event: THookEvent;
    Id: Integer;
    RangeMin, RangeMax: Cardinal;
  end;
  PHookRec = ^THookRec;

                        //######################################################
                        //##################### HOOKTIMER EVENT ################

  TOnHookTimerEvent = procedure of object;

                        //######################################################
                        //####################### CLASS TYPES ##################

  TAApplication = class;
  //#
  TABasicForm = class;
  //#
  TAFormManager = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                 APPLICATION                              ##
//##############################################################################




  TAApplication = class(TObject)
  protected
    FInstance,
    FThreadId,
    FHandle: Cardinal;
    FWindowProcInstance: Pointer;
    //#
    FCaption,
    FFileName,
    FFilePath: String;
    //#
    FMinimized,
    FTerminated,
    FAllowTerminate,
    FAllowMenu: Boolean;
    //#
    //#
    // message hooks can be installed for all message ranges. a compiler
    // directive is set to disabled this feature.
    FHookList: TAList;
    FHookCount: Integer;
(*============================================================================*)
    FOnDestroy: TOnEvent;
    FOnBeforeExecute,
    FOnAfterExecute: TExecuteEvent;
    FOnMinimize,                        //# RAN ON MESSAGE
    FOnRestore,                         //# RAN ON MESSAGE
    FOnShowMenu,                        //# RAN ON MESSAGE
    FOnHideMenu,                        //# RAN ON MESSAGE
    FOnUpdateMenu: TOnEvent;
    //#
    FOnHookTimer: TOnHookTimerEvent;
(*============================================================================*)
    // cursor property will return the cursor coordonates the
    // mouse had when the last message was getmessage.
    function GetCursorPos: TPoint;
    procedure SetCursorPos(ACursorPos: TPoint);
    //#
    procedure SetCaption(const ACaption: String);
    procedure SetAllowTerminate(AAllowTerminate: Boolean);
    procedure SetAllowMenu(AAllowMenu: Boolean);
(*============================================================================*)
    function WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; stdcall;
    //#
    function CreateHandle: Boolean;
    function DestroyHandle: Boolean;
(*============================================================================*)
  public
    //#
    //#
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    property Instance: Cardinal read FInstance;
    property ThreadId: Cardinal read FThreadId;
    property Handle: Cardinal read FHandle;
    //#
    procedure Execute(const ACaption: String); overload;
    procedure Execute; overload;
    function Terminate: Boolean;
    property Terminated: Boolean read FTerminated;
    property AllowTerminate: Boolean read FAllowTerminate write SetAllowTerminate;
    //#
    property AllowMenu: Boolean read FAllowMenu write SetAllowMenu;
    procedure UpdateMenu(ARecreateMenu: Boolean = False);
    //#
    procedure SendMessage(AHandle: Cardinal; AMessage: TMessage); overload;
    procedure SendMessage(AHandle: Cardinal; AMsg, AWParam, ALParam: Integer); overload;
    procedure PostMessage(AHandle: Cardinal; AMessage: TMessage); overload;
    procedure PostMessage(AHandle: Cardinal; AMsg, AWParam, ALParam: Integer); overload;
    procedure FlushQueue(AHookTimer: Boolean = True);
    //#
    property CursorPos: TPoint read GetCursorPos write SetCursorPos;
    property Caption: String read FCaption write SetCaption;
    property FileName: String read FFileName;
    property FilePath: String read FFilePath;
    //#
    property Minimized: Boolean read FMinimized;
    procedure Minimize;
    procedure Restore;
    procedure Surface;
    //#
    //#
    // message hooks can be installed for all message ranges. a compiler
    // directive is set to disabled this feature.
    function AddHook(AEvent: THookEvent; AId: Integer; AMsgRange: Integer): Boolean; overload;
    function AddHook(AEvent: THookEvent; AId: Integer; ARangeMin, ARangeMax: Integer): Boolean; overload;
    function RemoveHook(AId: Integer): Boolean;
    function FindHook(AId: Integer): Integer;
(*============================================================================*)
    // try to use these procedures to initialize the application data like forms,
    // controls etc because it will be exception safe and no other initialization
    // finalization settings will be used.
    property OnBeforeExecute: TExecuteEvent read FOnBeforeExecute write FOnBeforeExecute;
    property OnAfterExecute: TExecuteEvent read FOnAfterExecute write FOnAfterExecute;
    property OnDestroy: TOnEvent read FOnDestroy write FOnDestroy;
    property OnMinimize: TOnEvent read FOnMinimize write FOnMinimize;
    property OnRestore: TOnEvent read FOnRestore write FOnRestore;
    property OnShowMenu: TOnEvent read FOnShowMenu write FOnShowMenu;
    property OnHideMenu: TOnEvent read FOnHideMenu write FOnHideMenu;
    property OnUpdateMenu: TOnEvent read FOnUpdateMenu write FOnUpdateMenu;
    //#
    //#
    // this is used by hooktimer in UBasic. it doesn't use normal hooks because
    // timer operations require flushqueue and that should be done outside locks.
    property OnHookTimer: TOnHookTimerEvent read FOnHookTimer write FOnHookTimer;
  end;




//##############################################################################
//##                                BASICFORM                                 ##
//##############################################################################




  // EACH FORM MUST HAVE A UNIQUE NAME. IF NOT THEN AN EXCEPTION IS RAISED.

  TABasicForm = class(TObject)
  protected
    FHandle,
    FDC: Cardinal;
    FWindowProcInstance,
    FWindowProcPointer: Pointer;
    //#
    FLeft,
    FTop,
    FWidth,
    FHeight: Integer;
    //#
    FName: String;
    FVisible,
    FAlwaysOnTop,
    FMenu,
    FAllowHide: Boolean;
    //#
    //#
    // this is true when a fast paint message is in queue waiting to be processed.
    // it should be set to false when WM_PAINT or CM_PAINT are processed.
    FFastPaint: Boolean;
    // this is used to emulate click message. it holds the buttons pressed on
    // the form so that when a press matches a release a click message is posted.
    FButtonDown: Integer;
    // this is a structure used for requesting the
    // mouse hover state at a period of time.
    FMouseTrack: TTrackMouseEvent;
(*============================================================================*)
    FOnDestroy: TOnEvent;
(*============================================================================*)
    // cursor property will return the cursor coordonates the
    // mouse had when the last message was getmessage.
    function GetCursorPos: TPoint;
    procedure SetCursorPos(ACursorPos: TPoint);
    //#
    procedure SetLeft(ALeft: Integer);
    procedure SetTop(ATop: Integer);
    procedure SetWidth(AWidth: Integer);
    procedure SetHeight(AHeight: Integer);
    function GetBounds: TARect;
    //#
    procedure SetVisible(AVisible: Boolean); virtual;
    procedure SetAlwaysOnTop(AAlwaysOnTop: Boolean); virtual;
    //#
    function GetFocused: Boolean; virtual;
    procedure SetFocused(AFocused: Boolean); virtual;
    function GetCapture: Boolean; virtual;
    procedure SetCapture(ACapture: Boolean); virtual;
(*============================================================================*)
    function WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer; virtual; stdcall;
    //#
    function CreateHandle: Boolean;
    function DestroyHandle: Boolean;
(*============================================================================*)
  public
    //#
    //#
    constructor Create(const AName: String; AWindowProcPointer: Pointer = nil); overload;
    destructor Destroy; override;
    //#
    //#
    property CursorPos: TPoint read GetCursorPos write SetCursorPos;
    procedure ScreenToClient(var P: TPoint);
    procedure ClientToScreen(var P: TPoint);
    //#
    property Focused: Boolean read GetFocused write SetFocused;
    property Capture: Boolean read GetCapture write SetCapture;
    property Handle: Cardinal read FHandle;
    property DC: Cardinal read FDC;
    //#
    property Left: Integer read FLeft write SetLeft;
    property Top: Integer read FTop write SetTop;
    property Width: Integer read FWidth write SetWidth;
    property Height: Integer read FHeight write SetHeight;
    property Bounds: TARect read GetBounds;
    //#
    function SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer; overload; virtual;
    function SetBounds(ARect: TARect): Integer; overload;
    function Move(ALeft, ATop: Integer): Boolean;
    function Size(AWidth, AHeight: Integer): Boolean;
    //#
    procedure Invalidate; overload;
    procedure Invalidate(ARect: TRect); overload;
    procedure Update; virtual;
    //#
    procedure Show;
    function Hide: Boolean;
    procedure Surface;
    //#
    property Name: String read FName;
    property Visible: Boolean read FVisible write SetVisible;
    property AlwaysOnTop: Boolean read FAlwaysOnTop write SetAlwaysOnTop;
    property Menu: Boolean read FMenu write FMenu;
    property AllowHide: Boolean read FAllowHide write FAllowHide;
(*============================================================================*)
    property OnDestroy: TOnEvent read FOnDestroy write FOnDestroy;
    // no input mouse or keyboard events are present on basic form because
    // if you choose to use basic form then you have to use the windowproc
    // and will have access to all messages.
  end;




//##############################################################################
//##                              FORMMANAGER                                 ##
//##############################################################################




  // IN LAYERED ENVIROMENT THE LAYERMANAGER WILL HANDLE BOTH LAYER-LEVEL
  // AND FORM-LEVEL FOCUS AND CAPTURE. THE FORMMANAGER AND LAYERMANAGER
  // CAN BE USED TOGETHER.

  TAFormManager = class(TObject)
  protected
    FFocusedForm,
    FCaptureForm,
    FHoverForm: TABasicForm;
    //#
    FFormList: TAList;
    FFormCount: Integer;
    //#
    FCoreForm: TABasicForm;
(*============================================================================*)
    FOnDestroy,
    FOnBeforeSetCapture,
    FOnAfterSetCapture,
    FOnBeforeReleaseCapture,
    FOnAfterReleaseCapture,
    FOnBeforeSetFocus,
    FOnAfterSetFocus,
    FOnBeforeReleaseFocus,
    FOnAfterReleaseFocus,
    // update hover is done in the form window proc because there is no
    // point in complicating by making an updatehover procedure here.
    FOnUpdateHover: TOnEvent;           //# RAN ON MESSAGE
(*============================================================================*)
    function GetForm(AIndex: Integer): TABasicForm;
(*============================================================================*)
  public
    //#
    //#  
    constructor Create;
    destructor Destroy; override;
    //#
    //#
    // the systemsent parameter specifies if the focus or capture was changed
    // by the system. in that case the procedure doen't do the actual operation,
    // because it was already done by system, but it updates the formamanager to
    // be in sync with the real state of the form.
    function SetFocus(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
    function ReleaseFocus(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
    function SetCapture(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
    function ReleaseCapture(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
    property FocusedForm: TABasicForm read FFocusedForm;
    property CaptureForm: TABasicForm read FCaptureForm;
    property HoverForm: TABasicForm read FHoverForm;
    //#
    function AddForm(AForm: TABasicForm): Boolean;
    function RemoveForm(AForm: TABasicForm): Boolean;
    function FindForm(const AName: String): Integer; overload;
    function FindForm(AHandle: Cardinal): Integer; overload;
    //#
    property Forms[AIndex: Integer]: TABasicForm read GetForm;
    property FormCount: Integer read FFormCount;
    //#
    property CoreForm: TABasicForm read FCoreForm write FCoreForm;
(*============================================================================*)
    property OnDestroy: TOnEvent read FOnDestroy write FOnDestroy;
    property OnBeforeSetFocus: TOnEvent read FOnBeforeSetFocus write FOnBeforeSetFocus;
    property OnAfterSetFocus: TOnEvent read FOnAfterSetFocus write FOnAfterSetFocus;
    property OnBeforeReleaseFocus: TOnEvent read FOnBeforeReleaseFocus write FOnBeforeReleaseFocus;
    property OnAfterReleaseFocus: TOnEvent read FOnAfterReleaseFocus write FOnAfterReleaseFocus;
    property OnBeforeSetCapture: TOnEvent read FOnBeforeSetCapture write FOnBeforeSetCapture;
    property OnAfterSetCapture: TOnEvent read FOnAfterSetCapture write FOnAfterSetCapture;
    property OnBeforeReleaseCapture: TOnEvent read FOnBeforeReleaseCapture write FOnBeforeReleaseCapture;
    property OnAfterReleaseCapture: TOnEvent read FOnAfterReleaseCapture write FOnAfterReleaseCapture;
    property OnUpdateHover: TOnEvent read FOnUpdateHover write FOnUpdateHover;
  end;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;

//##############################################################################
//##                          instance functions                              ##
//##############################################################################

function SingleInstance(const ACaption: String): Boolean;
procedure ActivateInstance(const ACaption: String);

//##############################################################################
//##                       window animation functions                         ##
//##############################################################################

function GetAnimation: Boolean;
function SetAnimation(AAnimation: Boolean): Boolean;




                        //##############
                        //###  VAR   ###
                        //##############
                        Var
                        //######################################################
                        //##################### GLOBAL USED ####################

  Application: TAApplication;
  FormManager: TAFormManager;




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //############ BASE CLASS FOR APPLICATION ##############

  ApplicationWindowClass: TWndClass = (
            Style: CS_OWNDC;
            lpfnWndProc: @DefWindowProc;
            cbClsExtra: 0;
            cbWndExtra: 0;
            hInstance: 0;
            hIcon: 0;
            hCursor: 0;
            hbrBackground: 0;
            lpszMenuName: nil;
            lpszClassName: 'classAApplication');

                        //######################################################
                        //################ BASE CLASS FOR FORMS ################

  FormWindowClass: TWndClass = (
            Style: CS_DBLCLKS or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_OWNDC;
            lpfnWndProc: @DefWindowProc;
            cbClsExtra: 0;
            cbWndExtra: 0;
            hInstance: 0;
            hIcon: 0;
            hCursor: 0;
            hbrBackground: 0;
            lpszMenuName: nil;
            lpszClassName: 'classAForm');




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




//##############################################################################
//##                          instance functions                              ##
//##############################################################################

function SingleInstance(const ACaption: String): Boolean;
var Mutex: Cardinal;
begin
        Mutex:= HWindows.CreateMutex(nil, False, PChar(ACaption));

        Result:= (HWindows.GetLastError <> ERROR_ALREADY_EXISTS)and(Mutex <> 0);
end;


procedure ActivateInstance(const ACaption: String);
var AInstance: Cardinal;
begin
        AInstance:= HWindows.FindWindow(ApplicationWindowClass.lpszClassName, PChar(ACaption));

        if (AInstance <> 0) then
        begin
                case HWindows.IsIconic(AInstance) of
                  True:
                        (*--------------*)
                        (**) if (HWindows.IsIconic(AInstance)) then HWindows.PostMessage(AInstance, WM_SYSCOMMAND, SC_RESTORE, 0)
                        (*--------------*)
                  //
                  else HWindows.BringWindowToTop(AInstance)
                  //
                end;
        end;
end;

//##############################################################################
//##                       window animation functions                         ##
//##############################################################################

function GetAnimation: Boolean;
var Ani: TAnimationInfo;
begin
        Ani.cbSize:= SizeOf(TAnimationInfo);

        HWindows.SystemParametersInfo(SPI_GETANIMATION, SizeOf(Ani), @Ani, 0);

        Result:= Boolean(Ani.iMinAnimate);
end;


function SetAnimation(AAnimation: Boolean): Boolean;
var Ani: TAnimationInfo;
begin
        Result:= GetAnimation;

        Ani.cbSize:= SizeOf(TAnimationInfo);
        Ani.iMinAnimate:= Integer(AAnimation);

        HWindows.SystemParametersInfo(SPI_SETANIMATION, SizeOf(Ani), @Ani, 0);
end;




//##############################################################################
//##                                 APPLICATION                              ##
//##############################################################################


{ TAApplication }




constructor TAApplication.Create;
begin
        FInstance:= MainInstance;
        FThreadId:= MainThreadId;

        FHandle:= 0;
        FWindowProcInstance:= nil;

        FFileName:= PathExtractFileName(ParamStr(0));
        FFilePath:= PathExtract(ParamStr(0));

        FMinimized:= False;
        FTerminated:= False;
        FAllowTerminate:= True;
        FAllowMenu:= True;



        FHookList:= TAList.Create;
        FHookCount:= 0;
end;


destructor TAApplication.Destroy;
begin
        FreeNil(FHookList);



(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)

inherited;
end;


function TAApplication.GetCursorPos: TPoint;
begin
        Result:= Mouse.MessagePosition;
end;


procedure TAApplication.SetCursorPos(ACursorPos: TPoint);
begin
        Mouse.Position:= ACursorPos;
end;


procedure TAApplication.SetCaption(const ACaption: String);
var LockCount: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FCaption <> ACaption) then
        begin
                FCaption:= ACaption;


               {$IFDEF THREADSAFE}
                LockCount:= ThreadManager.ClearExclusive(GlobalLock.LockCount);
               {$ENDIF}
                HWindows.SetWindowText(FHandle, PChar(FCaption));
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive(LockCount);
              {$ENDIF}
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAApplication.SetAllowTerminate(AAllowTerminate: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAllowTerminate <> AAllowTerminate) then
        begin
                FAllowTerminate:= AAllowTerminate;


                UpdateMenu(True);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAApplication.SetAllowMenu(AAllowMenu: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAllowMenu <> AAllowMenu) then
        begin
                FAllowMenu:= AAllowMenu;


                UpdateMenu(True);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAApplication.WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer;
var Animation: Boolean;
begin
        case Msg of
          WM_CLOSE:
          begin
                // check allowterminate there.
                Terminate;

                // don't run the default wndproc because it will
                // destroy the window.
                Result:= 0;
                Exit;
          end;
          //
          WM_QUERYENDSESSION:
          if (not FAllowTerminate) then
          begin
                // don't run the default wndproc because it will
                // terminate the application.
                Result:= 0;
                Exit;
          end;
          //
          WM_SYSCOMMAND:
          begin
                Animation:= SetAnimation(False);

                case WParam of
                  SC_CLOSE: Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
                  //
                  SC_MINIMIZE:
                  begin
                        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
                        FMinimized:= True;
                        UpdateMenu(True);

                        (*--------------*)
                        (**) Application.SendMessage(HWND_BROADCAST, AM_APPLICATION_MINIMIZE, 0, 0);
                        (*--------------*)

                        (*==============*)
                        (**) if (Assigned(FOnMinimize)) then FOnMinimize(Self);
                        (*==============*)
                  end;
                  //
                  SC_RESTORE:
                  begin
                        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
                        FMinimized:= False;
                        UpdateMenu(True);

                        (*--------------*)
                        (**) Application.SendMessage(HWND_BROADCAST, AM_APPLICATION_RESTORE, 0, 0);
                        (*--------------*)

                        (*==============*)
                        (**) if (Assigned(FOnRestore)) then FOnRestore(Self);
                        (*==============*)

                        FormManager.SetFocus(FormManager.FCoreForm);
                  end;
                  //
                  else Result:= 0;
                end;

                SetAnimation(Animation);

                Exit;
          end;
          //
          // a menu is supposed to be shown.
          WM_REQUESTMENU:
          begin
                if (FAllowMenu) then Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam)
                else Result:= 0;

                (*--------------*)
                (**) Application.PostMessage(FHandle, WM_MOUSEMOVE, 0, 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = custommenu (bool)
                //   || LparamLo = X cursor screen position
                //   || LparamHi = Y cursor screen position
                (**) Application.SendMessage(HWND_BROADCAST, AM_APPLICATION_SHOW_MENU, Integer(FAllowMenu), LowHigh(Mouse.Position.X, Mouse.Position.Y));
                (*--------------*)

                (*==============*)
                (**) if (Assigned(FOnShowMenu)) then FOnShowMenu(Self);
                (*==============*)

                Exit;
          end;
          //
          WM_EXITMENULOOP:
          begin
                if (FAllowMenu) then Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam)
                else Result:= 0;

                (*--------------*)
                (**) Application.PostMessage(FHandle, WM_MOUSEMOVE, 0, 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = custommenu (bool)
                //   || LparamLo = X cursor screen position
                //   || LparamHi = Y cursor screen position
                (**) Application.SendMessage(HWND_BROADCAST, AM_APPLICATION_HIDE_MENU, Integer(FAllowMenu), LowHigh(Mouse.Position.X, Mouse.Position.Y));
                (*--------------*)

                (*==============*)
                (**) if (Assigned(FOnHideMenu)) then FOnHideMenu(Self);
                (*==============*)

                Exit;
          end;
          //
          WM_ACTIVATEAPP: if Boolean(WParam) then HWindows.SetForegroundWindow(FHandle);
          //
        end;


        // always pass the message to the default
        // window procedure (system handled).
        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam)
end;


function TAApplication.CreateHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FHandle = 0) then
        begin
                FWindowProcInstance:= MethodToProcedure(Self, @TAApplication.WindowProc);

                ApplicationWindowClass.hInstance:= FInstance;
                ApplicationWindowClass.hIcon:= LoadIcon(MainInstance, 'MAINICON');
                HWindows.RegisterClass(ApplicationWindowClass);

                FHandle:= HWindows.CreateWindowEx(
                           WS_EX_APPWINDOW,
                           ApplicationWindowClass.lpszClassName, PChar(FCaption),
                           WS_POPUP or WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX,
                           0, 0, 0, 0, 0, 0,
                           HInstance, nil);

                (*++++++++++++++*)
                (**) if (FHandle = 0) then RaiseException('Cannot create handle for application.', 'TAApplication.CreateHandle', Self, True);
                (*++++++++++++++*)

                // now we set the real WindowProc.
                HWindows.SetWindowLong(FHandle, GWL_WNDPROC, Integer(FWindowProcInstance));

                // set the priority a little bit higher.
                HWindows.SetThreadPriority(FThreadId, TP_HIGHER);

                UpdateMenu;
                Result:= (FHandle <> 0);
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAApplication.DestroyHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FHandle <> 0) then
        begin
                // free the handle and unregister the class
                // flush queue and kill timers.
                HWindows.DestroyWindow(FHandle);
                FHandle:= 0;

                FreeMem(FWindowProcInstance);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAApplication.Execute;
var AMsg: TMsg;
    i: Integer;

{$IFDEF USE_HOOKS}

    ARec: THookRec;

{$ENDIF}
{$IFDEF USE_FAST_PAINT}

    Rect: TRect;
    AForm: TABasicForm;

{$ENDIF}
begin
        CreateHandle;

        (*==============*)
        (**) if Assigned(FOnBeforeExecute) then FOnBeforeExecute;
        (*==============*)


        repeat
                try
                  if (FormManager.CoreForm = nil) then Terminate;


                  case Integer(HWindows.GetMessage(AMsg, 0, 0, 0)) of
                    GM_SUCCESS:
                    begin
                          HWindows.TranslateMessage(AMsg);
                          HWindows.DispatchMessage(AMsg);


                          {$IFDEF USE_HOOKS}
                            {$IFDEF THREADSAFE}
                             ThreadManager.SetExclusive;
                            {$ENDIF}

                                  for i:= 0 to FHookCount-1 do
                                  begin
                                          ARec:= PHookRec(FHookList.Items[i])^;

                                          if (AMsg.Message >= ARec.RangeMin)and
                                             (AMsg.Message <= ARec.RangeMax) then
                                                  ARec.Event(AMsg.HWnd, AMsg.Message, AMsg.WParam, AMsg.LParam, ARec.Id);
                                  end;

                            {$IFDEF THREADSAFE}
                             ThreadManager.ClearExclusive;
                            {$ENDIF}
                          {$ENDIF}


                          {$IFDEF USE_FAST_PAINT}
                            {$IFDEF THREADSAFE}
                             ThreadManager.SetExclusive;
                            {$ENDIF}

                                  for i:= 0 to FormManager.FFormCount-1 do
                                  begin
                                          AForm:= FormManager.Forms[i];

                                          if (not AForm.FFastPaint)and(HWindows.GetUpdateRect(AForm.FHandle, Rect, False)) then
                                          begin
                                                  AForm.FFastPaint:= True;

                                                  (*--------------*)
                                                  (**) Application.PostMessage(AForm.FHandle, CM_PAINT, 0, 0);
                                                  (*--------------*)
                                          end;
                                  end;

                            {$IFDEF THREADSAFE}
                             ThreadManager.ClearExclusive;
                            {$ENDIF}
                          {$ENDIF}

                          // run the hooktimer check procedure.
                          if Assigned(FOnHookTimer) then FOnHookTimer;
                    end;
                    //
                    GM_TERMINATE: FTerminated:= True;
                    //
                    GM_ERROR:
                          (*++++++++++++++*)
                          (**) RaiseException('Cannot getmessage.', 'Application.Execute', Self);
                          (*++++++++++++++*)
                    //
                  end;
                except
                  (*++++++++++++++*)
                  (**) HandleException('Application.Execute');
                  (*++++++++++++++*)
                end;
        until (FTerminated);


        (*==============*)
        (**) if Assigned(FOnAfterExecute) then FOnAfterExecute;
        (*==============*)

        DestroyHandle;
end;


procedure TAApplication.Execute(const ACaption: String);
begin
        SetCaption(ACaption);

        Execute;
end;


function TAApplication.Terminate: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // posting a message will wake the thread from a waitmessage instruction.
        if (FAllowTerminate) then
        begin
                Result:= True;

                (*--------------*)
                (**) if (not FTerminated) then Application.PostMessage(FHandle, WM_QUIT, 0, 0);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAApplication.UpdateMenu(ARecreateMenu: Boolean = False);
var ASysMenu: Cardinal;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAllowMenu) then
        begin
                if ARecreateMenu then HWindows.GetSystemMenu(FHandle, True);

                ASysMenu:= HWindows.GetSystemMenu(FHandle, False);
                HWindows.DeleteMenu(ASysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
                HWindows.DeleteMenu(ASysMenu, SC_SIZE, MF_BYCOMMAND);
                HWindows.DeleteMenu(ASysMenu, SC_MOVE, MF_BYCOMMAND);
                case FMinimized of
                  True: HWindows.DeleteMenu(ASysMenu, SC_MINIMIZE, MF_BYCOMMAND);
                  else HWindows.DeleteMenu(ASysMenu, SC_RESTORE, MF_BYCOMMAND);
                end;
                if (not FAllowTerminate) then HWindows.DeleteMenu(ASysMenu, SC_CLOSE, MF_BYCOMMAND);
        end;

        (*--------------*)
        //   || Wparam = custommenu (bool)
        //   || LparamLo = X cursor screen position
        //   || LparamHi = Y cursor screen position
        (**) Application.SendMessage(HWND_BROADCAST, AM_APPLICATION_UPDATE_MENU, Integer(FAllowMenu), LowHigh(Mouse.Position.X, Mouse.Position.Y));
        (*--------------*)

        (*==============*)
        (**) if (Assigned(FOnUpdateMenu)) then FOnUpdateMenu(Self);
        (*==============*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAApplication.PostMessage(AHandle: Cardinal; AMessage: TMessage);
begin
        (*--------------*)
        (**) HWindows.PostMessage(AHandle, AMessage.Msg, AMessage.WParam, AMessage.LParam);
        (*--------------*)
end;


procedure TAApplication.PostMessage(AHandle: Cardinal; AMsg, AWParam, ALParam: Integer);
var i: Integer;
begin
        case AHandle of
          HWND_BROADCAST:
          begin
                {$IFDEF THREADSAFE}
                 ThreadManager.SetExclusive;
                {$ENDIF}

                  for i:= 0 to FormManager.FormCount-1 do
                        (*--------------*)
                        (**) HWindows.PostMessage(FormManager.Forms[i].FHandle, AMsg, AWParam, ALParam);
                        (*--------------*)

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}
          end;
          //
          (*--------------*)
          (**) else HWindows.PostMessage(AHandle, AMsg, AWParam, ALParam)
          (*--------------*)
          //
        end;
end;


procedure TAApplication.SendMessage(AHandle: Cardinal; AMessage: TMessage);
begin
        (*--------------*)
        (**) HWindows.SendMessage(AHandle, AMessage.Msg, AMessage.WParam, AMessage.LParam);
        (*--------------*)
end;


procedure TAApplication.SendMessage(AHandle: Cardinal; AMsg, AWParam, ALParam: Integer);
var i: Integer;
begin
        case AHandle of
          HWND_BROADCAST:
          begin
                {$IFDEF THREADSAFE}
                 ThreadManager.SetExclusive;
                {$ENDIF}

                  for i:= 0 to FormManager.FormCount-1 do
                        (*--------------*)
                        (**) HWindows.SendMessage(FormManager.Forms[i].FHandle, AMsg, AWParam, ALParam);
                        (*--------------*)

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}
          end;
          //
          (*--------------*)
          (**) else HWindows.SendMessage(AHandle, AMsg, AWParam, ALParam)
          (*--------------*)
          //
        end;
end;


procedure TAApplication.FlushQueue(AHookTimer: Boolean = True);
var AMsg: TMsg;
    Tick: Cardinal;
    i: Integer;

{$IFDEF USE_HOOKS}

    ARec: THookRec;

{$ENDIF}
begin
        Tick:= HMultimedia.timeGetTime;


        while HWindows.PeekMessage(AMsg, 0, 0, 0, PM_REMOVE) do
        begin
                try
                  case AMsg.Message of
                    WM_QUIT:
                    begin
                          FTerminated:= True;

                          DestroyHandle;
                    end;
                    //
                    else begin
                          HWindows.TranslateMessage(AMsg);
                          HWindows.DispatchMessage(AMsg);


                          {$IFDEF USE_HOOKS}
                            {$IFDEF THREADSAFE}
                             ThreadManager.SetExclusive;
                            {$ENDIF}

                                  for i:= 0 to FHookCount-1 do
                                  begin
                                        ARec:= PHookRec(FHookList.Items[i])^;

                                        if (AMsg.Message >= ARec.RangeMin)and
                                           (AMsg.Message <= ARec.RangeMax) then
                                                ARec.Event(AMsg.HWnd, AMsg.Message, AMsg.WParam, AMsg.LParam, ARec.Id);
                                  end;

                            {$IFDEF THREADSAFE}
                             ThreadManager.ClearExclusive;
                            {$ENDIF}
                          {$ENDIF}


                          // fast paint does not need to be implemented here.


                          // run the hooktimer check procedure.
                          if (AHookTimer)and(Assigned(FOnHookTimer)) then FOnHookTimer;

                          if (AMsg.Time > Tick) then Break;
                    end;
                    //
                  end;
                except
                  (*++++++++++++++*)
                  (**) HandleException('Application.FlushQueue');
                  (*++++++++++++++*)
                end;
        end;
end;


procedure TAApplication.Minimize;
begin
        (*--------------*)
        (**) Application.PostMessage(FHandle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
        (*--------------*)
end;


procedure TAApplication.Restore;
begin
        (*--------------*)
        (**) Application.PostMessage(FHandle, WM_SYSCOMMAND, SC_RESTORE, 0);
        (*--------------*)
end;


procedure TAApplication.Surface;
begin
        HWindows.BringWindowToTop(FHandle);
end;


function TAApplication.AddHook(AEvent: THookEvent; AId: Integer; AMsgRange: Integer): Boolean;
begin
        case AMsgRange of
          HMR_MOUSE: Result:= AddHook(AEvent, AId, AM_MOUSE_FIRST, AM_MOUSE_LAST);
          //
          HMR_KEY: Result:= AddHook(AEvent, AId, AM_KEY_FIRST, AM_KEY_LAST);
          //
          HMR_TIMER: Result:= AddHook(AEvent, AId, WM_TIMER, WM_TIMER);
          //
          HMR_ALL: Result:= AddHook(AEvent, AId, WM_FIRST, AM_LAST);
          //
          else Result:= False;
          //
        end;
end;


function TAApplication.AddHook(AEvent: THookEvent; AId: Integer; ARangeMin, ARangeMax: Integer): Boolean;
var ARec: PHookRec;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

          if (AId > 0)and(FindHook(AId) = -1)and(Assigned(AEvent))and(ARangeMax >= ARangeMin) then
          begin
                GetMem(ARec, SizeOf(THookRec));
                ARec^.Event:= AEvent;
                ARec^.Id:= AId;
                ARec^.RangeMin:= ARangeMin;
                ARec^.RangeMax:= ARangeMax;

                FHookList.Add(ARec);
                Inc(FHookCount);
                Result:= True;
          end
          else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAApplication.RemoveHook(AId: Integer): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

          AIndex:= FindHook(AId);

          if (AId > 0)and(AIndex > -1) then
          begin
                FreeMem(FHookList.Items[AIndex]);

                FHookList.Delete(AIndex);
                Dec(FHookCount);
                Result:= True;
          end
          else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAApplication.FindHook(AId: Integer): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FHookCount)and(PHookRec(FHookList.Items[Result])^.Id <> AId) do
              Inc(Result);

        if (Result = FHookCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                BASICFORM                                 ##
//##############################################################################


{ TABasicForm }




constructor TABasicForm.Create(const AName: String; AWindowProcPointer: Pointer = nil);
begin
if (AWindowProcPointer = nil) then FWindowProcPointer:= @TABasicForm.WindowProc
else FWindowProcPointer:= AWindowProcPointer;

FName:= AName;



        FHandle:= 0;
        FDC:= 0;
        FWindowProcInstance:= nil;

        FLeft:= 0;
        FTop:= 0;
        FWidth:= 0;
        FHeight:= 0;

        FVisible:= False;
        FAlwaysOnTop:= False;
        FMenu:= False;
        FAllowHide:= True;



        FFastPaint:=  False;

        FButtonDown:= 0;



        CreateHandle;
        FormManager.AddForm(Self);
end;


destructor TABasicForm.Destroy;
begin
        FormManager.RemoveForm(Self);
        DestroyHandle;



(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)

inherited;
end;


function TABasicForm.GetCursorPos: TPoint;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= Mouse.MessagePosition;

        Dec(Result.X, FLeft);
        Dec(Result.Y, FTop);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.SetCursorPos(ACursorPos: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Inc(ACursorPos.X, FLeft);
        Inc(ACursorPos.Y, FTop);

        Mouse.Position:= ACursorPos;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.SetLeft(ALeft: Integer);
begin
        if (FLeft <> ALeft) then
                SetBounds(ALeft, FTop, FWidth, FHeight);
end;


procedure TABasicForm.SetTop(ATop: Integer);
begin
        if (FTop <> ATop) then
                SetBounds(FLeft, ATop, FWidth, FHeight);
end;



procedure TABasicForm.SetWidth(AWidth: Integer);
begin
        if (FWidth <> AWidth) then
                SetBounds(FLeft, FTop, AWidth, FHeight);
end;


procedure TABasicForm.SetHeight(AHeight: Integer);
begin
        if (FHeight <> AHeight) then
                SetBounds(FLeft, FTop, FWidth, AHeight);
end;


function TABasicForm.GetBounds: TARect;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        with Result do
        begin
                Left:= FLeft;
                Top:= FTop;
                Width:= FWidth;
                Height:= FHeight;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.SetVisible(AVisible: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FVisible <> (AVisible or (not FAllowHide))) then
        begin
                FVisible:= AVisible or (not FAllowHide);


                case (AVisible or (not FAllowHide)) of
                  True:
                  begin
                        HWindows.SetWindowPos(FHandle, 0, 0, 0, 0, 0, SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        Surface;
                        FormManager.SetFocus(Self);
                        Invalidate;

                        (*--------------*)
                        (**) Application.PostMessage(FHandle, CM_SHOW, 0, 0);
                        (*--------------*)
                  end;
                  //
                  else begin
                        HWindows.SetWindowPos(FHandle, 0, 0, 0, 0, 0, SWP_HIDEWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        FormManager.ReleaseFocus(Self);
                        FormManager.ReleaseCapture(Self);

                        FButtonDown:= 0;

                        // focus another window of the same application.
                        if (Self <> FormManager.FCoreForm) then FormManager.SetFocus(FormManager.FCoreForm);

                        (*--------------*)
                        (**) Application.PostMessage(FHandle, CM_HIDE, 0, 0);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.SetAlwaysOnTop(AAlwaysOnTop: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAlwaysOnTop <> AAlwaysOnTop) then
        begin
                FAlwaysOnTop:= AAlwaysOnTop;


                case FAlwaysOnTop of
                  True:
                  begin
                        HWindows.SetWindowPos(FHandle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        Surface;

                        (*--------------*)
                        (**) Application.PostMessage(FHandle, CM_SET_ALWAYSONTOP, 0, 0);
                        (*--------------*)
                  end;
                  //
                  else begin
                        HWindows.SetWindowPos(FHandle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_ASYNCWINDOWPOS);

                        (*--------------*)
                        (**) Application.PostMessage(FHandle, CM_RELEASE_ALWAYSONTOP, 0, 0);
                        (*--------------*)
                  end;
                  //
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TABasicForm.GetFocused: Boolean;
begin
        Result:= (FormManager.FocusedForm = Self);
end;


procedure TABasicForm.SetFocused(AFocused: Boolean);
begin
        case AFocused of
          True: FormManager.SetFocus(Self);
          else FormManager.ReleaseFocus(Self);
        end;
end;


function TABasicForm.GetCapture: Boolean;
begin
        Result:= (FormManager.CaptureForm = Self);
end;


procedure TABasicForm.SetCapture(ACapture: Boolean);
begin
        case ACapture of
          True: FormManager.SetCapture(Self);
          else FormManager.ReleaseCapture(Self);
        end;
end;


function TABasicForm.WindowProc(AHandle: Cardinal; Msg, WParam, LParam: Integer): Integer;
var OldHoverForm: TABasicForm;
begin
        case Msg of
          // do not allow menus to be hidden when the application is minimized.
          WM_SHOWWINDOW:
          begin
                  if (FMenu)and((LParam = SW_PARENTCLOSING)or(LParam = SW_PARENTOPENING)) then
                  begin
                        Result:= 0;
                        Exit;
                  end;
          end;
          //
          // on a core window we want to close the application,
          // else we want to hide the window.
          WM_CLOSE:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                if (FAllowHide) then
                begin
                        // check allowterminate there.
                        if (Self = FormManager.CoreForm) then Application.Terminate
                        else Hide;
                end;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}

              // don't run the default wndproc because it
              // will destroy the window.
              Result:= 0;
              Exit;
          end;
          //
          WM_CAPTURECHANGED: FormManager.ReleaseCapture(Self, True);
          //
          WM_ACTIVATE:
          begin
                case WParam of
                  WA_INACTIVE: FormManager.ReleaseFocus(Self, True);
                  WA_ACTIVE, WA_CLICKACTIVE: FormManager.SetFocus(Self, True);
                end;
          end;
          //
          WM_SETFOCUS: FormManager.SetFocus(Self, True);
          //
          WM_KILLFOCUS: FormManager.ReleaseFocus(Self, True);
          //
          WM_PAINT, CM_PAINT:
          begin
                // run the default wndproc so the area is validated and the
                // WM_PAINT is erased from the message queue.
                Result:= DefWindowProc(AHandle, WM_PAINT, DC, LParam);

                FFastPaint:= False;

                Exit;
          end;
          //
          WM_MOUSEMOVE:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                if (FormManager.FHoverForm <> Self) then
                begin
                        FMouseTrack.cbSize:= SizeOf(TTrackMouseEvent);
                        FMouseTrack.dwFlags:= TME_HOVER or TME_LEAVE;
                        FMouseTrack.hwndTrack:= FHandle;
                        FMouseTrack.dwHoverTime:= HOVER_DEFAULT;
                        HWindows.TrackMouseEvent(FMouseTrack);

                        OldHoverForm:= FormManager.FHoverForm;
                        FormManager.FHoverForm:= Self;

                        (*--------------*)
                        (**) if (OldHoverForm <> nil) then Application.SendMessage(OldHoverForm.FHandle, CM_MOUSE_LEAVE, 0, 0);
                        (*--------------*)

                        (*--------------*)
                        //   || Wparam = old hover form (object)
                        (**) Application.SendMessage(FHandle, CM_MOUSE_ENTER, Integer(OldHoverForm), 0);
                        (*--------------*)

                        (*--------------*)
                        //   || Wparam = new hover form (object)
                        //   || Lparam = old hover form (object)
                        (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_UPDATE_HOVER, Integer(Self), Integer(OldHoverForm));
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FormManager.OnUpdateHover) then FormManager.OnUpdateHover(FormManager);
                        (*==============*)
                end;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          WM_MOUSELEAVE:
          begin
              {$IFDEF THREADSAFE}
               ThreadManager.SetExclusive;
              {$ENDIF}

                if (FormManager.FHoverForm = Self) then
                begin
                        FMouseTrack.cbSize:= SizeOf(TTrackMouseEvent);
                        FMouseTrack.dwFlags:= TME_HOVER or TME_LEAVE;
                        FMouseTrack.hwndTrack:= FHandle;
                        FMouseTrack.dwHoverTime:= HOVER_DEFAULT;
                        HWindows.TrackMouseEvent(FMouseTrack);

                        FormManager.FHoverForm:= nil;

                        (*--------------*)
                        (**) Application.SendMessage(FHandle, CM_MOUSE_LEAVE, 0, 0);
                        (*--------------*)

                        (*--------------*)
                        //   || Wparam = new hover form (object)
                        //   || Lparam = old hover form (object)
                        (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_UPDATE_HOVER, 0, Integer(Self));
                        (*--------------*)

                        (*==============*)
                        (**) if Assigned(FormManager.OnUpdateHover) then FormManager.OnUpdateHover(FormManager);
                        (*==============*)
                end;

              {$IFDEF THREADSAFE}
               ThreadManager.ClearExclusive;
              {$ENDIF}
          end;
          //
          AM_MOUSE_DOWNL: FButtonDown:= FButtonDown or MB_LEFT;
          AM_MOUSE_DOWNM: FButtonDown:= FButtonDown or MB_MIDDLE;
          AM_MOUSE_DOWNR: FButtonDown:= FButtonDown or MB_RIGHT;
          //
          AM_MOUSE_UPL:
          begin
                 (*--------------*)
                 (**) if (FButtonDown and MB_LEFT <> 0) then Application.SendMessage(FHandle, AM_MOUSE_CLICKL, WParam, LParam);
                 (**) FButtonDown:= FButtonDown and (not MB_LEFT);
                 (*--------------*)
          end;
          //
          AM_MOUSE_UPM:
          begin
                 (*--------------*)
                 (**) if (FButtonDown and MB_MIDDLE <> 0) then Application.SendMessage(FHandle, AM_MOUSE_CLICKM, WParam, LParam);
                 (**) FButtonDown:= FButtonDown and (not MB_MIDDLE);
                 (*--------------*)
          end;
          //
          AM_MOUSE_UPR:
          begin
                 (*--------------*)
                 (**) if (FButtonDown and MB_RIGHT <> 0) then Application.SendMessage(FHandle, AM_MOUSE_CLICKR, WParam, LParam);
                 (**) FButtonDown:= FButtonDown and (not MB_RIGHT);
                 (*--------------*)
          end;
          //
        end;


        // always pass the message to the default
        // window procedure (system handled).
        Result:= HWindows.DefWindowProc(FHandle, Msg, WParam, LParam);
end;


function TABasicForm.CreateHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FHandle = 0) then
        begin
                FWindowProcInstance:= MethodToProcedure(Self, FWindowProcPointer);

                FormWindowClass.hInstance:= Application.Instance;
                FormWindowClass.lpszClassName:= PChar('classAForm | ' + FName);
                HWindows.RegisterClass(FormWindowClass);

                FHandle:= HWindows.CreateWindow(
                          FormWindowClass.lpszClassName, PChar(FName),
                          WS_POPUP,
                          FLeft, FTop, FWidth, FHeight,
                          Application.FHandle, 0, HInstance, nil);

                (*++++++++++++++*)
                (**) if (FHandle = 0) then RaiseException('Cannot create handle for form "' + FName + '".', 'TABasicForm.CreateHandle', Self, True);
                (*++++++++++++++*)

                // now we set the real WindowProc.
                HWindows.SetWindowLong(FHandle, GWL_WNDPROC, Integer(FWindowProcInstance));

                // get the dc.
                FDC:= HWindows.GetDC(FHandle);

                // set the default cursor.
                HWindows.SetCursor(LoadCursor(0, IDC_ARROW));

                // set the window to recive hover and leave notifications.
                FMouseTrack.cbSize:= SizeOf(TTrackMouseEvent);
                FMouseTrack.dwFlags:= TME_LEAVE;
                FMouseTrack.hwndTrack:= FHandle;
                FMouseTrack.dwHoverTime:= HOVER_DEFAULT;
                HWindows.TrackMouseEvent(FMouseTrack);
                Result:= (FHandle <> 0);

                (*--------------*)
                (**) Application.SendMessage(FHandle, AM_CREATE_HANDLE, 0, 0);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TABasicForm.DestroyHandle: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FHandle <> 0) then
        begin
                (*--------------*)
                (**) Application.SendMessage(FHandle, AM_DESTROY_HANDLE, 0, 0);
                (*--------------*)

                // free the DC.
                HWindows.ReleaseDC(FHandle,FDC);

                // free the handle and unregister the class
                // flush queue and kill timers.
                HWindows.DestroyWindow(FHandle);
                FHandle:= 0;

                FreeMem(FWindowProcInstance);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.ScreenToClient(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Dec(P.X, FLeft);
        Dec(P.Y, FTop);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.ClientToScreen(var P: TPoint);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Inc(P.X, FLeft);
        Inc(P.Y, FTop);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TABasicForm.SetBounds(ALeft, ATop, AWidth, AHeight: Integer): Integer;
var OLeft, OTop, OWidth, OHeight: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= SB_NONE;

        if (ALeft <> FLeft)or(ATop <> FTop)or(AWidth <> FWidth)or(AHeight <> FHeight) then
        begin
                HWindows.SetWindowPos(FHandle, 0, ALeft, ATop, AWidth, AHeight, SWP_NOACTIVATE or SWP_NOZORDER or SWP_ASYNCWINDOWPOS);

                if (ALeft <> FLeft)or(ATop <> FTop) then Result:= SB_MOVE;

                if (AWidth <> FWidth)or(AHeight <> FHeight) then Result:= Result or SB_SIZE;

                OLeft:= FLeft;
                OTop:= FTop;
                OWidth:= FWidth;
                OHeight:= FHeight;
                FLeft:= ALeft;
                FTop:= ATop;
                FWidth:= AWidth;
                FHeight:= AHeight;

                (*--------------*)
                (**) Application.SendMessage(FHandle, CM_BOUNDS_CHANGE, 0, 0);
                (*--------------*)

                (*--------------*)
                //   || WparamLo = by X
                //   || WparamHi = by Y
                //   || LparamLo = from X
                //   || LparamHi = from Y
                (**) if (Result and SB_MOVE <> 0) then Application.SendMessage(FHandle, CM_MOVE, LowHigh(FLeft-OLeft, FTop-OTop), LowHigh(OLeft, OTop));
                (*--------------*)

                (*--------------*)
                //   || WparamLo = by X
                //   || WparamHi = by Y
                //   || LparamLo = from X
                //   || LparamHi = from Y
                (**) if (Result and SB_SIZE <> 0) then Application.SendMessage(FHandle, CM_SIZE, LowHigh(FWidth-OWidth, FHeight-OHeight), LowHigh(OWidth, OHeight));
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TABasicForm.SetBounds(ARect: TARect): Integer;
begin
        with ARect do Result:= SetBounds(Left, Top, Width, Height);
end;


function TABasicForm.Move(ALeft, ATop: Integer): Boolean;
begin
        Result:= (SetBounds(ALeft, ATop, FWidth, FHeight) and SB_MOVE <> 0);
end;


function TABasicForm.Size(AWidth, AHeight: Integer): Boolean;
begin
        Result:= (SetBounds(FLeft, FTop, AWidth, AHeight) and SB_SIZE <> 0);
end;


procedure TABasicForm.Invalidate;
begin
        HWindows.InvalidateRect(FHandle, nil, False);
end;


procedure TABasicForm.Invalidate(ARect: TRect);
begin
        HWindows.InvalidateRect(FHandle, @ARect, False);
end;


procedure TABasicForm.Update;
begin
        HWindows.UpdateWindow(FHandle);
end;


procedure TABasicForm.Show;
begin
        SetVisible(True);
end;


function TABasicForm.Hide: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SetVisible(False);


        Result:= not FVisible;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TABasicForm.Surface;
begin
        HWindows.BringWindowToTop(FHandle);
end;




//##############################################################################
//##                              FORMMANAGER                                 ##
//##############################################################################


{ TAFormManager }




constructor TAFormManager.Create;
begin



        FFormList:= TAList.Create;
        FFormCount:= 0;
end;


destructor TAFormManager.Destroy;
begin
        // free remaining forms.
        while (FFormCount > 0) do TABasicForm(FFormList.Items[0]).Free;

        FreeNil(FFormList);



(*==============*)
(**) if Assigned(FOnDestroy) then FOnDestroy(Self);
(*==============*)

inherited;
end;


function TAFormManager.GetForm(AIndex: Integer): TABasicForm;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FFormCount) then Result:= TABasicForm(FFormList.Items[AIndex])
        else begin
                Result:= nil;

                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getform index out of bounds. Request ' + IntToStr(AIndex) + ', count ' + IntToStr(FFormCount) + '.', 'TAFormManager.GetForm', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.SetFocus(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
var OldFocus: TABasicForm;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AForm <> nil)and(FFocusedForm <> AForm)and(AForm.FVisible)and
           ((not Application.Minimized)or(AForm.FMenu)) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeSetFocus) then FOnBeforeSetFocus(Self);
                (*==============*)

                OldFocus:= FFocusedForm;
                ReleaseFocus(FFocusedForm, SystemSent);
                FFocusedForm:= AForm;

                if (not SystemSent) then Result:= Boolean(HWindows.SetFocus(FFocusedForm.FHandle))
                else Result:= True;

                (*--------------*)
                //   || Wparam = old focused form (object)
                (**) Application.SendMessage(AForm.Handle, CM_SET_FOCUS, Integer(OldFocus), 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = new focus form (object)
                //   || Lparam = old focus form (object)
                (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_SET_FOCUS, Integer(FFocusedForm), Integer(OldFocus));
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnAfterSetFocus) then FOnAfterSetFocus(Self);
                (*==============*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.ReleaseFocus(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AForm <> nil)and(AForm = FFocusedForm) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeReleaseFocus) then FOnBeforeReleaseFocus(Self);
                (*==============*)

                FFocusedForm:= nil;

                if (not SystemSent) then Result:= Boolean(HWindows.SetFocus(0))
                else Result:= True;

                (*--------------*)
                (**) Application.SendMessage(AForm.Handle, CM_RELEASE_FOCUS, 0, 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = old focus form (object)
                (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_RELEASE_FOCUS, Integer(AForm), 0);
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnAfterReleaseFocus) then FOnAfterReleaseFocus(Self);
                (*==============*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.SetCapture(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
var OldCapture: TABasicForm;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AForm <> nil)and(FCaptureForm <> AForm)and(AForm.FVisible)and
           ((not Application.Minimized)or(AForm.FMenu)) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeSetCapture) then FOnBeforeSetCapture(Self);
                (*==============*)

                OldCapture:= FCaptureForm;
                ReleaseCapture(FCaptureForm, SystemSent);
                FCaptureForm:= AForm;

                if (not SystemSent) then Result:= Boolean(HWindows.SetCapture(FCaptureForm.FHandle))
                else Result:= True;

                (*--------------*)
                //   || Wparam = old capture form (object)
                (**) Application.SendMessage(AForm.Handle, CM_SET_CAPTURE, Integer(OldCapture), 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = new capture form (object)
                //   || Lparam = old capture form (object)
                (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_SET_CAPTURE, Integer(FCaptureForm), Integer(OldCapture));
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnAfterSetCapture) then FOnAfterSetCapture(Self);
                (*==============*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.ReleaseCapture(AForm: TABasicForm; SystemSent: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AForm <> nil)and(AForm = FCaptureForm) then
        begin
                (*==============*)
                (**) if Assigned(FOnBeforeReleaseCapture) then FOnBeforeReleaseCapture(Self);
                (*==============*)

                FCaptureForm:= nil;

                if (not SystemSent) then Result:= HWindows.ReleaseCapture
                else Result:= True;

                (*--------------*)
                (**) Application.SendMessage(AForm.Handle, CM_RELEASE_CAPTURE, 0, 0);
                (*--------------*)

                (*--------------*)
                //   || Wparam = old capture form (object)
                (**) Application.SendMessage(HWND_BROADCAST, AM_FORMMANAGER_RELEASE_CAPTURE, Integer(AForm), 0);
                (*--------------*)

                (*==============*)
                (**) if Assigned(FOnAfterReleaseCapture) then FOnAfterReleaseCapture(Self);
                (*==============*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.AddForm(AForm: TABasicForm): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AForm <> nil) then
        begin
                AIndex:= FindForm(AForm.FName);

                if (AIndex = -1) then
                begin
                        FFormList.Add(AForm);
                        Inc(FFormCount);
                        Result:= True;

                        if (FCoreForm = nil) then FCoreForm:= AForm;                        
                end
                else begin
                        Result:= False;

                        {$IFDEF THREADSAFE}
                         ThreadManager.ClearExclusive;
                        {$ENDIF}

                        (*++++++++++++++*)
                        (**) RaiseException('Form "' + AForm.FName + '" name not unique.', 'FormManager.AddForm', Self, True)
                        (*++++++++++++++*)
                end;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.RemoveForm(AForm: TABasicForm): Boolean;
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindForm(AForm.FHandle);

        if (AForm <> nil)and(AIndex > -1) then
        begin
                FFormList.Delete(AIndex);
                Dec(FFormCount);
                Result:= True;
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.FindForm(AHandle: Cardinal): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FFormCount)and
              (TABasicForm(FFormList.Items[Result]).FHandle <> AHandle) do
              Inc(Result);

        if (Result = FFormCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAFormManager.FindForm(const AName: String): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FFormCount)and
              (not StringEqual(TABasicForm(FFormList.Items[Result]).FName, AName, False)) do
              Inc(Result);

        if (Result = FFormCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
        try
          Application:= TAApplication.Create;
          FormManager:= TAFormManager.Create;
        except
          (*++++++++++++++*)
          (**) HandleException('UCore intialization');
          (*++++++++++++++*)
        end;
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
        try
          FreeNil(FormManager);
          FreeNil(Application);
        except
          (*++++++++++++++*)
          (**) HandleException('UCore finalization');
          (*++++++++++++++*)
        end;
end;

//##############################################################################
//##############################################################################

End.
