(*==============*)
        // AN EVENT IS RAN
(*--------------*)
        // A MESSAGE IS POSTED OR SENT
(*++++++++++++++*)
        // AN EXCEPTION IS RAISED




// v3.0
//##############################################################################
//#######                             EXTENDED                            ######
//##############################################################################




        (*
          DEFINE THREADSAFE TO MAKE ALL THE OBJECTS THREADSAFE.
          || TAScrollControl
          || TAScroll
          || TAEditbox
          || TAListbox
          || TAMenu
        *)
        {$DEFINE THREADSAFE}


//##############################################################################
//#######                             EXTENDED                            ######
//##############################################################################
Unit UExtended;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,
                                                  HMessages,
                                                  HMultimedia,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine,
                                                  ADevices,
                                                  UCore,
                                                  UBasic,
                                                  UPrimitives,

                        //######################################################
                        //######################### FOOT #######################
                                                  Foot;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //################### TIMER CONSTANTS ##################

  TID_FIRST_EXTENDED = TID_LAST_PRIMITIVES + 1;
  TID_LAST_EXTENDED  = TID_FIRST_EXTENDED + 4;

                        //######################################################
                        //################ ANIMATION TIMERS  ###################

    TID_LEFTSCROLL_SMOOTH     = TID_FIRST_EXTENDED + 1;
    TID_TOPSCROLL_SMOOTH      = TID_FIRST_EXTENDED + 2;
    //
    TID_CARET                 = TID_FIRST_EXTENDED + 3;

                        //######################################################
                        //################## MESSAGE CONSTANTS #################

  AM_FIRST_EXTENDED = AM_LAST_PRIMITIVES + 1;
  AM_LAST_EXTENDED  = AM_FIRST_EXTENDED + 10;

                        //######################################################
                        //################### LAYER MESSAGES ###################

    AM_SCROLL_START                   = AM_TRACK_START;
    AM_SCROLL_STOP                    = AM_TRACK_STOP;
    AM_SCROLL_CHANGE                  = AM_TRACK_CHANGE;
    //
    AM_LEFTSCROLL_START               = AM_FIRST_EXTENDED + 1;
    AM_LEFTSCROLL_STOP                = AM_FIRST_EXTENDED + 2;
    AM_TOPSCROLL_START                = AM_FIRST_EXTENDED + 3;
    AM_TOPSCROLL_STOP                 = AM_FIRST_EXTENDED + 4;
    AM_LEFTSCROLL_CHANGE              = AM_FIRST_EXTENDED + 5;
    AM_TOPSCROLL_CHANGE               = AM_FIRST_EXTENDED + 6;
    //
    AM_CHANGE                         = AM_FIRST_EXTENDED + 7;
    //
    AM_UPDATE_CARET                   = AM_FIRST_EXTENDED + 8;
    //
    AM_UPDATE_INDEX                   = AM_FIRST_EXTENDED + 9;

                        //######################################################
                        //#################### SCROLL TYPES ####################

  ST_PUSH            = 4;
  ST_TOGGLE          = 8;
  ST_FRAMED_FORWARD  = 16;
  ST_FRAMED_CIRCULAR = 32;
  ST_FRAMED_ALL      = 48;

                        //######################################################
                        //############### SCROLL ANIMATION TYPES ###############

  SAT_STATE_FADE              = 1;
  SAT_FRAME_FADE              = 2;
  //#
  // animation repeaters
  SATR_FRAME_CIRCULAR          = 4;
  SATR_FRAME_FLIPFLOP          = 8;
  SATR_FRAME_FORWARD           = 0;
  SATR_FRAME_ALL               = 12;
  //#
  // animation triggers
  SATT_FRAME_HOVER             = 32;
  SATT_FRAME_DOWN              = 64;
  SATT_FRAME_HOVERDOWN         = 96;
  SATT_FRAME_ACTIVE            = 128;
  SATT_FRAME_ALL               = 224;

                        //######################################################
                        //##################### SCROLL STATES ##################

  SSP_UP         = 0;
  SSP_HOVER      = 1;
  SSP_DOWN       = 2;
  SSP_DISABLED   = 3;
  //#
  // toggle trackbar states
  SST_ACTIVE_UP         = 0;
  SST_ACTIVE_HOVER      = 1;
  SST_ACTIVE_DOWN       = 2;
  SST_ACTIVE_DISABLED   = 3;
  SST_INACTIVE_UP       = 4;
  SST_INACTIVE_HOVER    = 5;
  SST_INACTIVE_DOWN     = 6;
  SST_INACTIVE_DISABLED = 7;

                        //######################################################
                        //################### EDITBOX TYPES ####################

  EBT_NORMAL          = 0;
  //#
  EBT_PASSWORD        = 1;
  EBT_NUMBER          = 2;
  EBT_SELECT          = 4;

                        //######################################################
                        //################### LISTBOX TYPES ####################

  LBT_NORMAL             = 0;
  //#
  LBT_TEXT_ITEMHEIGHT    = 1;
  LBT_FOOT_ITEMHEIGHT    = 2;
  LBT_CONTROL_ITEMHEIGHT = 4;
  LBT_MAX_ITEMHEIGHT     = 7;
  //#
  LBT_RESTRICT           = 8;
  LBT_MULTILINE          = 16;

                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //########### SCROLLCONTROL ANIMATION STRUCT ###########

  TScrollRec = record
    SmoothLeft,
    SmoothLeftInc,
    SmoothTop,
    SmoothTopInc: Extended;
    //#
    TimeOutLeft,
    TimeOutTop: Integer;
  end;

                        //######################################################
                        //####################### LISTBOX ITEM #################

  TListboxItem = record
    Text: String;
    TextOffset: Integer;
    Foot: TFoot;
    FootOffset: Integer;
    Control: TAControl;
    ControlOffset: Integer;
    //#
    Font,
    FontSel: String;
  end;

  PListboxItem = ^TListboxItem;

                        //######################################################
                        //####################### CLASS TYPES ##################

  TAScroll = class;
  //#
  TAScrollControl = class;
  //#
  TAEditbox = class;
  TAListbox = class;
  TAMenu = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                SCROLLBAR                                 ##
//##############################################################################




  TAScroll = class(TATrack)
  protected
    FScrollControl: TAScrollControl;
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    property StateFadeAnimating;
    property StateFadeAnimationRec;
    property FrameAnimating;
    property FrameAnimationRec;
    property FrameFadeAnimating;
    property FrameFadeAnimationRec;
    property Scrolling: Boolean read FTracking;
    property ScrollRec: TTrackRec read FTrackRec;
    //#
    property State;
    property StateCount;
    property Frame;
    property FrameCount;
    //#
    property AnimationType;
    property Active;
    property Disabled;
    property RepeatWait;
    property RepeatInt;
    //#
    property ScrollControl: TAScrollControl read FScrollControl;
    property MinValue;
    property MaxValue;
    property Value;
    //#
    //#
    // properties that can be set only when loading the control.
    property ScrollWidth: Integer read FButtonWidth;
    property ScrollHeight: Integer read FButtonHeight;
    property ScrollBuffer: TFoot read FButtonBuffer;
    //#
    property ScrollType: Integer read FStateCount;
    property FrameOrientation;
    property Orientation;
(*============================================================================*)
    property OnStateFadeAnimationStart;
    property OnStateFadeAnimating;
    property OnStateFadeAnimationStop;
    property OnFrameAnimationStart;
    property OnFrameAnimating;
    property OnFrameAnimationStop;
    property OnFrameFadeAnimationStart;
    property OnFrameFadeAnimating;
    property OnFrameFadeAnimationStop;
    //#
    property OnPush;
    property OnActiveChange;
    property OnDisabledChange;
    //#
    property OnScrollStart: TOnEvent read FOnTrackStart write FOnTrackStart;
    property OnScrolling: TOnEvent read FOnTracking write FOnTracking;
    property OnScrollStop: TOnEvent read FOnTrackStop write FOnTrackStop;
    property OnScrollChange: TOnEvent read FOnTrackChange write FOnTrackChange;
  end;




//##############################################################################
//##                              SCROLLCONTROL                               ##
//##############################################################################




  // THE INHERITED CONTROLS SHOULD HAVE LOAD FUNCTIONS THAT CAN SET THE TIMEOUTS.

  TAScrollControl = class(TAControl)
  protected
    FLeftScrolling,
    FTopScrolling: Boolean;
    FScrollRec: TScrollRec;
    //#
    FLeftScroll,
    FTopScroll,
    FWidthScroll,
    FHeightScroll: Integer;
    // how many times increase smooth speed.
    FCountLeft,
    FCountTop: Integer;
    //#
    FH,
    FV: TAScroll;
    //#
    //#
    // used to determine the speed of the scroll.
    FLastLeft,
    FLastTop: Integer;
(*============================================================================*)
    FOnLeftScrollStart,                 //# RAN ON MESSAGE
    FOnLeftScrolling,                   //# RAN ON MESSAGE
    FOnLeftScrollStop,                  //# RAN ON MESSAGE
    FOnTopScrollStart,                  //# RAN ON MESSAGE
    FOnTopScrolling,                    //# RAN ON MESSAGE
    FOnTopScrollStop,                   //# RAN ON MESSAGE
    FOnLeftScrollChange,                //# RAN ON MESSAGE
    FOnTopScrollChange: TOnEvent;       //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetLeftScroll(ALeftScroll: Integer);
    procedure SetTopScroll(ATopScroll: Integer);
    procedure SetWidthScroll(AWidthScroll: Integer);
    procedure SetHeightScroll(AHeightScroll: Integer);
    //#
    procedure SetH(AH: TAScroll);
    procedure SetV(AV: TAScroll);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure UpdateSmoothInc;
    //#
    function StartLeftScroll: Boolean;
    function StopLeftScroll: Boolean;
    function StartTopScroll: Boolean;
    function StopTopScroll: Boolean;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    property H: TAScroll read FH write SetH;
    property V: TAScroll read FV write SetV;
    //#
    //#
    // properties that should be set by the inherited controls.
    property LeftScrolling: Boolean read FLeftScrolling;
    property TopScrolling: Boolean read FTopScrolling;
    //#
    property LeftScroll: Integer read FLeftScroll write SetLeftScroll;
    property TopScroll: Integer read FTopScroll write SetTopScroll;
    property WidthScroll: Integer read FWidthScroll;
    property HeightScroll: Integer read FHeightScroll;
    property CountLeft: Integer read FCountLeft;
    property CountTop: Integer read FCountTop;
(*============================================================================*)
    property OnLeftScrollStart: TOnEvent read FOnLeftScrollStart write FOnLeftScrollStart;
    property OnLeftScrolling: TOnEvent read FOnLeftScrolling write FOnLeftScrolling;
    property OnLeftScrollStop: TOnEvent read FOnLeftScrollStop write FOnLeftScrollStop;
    property OnTopScrollStart: TOnEvent read FOnTopScrollStart write FOnTopScrollStart;
    property OnTopScrolling: TOnEvent read FOnTopScrolling write FOnTopScrolling;
    property OnTopScrollStop: TOnEvent read FOnTopScrollStop write FOnTopScrollStop;
    property OnLeftScrollChange: TOnEvent read FOnLeftScrollChange write FOnLeftScrollChange;
    property OnTopScrollChange: TOnEvent read FOnTopScrollChange write FOnTopScrollChange;
  end;




//##############################################################################
//##                                 EDITBOX                                  ##
//##############################################################################




  TAEditbox = class(TAScrollControl)
  protected
    FCaret: Integer;
    FSelStart,
    FSelEnd: Integer;
    //#
    // normal, password, number.
    FEditboxType: Integer;
    FDisabled: Boolean;
    FText: String;
    //#
    //#
    FFont,
    FFontSel: String;
    //#
    //#
    // used to determine if the caret has blinked.
    FBlink: Boolean;
    //#
    // setting selection with the mouse.
    FSetting: Boolean;
    //#
    // used for password text.
    FRealText: String;
(*============================================================================*)
    FOnChange: TOnEvent;                //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    procedure SetCursorDef(ACursorDef: Integer); override;    
    //#
    procedure SetEditboxType(AEditboxType: Integer);
    procedure SetDisabled(ADisabled: Boolean);
    procedure SetText(const AText: String);
    procedure SetCaret(ACaret: Integer);
    procedure SetSelStart(ASelStart: Integer);
    procedure SetSelEnd(ASelEnd: Integer);
    //#
    // returns the width of the text to the caret.
    function GetCaret(ACaret: Integer): Integer;
    // returns the index of the char to the position ax.
    function GetIndex(AX: Integer): Integer;
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateCaret;
    procedure UpdateEdit;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // BT_RESIZE will be excluded from buffertype.
    procedure Load(const AFont, AFontSel: String; ACount, ATimeOut: Integer);
    procedure UnLoad;
    //#
    //#
    property EditboxType: Integer read FEditboxType write SetEditboxType;
    property Disabled: Boolean read FDisabled write SetDisabled;
    property Text: String read FText write SetText;
    property Caret: Integer read FCaret write SetCaret;
    property SelStart: Integer read FSelStart write SetSelStart;
    property SetEnd: Integer read FSelEnd write SetSelEnd;
    //#
    // properties that can be set only when loading the control.
    property Font: String read FFont;
    property FontSel: String read FFontSel;
(*============================================================================*)
    property OnChange: TOnEvent read FOnChange write FOnChange;
  end;




//##############################################################################
//##                                 LISTBOX                                  ##
//##############################################################################




  // CONTROLS ADDED TO THE LIST SHOULD NOT MOVE, CHANGE PARENT, VISIBILITY
  // OR BE FREED WHILE IN THE LIST.

  TAListbox = class(TAScrollControl)
  protected
    FList: TAList;
    FCount: Integer;
    //#
    FListboxType: Integer;
    FDisabled: Boolean;
    FIndex: Integer;
(*============================================================================*)
    FOnChange: TOnEvent;                //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    //#
    function GetItem(AIndex: Integer): TListboxItem;
    procedure SetItem(AIndex: Integer; AItem: TListboxItem);
    //#
    procedure SetListboxType(AListboxType: Integer);
    procedure SetDisabled(ADisabled: Boolean);
    procedure SetIndex(AIndex: Integer);
    function GetTopIndex: Integer;
    procedure SetTopIndex(AIndex: Integer);
    function GetBottomIndex: Integer;
    procedure SetBottomIndex(AIndex: Integer);
    //#
    // returns the index of the item at the position ax.
    function GetIndex(AX: Integer): Integer;
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateIndex;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // BT_RESIZE will be included from buffertype.
    procedure Load(ACountLeft, ACountTop, ATimeOutLeft, ATimeOutTop: Integer);
    procedure UnLoad;
    //#
    //#
    property Items[AIndex: Integer]: TListboxItem read GetItem write SetItem;
    property ItemCount: Integer read FCount;
    //#
    procedure AddItem(const AFont, AFontSel, AText: String; ATextOffset: Integer = 0); overload;
    procedure AddItem(const AFont, AFontSel, AText: String; AFoot: TFoot; ATextOffset: Integer = 0; AFootOffset: Integer = 0); overload;
    procedure AddItem(const AFont, AFontSel, AText: String; AControl: TAControl; ATextOffset: Integer = 0; AControlOffset: Integer = 0); overload;
    procedure AddItem(const AFont, AFontSel, AText: String; AFoot: TFoot; AControl: TAControl; ATextOffset: Integer = 0; AFootOffset: Integer = 0; AControlOffset: Integer = 0); overload;
    procedure InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; ATextOffset: Integer = 0); overload;
    procedure InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AFoot: TFoot; ATextOffset: Integer = 0; AFootOffset: Integer = 0); overload;
    procedure InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AControl: TAControl; ATextOffset: Integer = 0; AControlOffset: Integer = 0); overload;
    procedure InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AFoot: TFoot; AControl: TAControl; ATextOffset: Integer = 0; AFootOffset: Integer = 0; AControlOffset: Integer = 0); overload;
    procedure RemoveItem(AIndex: Integer);
    procedure Clear;
    //#
    function FindItem(const AText: String; AControl: TAControl; ACaseSensitive: Boolean = True): Integer; overload;
    function FindItem(const AText: String; ACaseSensitive: Boolean = True): Integer; overload;
    function FindItem(AControl: TAControl): Integer; overload;
    //#
    property ListboxType: Integer read FListboxType write SetListboxType;
    property Disabled: Boolean read FDisabled write SetDisabled;
    property Index: Integer read FIndex write SetIndex;
    property TopIndex: Integer read GetTopIndex write SetTopIndex;
    property BottomIndex: Integer read GetBottomIndex write SetBottomIndex;
(*============================================================================*)
    property OnChange: TOnEvent read FOnChange write FOnChange;
  end;




//##############################################################################
//##                                  MENU                                    ##
//##############################################################################




  // CONTROLS ADDED TO THE MENU SHOULD NOT MOVE, CHANGE PARENT, VISIBILITY
  // OR BE FREED WHILE IN THE LIST.

  TAMenu = class(TAControl)
  protected
    FList: TAList;
    FCount: Integer;
    //#
    FPopped: Boolean;
    //#
    //#
    // the alpha of the menu items.
    FMaxAlpha: Byte;
    //#
    FSpeed,
    FAcceleration: Extended;
    FTimeOut: Integer;
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure UpdateMenu;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    procedure Load(AMaxAlpha: Byte; ATimeOut: Integer; ASpeed: Extended = 0; AAcceleration: Extended = 0);
    procedure Unload;
    //#
    //#
    procedure Pop(AX, AY: Integer);
    procedure Unpop;
    //#
    procedure AddItem(AControl: TAControl);
    procedure RemoveItem(AControl: TAControl);
    function FindItem(AControl: TAControl): Integer;
    procedure Clear;
  end;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




//##############################################################################
//##                                 SCROLL                                   ##
//##############################################################################


{ TAScroll }




constructor TAScroll.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, ABufferType, AControlType);



end;


destructor TAScroll.Destroy;
begin
        if (FScrollControl <> nil) then
        begin
                if (FScrollControl.FH = Self) then FScrollControl.SetH(nil)
                else if (FScrollControl.FV = Self) then FScrollControl.SetV(nil);
        end;



inherited;
end;


procedure TAScroll.ProcessMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_TRACK_CHANGE:
          begin
                if (FScrollControl <> nil) then
                begin
                        if (FScrollControl.FH = Self) then FScrollControl.SetLeftScroll(FValue)
                        else if (FScrollControl.FV = Self) then FScrollControl.SetTopScroll(FValue);
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                              SCROLLCONTROL                               ##
//##############################################################################


{ TAScrollControl }




constructor TAScrollControl.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, ABufferType, AControlType);



        FLeftScrolling:= False;
        FTopScrolling:= False;



        FLastLeft:= 0;
        FLastTop:= 0;



        FLeftScroll:= 0;
        FTopScroll:= 0;
        FWidthScroll:= 0;
        FHeightScroll:= 0;
        FCountLeft:= 0;
        FCountTop:= 0;
end;


destructor TAScrollControl.Destroy;
begin
        StopLeftScroll;
        StopTopScroll;

        if (FH <> nil) then FH.FScrollControl:= nil;
        if (FV <> nil) then FV.FScrollControl:= nil;



inherited;
end;



procedure TAScrollControl.SetLeftScroll(ALeftScroll: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ALeftScroll, 0, FWidthScroll);

        if (ALeftScroll <> FLeftScroll) then
        begin
                if (FLeftScrolling) then FLastLeft:= Trunc(FScrollRec.SmoothLeft)
                else FLastLeft:= FLeftScroll;


                FLeftScroll:= ALeftScroll;


                if (FH <> nil) then FH.SetValue(FLeftScroll);
                UpdateSmoothInc;
                StartLeftScroll;
                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_LEFTSCROLL_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.SetTopScroll(ATopScroll: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ATopScroll, 0, FHeightScroll);

        if (ATopScroll <> FTopScroll) then
        begin
                if (FTopScrolling) then FLastTop:= Trunc(FScrollRec.SmoothTop)
                else FLastTop:= FTopScroll;


                FTopScroll:= ATopScroll;


                if (FV <> nil) then FV.SetValue(FTopScroll);
                UpdateSmoothInc;
                StartTopScroll;
                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TOPSCROLL_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.SetWidthScroll(AWidthScroll: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AWidthScroll, 0, MaxInt);

        if (AWidthScroll <> FWidthScroll) then
        begin
                FWidthScroll:= AWidthScroll;


                if (FH <> nil) then FH.SetMaxValue(FWidthScroll);
                if (FLeftScroll > FWidthScroll) then SetLeftScroll(FWidthScroll);
                UpdateSmoothInc;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.SetHeightScroll(AHeightScroll: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AHeightScroll, 0, MaxInt);

        if (AHeightScroll <> FHeightScroll) then
        begin
                FHeightScroll:= AHeightScroll;


                if (FV <> nil) then FV.SetMaxValue(FHeightScroll);
                if (FTopScroll > FHeightScroll) then SetTopScroll(FHeightScroll);
                UpdateSmoothInc;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.SetH(AH: TAScroll);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AH <> FH)and((FV = nil)or(AH <> FV)) then
        begin
                if (FH <> nil) then FH.FScrollControl:= nil;


                FH:= AH;


                if (FH <> nil) then
                begin
                        FH.FScrollControl:= Self;
                        FH.SetMinValue(0);
                        FH.SetMaxValue(FWidthScroll);
                        FH.SetValue(FLeftScroll);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.SetV(AV: TAScroll);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AV <> FV)and((FH = nil)or(AV <> FH)) then
        begin
                if (FV <> nil) then FV.FScrollControl:= nil;


                FV:= AV;


                if (FV <> nil) then
                begin
                        FV.FScrollControl:= Self;
                        FV.SetMinValue(0);
                        FV.SetMaxValue(FHeightScroll);
                        FV.SetValue(FTopScroll);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.ProcessMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SIZE:
          begin
                UpdateSmoothInc;
                Changed;
          end;
          //
          AM_LEFTSCROLL_START:
                (*==============*)
                (**) if (Assigned(FOnLeftScrollStart)) then FOnLeftScrollStart(Self);
                (*==============*)
          //
          AM_LEFTSCROLL_STOP:
                (*==============*)
                (**) if (Assigned(FOnLeftScrollStop)) then FOnLeftScrollStop(Self);
                (*==============*)
          //
          AM_TOPSCROLL_START:
                (*==============*)
                (**) if (Assigned(FOnTopScrollStart)) then FOnTopScrollStart(Self);
                (*==============*)
          //
          AM_TOPSCROLL_STOP:
                (*==============*)
                (**) if (Assigned(FOnTopScrollStop)) then FOnTopScrollStop(Self);
                (*==============*)
          //
          AM_LEFTSCROLL_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnLeftScrollChange)) then FOnLeftScrollChange(Self);
                (*==============*)
          //
          AM_TOPSCROLL_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnTopScrollChange)) then FOnTopScrollChange(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_LEFTSCROLL_SMOOTH:
                  begin
                        if (FLeftScroll <> FScrollRec.SmoothLeft) then
                        begin
                                if (FLeftScroll > FScrollRec.SmoothLeft)and(FLeftScroll < FScrollRec.SmoothLeft + FScrollRec.SmoothLeftInc) then FScrollRec.SmoothLeft:= FLeftScroll
                                else if (FLeftScroll < FScrollRec.SmoothLeft)and(FLeftScroll > FScrollRec.SmoothLeft - FScrollRec.SmoothLeftInc) then FScrollRec.SmoothLeft:= FLeftScroll
                                else FScrollRec.SmoothLeft:= FScrollRec.SmoothLeft + Sgn(FLeftScroll - FScrollRec.SmoothLeft) * FScrollRec.SmoothLeftInc;

                                Changed;
                        end
                        else StopLeftScroll;

                        (*==============*)
                        (**) if (Assigned(FOnLeftScrolling)) then FOnLeftScrolling(Self);
                        (*==============*)
                  end;
                  //
                  TID_TOPSCROLL_SMOOTH:
                  begin
                        if (FTopScroll <> FScrollRec.SmoothTop) then
                        begin
                                if (FTopScroll > FScrollRec.SmoothTop)and(FTopScroll < FScrollRec.SmoothTop + FScrollRec.SmoothTopInc) then FScrollRec.SmoothTop:= FTopScroll
                                else if (FTopScroll < FScrollRec.SmoothTop)and(FTopScroll > FScrollRec.SmoothTop - FScrollRec.SmoothTopInc) then FScrollRec.SmoothTop:= FTopScroll
                                else FScrollRec.SmoothTop:= FScrollRec.SmoothTop + Sgn(FTopScroll - FScrollRec.SmoothTop) * FScrollRec.SmoothTopInc;

                                Changed;
                        end
                        else StopTopScroll;

                        (*==============*)
                        (**) if (Assigned(FOnTopScrolling)) then FOnTopScrolling(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAScrollControl.UpdateSmoothInc;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FWidthScroll <> 0) then FScrollRec.SmoothLeftInc:= Abs(FLastLeft - FLeftScroll) * (FCountLeft + 1) / FWidthScroll
        else FScrollRec.SmoothLeftInc:= 0;

        if (FHeightScroll <> 0) then FScrollRec.SmoothTopInc:= Abs(FLastTop - FTopScroll) * (FCountTop + 1) / FHeightScroll
        else FScrollRec.SmoothTopInc:= 0;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAScrollControl.StartLeftScroll: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FLeftScrolling)and(FScrollRec.TimeOutLeft <> 0)and(FScrollRec.SmoothLeftInc <> 0) then
        begin
                FLeftScrolling:= True;
                Result:= True;

                TimerManager.AddTimer(TT_HOOK, TID_LEFTSCROLL_SMOOTH, FScrollRec.TimeOutLeft, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_LEFTSCROLL_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAScrollControl.StopLeftScroll: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FLeftScrolling) then
        begin
                FLeftScroll:= Trunc(FScrollRec.SmoothLeft);
                FLeftScrolling:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_LEFTSCROLL_SMOOTH, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_LEFTSCROLL_STOP, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAScrollControl.StartTopScroll: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FTopScrolling)and(FScrollRec.TimeOutTop <> 0)and(FScrollRec.SmoothTopInc <> 0) then
        begin
                FTopScrolling:= True;
                Result:= True;

                TimerManager.AddTimer(TT_HOOK, TID_TOPSCROLL_SMOOTH, FScrollRec.TimeOutTop, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TOPSCROLL_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAScrollControl.StopTopScroll: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FTopScrolling) then
        begin
                FTopScroll:= Trunc(FScrollRec.SmoothTop);        
                FTopScrolling:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_TOPSCROLL_SMOOTH, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TOPSCROLL_STOP, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;



//##############################################################################
//##                                  EDIT                                    ##
//##############################################################################


{ TAEdit }




constructor TAEditbox.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT or BT_RESIZE, AControlType);

SetCursorDef(CS_TEXT);



        FCaret:= 0;
        FSelStart:= 0;
        FSelEnd:= 0;

        FEditboxType:= EBT_NORMAL;



        FBlink:= False;

        FSetting:= False;
end;


destructor TAEditbox.Destroy;
begin



inherited;
end;


procedure TAEditbox.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetCursorDef(ACursorDef: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ACursorDef:= CS_TEXT;

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetEditboxType(AEditboxType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AEditboxType <> FEditboxType) then
        begin
                FEditboxType:= AEditboxType;


                if (FEditboxType and EBT_NUMBER <> 0) then SetText(IntToStr(StrToInt(FText)));
                if (FEditboxType and EBT_PASSWORD <> 0) then FRealText:= StringFill('*', Length(FText));
                if (FEditboxType and EBT_SELECT = 0) then
                begin
                        FSelStart:= 0;
                        FSelEnd:= 0;
                end;
                UpdateCaret;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetDisabled(ADisabled: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ADisabled <> FDisabled) then
        begin
                FDisabled:= ADisabled;


                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetText(const AText: String);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AText <> FText) then
        begin
                if (FEditboxType and EBT_PASSWORD <> 0) then FRealText:= StringFill('*', Length(AText))
                else FRealText:= AText;


                FText:= AText;


                Restrict(FCaret, 0, Length(FRealText) + 1);
                Restrict(FSelStart, 0, Length(FRealText) + 1);
                Restrict(FSelEnd, 0, Length(FRealText) + 1);
                UpdateCaret;
                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetCaret(ACaret: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ACaret, 0, Length(FRealText) + 1);

        if (ACaret <> FCaret) then
        begin
                FCaret:= ACaret;

                
                UpdateCaret;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetSelStart(ASelStart: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ASelStart, 0, Length(FRealText) + 1);

        if (FEditboxType and EBT_SELECT = 0) then ASelStart:= 0;

        if (ASelStart <> FSelStart) then
        begin
                FSelStart:= ASelStart;

                UpdateCaret;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.SetSelEnd(ASelEnd: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(ASelEnd, 0, Length(FRealText) + 1);

        if (FEditboxType and EBT_SELECT = 0) then ASelEnd:= 0;

        if (ASelEnd <> FSelEnd) then
        begin
                FSelEnd:= ASelEnd;

                UpdateCaret;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAEditbox.GetCaret(ACaret: Integer): Integer;
var SStart, SEnd: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SStart:= Min(FSelStart, FSelEnd);
        SEnd:= Max(FSelStart, FSelEnd);

        if (FSelStart = FSelEnd) then Result:= FontManager.FontStringSize(FFont, Copy(FRealText, 1, ACaret)).X
        else begin
                if (ACaret < SStart) then Result:= FontManager.FontStringSize(FFont, Copy(FRealText, 1, ACaret)).X
                else if (ACaret < SEnd) then Result:= FontManager.FontStringSize(FFont, Copy(FRealText, 1, SStart)).X + FontManager.FontStringSize(FFontSel, Copy(FRealText, SStart + 1, ACaret - SStart)).X
                else Result:= FontManager.FontStringSize(FFont, Copy(FRealText, 1, SStart)).X + FontManager.FontStringSize(FFontSel, Copy(FRealText, SStart + 1, SEnd - SStart)).X + FontManager.FontStringSize(Font, Copy(FRealText, SEnd + 1, ACaret - SEnd)).X;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAEditbox.GetIndex(AX: Integer): Integer;
var SStart, SEnd: Integer;
    SL: Extended;
    X, W: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SL:= FScrollRec.SmoothLeft*Integer(FLeftScrolling) + FLeftScroll*Integer(not FLeftScrolling);

        SStart:= Min(FSelStart, FSelEnd);
        SEnd:= Max(FSelStart, FSelEnd);

        Result:= 1;

        if Length(FRealText) > 0 then
        begin
                X:= -Trunc(SL);
                while (Result <= SStart)and(X < AX) do
                begin
                        Inc(X, FontManager.FontStringSize(FFont, FRealText[Result]).X);
                        Inc(Result);
                end;
                while (Result <= SEnd)and(X < AX) do
                begin
                        Inc(X, FontManager.FontStringSize(FFontSel, FRealText[Result]).X);
                        Inc(Result);
                end;
                while (Result <= Length(FRealText))and(X < AX) do
                begin
                        Inc(X, FontManager.FontStringSize(FFont, FRealText[Result]).X);
                        Inc(Result);
                end;

                if (not FSetting) then
                begin
                        if (Result > SStart)and(Result < SEnd) then W:= FontManager.FontStringSize(FFontSel, FRealText[Result - 1]).X
                        else W:= FontManager.FontStringSize(FFont, FRealText[Result - 1]).X;

                        if (AX <= X - (W shr 1)) then Dec(Result);
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.ProcessMessage(Msg, WParam, LParam: Integer);
var SStart, SEnd: Integer;
    X: Integer;
    S: String;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SIZE: UpdateEdit;
          //
          AM_MOUSE_DOWNL:
          begin
                if (GetFocused)and(FEditboxType and EBT_SELECT <> 0) then
                begin
                        X:= GetIndex(LowInt(LParam));

                        FCaret:= X - 1;
                        FSelStart:= X - 1;
                        FSelEnd:= X - 1;
                        UpdateCaret;
                        Changed;

                        FSetting:= True;
                end;

                SetCapture(True);
          end;
          //
          AM_MOUSE_MOVE:
          if (FSetting) then
          begin
                X:= GetIndex(LowInt(LParam));

                FCaret:= X - 1;
                FSelEnd:= X - 1;
                UpdateCaret;
                Changed;
          end;
          //
          AM_MOUSE_UPL:
          begin
                FSetting:= False;

                SetCapture(False);
          end;
          //
          AM_KEY_DOWN:
          begin
                case WParam of
                  VK_LEFT:
                  begin
                        // get jump delta.
                        if (Keyboard.ShiftState and SS_CONTROL <> 0) then
                        begin
                                X:= StringMatchIndexRight(Copy(FText, 1, FCaret - 1), ' ');
                                X:= Abs(FCaret - X);
                        end
                        else X:= 1;

                        if (Keyboard.ShiftState and SS_SHIFT <> 0)and
                           (FEditboxType and EBT_SELECT <> 0) then
                        begin
                                if (FCaret > 0) then
                                begin
                                        if (FSelStart = FSelEnd) then
                                        begin
                                                FSelStart:= FCaret;
                                                FSelEnd:= FCaret - X;
                                        end
                                        else FSelEnd:= FSelEnd - X;
                                end;
                        end
                        else begin
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        if (FCaret > 0) then FCaret:= FCaret - X;
                        UpdateCaret;
                        Changed;
                  end;
                  //
                  VK_RIGHT:
                  begin
                        // get jump delta.
                        if (Keyboard.ShiftState and SS_CONTROL <> 0) then
                        begin
                                X:= FCaret + 1 + StringMatchIndexLeft(Copy(FText, FCaret + 2, MaxInt), ' ');
                                if (X <> FCaret + 1) then X:= Abs(FCaret - X)
                                else X:= Length(FRealText) - FCaret;
                        end
                        else X:= 1;

                        if (Keyboard.ShiftState and SS_SHIFT <> 0)and
                           (FEditboxType and EBT_SELECT <> 0) then
                        begin
                                if (FCaret < Length(FRealText)) then
                                begin
                                        if (FSelStart = FSelEnd) then
                                        begin
                                                FSelStart:= FCaret;
                                                FSelEnd:= FCaret + X;
                                        end
                                        else FSelEnd:= FSelEnd + X;
                                end;
                        end
                        else begin
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        if (FCaret < Length(FRealText)) then FCaret:= FCaret + X;
                        UpdateCaret;
                        Changed;
                  end;
                  //
                  VK_HOME:
                  begin
                        if (Keyboard.ShiftState and SS_SHIFT <> 0)and
                           (FEditboxType and EBT_SELECT <> 0) then
                        begin
                                if (FSelStart = FSelEnd) then FSelStart:= FCaret;
                                FSelEnd:= 0;
                        end
                        else begin
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        FCaret:= 0;
                        UpdateCaret;
                        Changed;
                  end;
                  //
                  VK_END:
                  begin
                        if (Keyboard.ShiftState and SS_SHIFT <> 0)and
                           (FEditboxType and EBT_SELECT <> 0) then
                        begin
                                if (FSelStart = FSelEnd) then FSelStart:= FCaret;
                                FSelEnd:= Length(FRealText);
                        end
                        else begin
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        FCaret:= Length(FRealText);
                        UpdateCaret;
                        Changed;
                  end;
                  //
                  VK_DELETE:
                  if (not FDisabled) then
                  begin
                        if (FSelStart = FSelEnd) then SetText(Copy(FText, 1, FCaret) + Copy(FText, FCaret + 2, MaxInt))
                        else begin
                                SStart:= Min(FSelStart, FSelEnd);
                                SEnd:= Max(FSelStart, FSelEnd);

                                SetText(Copy(FText, 1, SStart) + Copy(FText, SEnd + 1, MaxInt));
                                FCaret:= SStart;
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        UpdateCaret;
                        Changed;
                  end;
                  //
                  VK_BACKSPACE:
                  if (not FDisabled) then
                  begin
                        if (FSelStart = FSelEnd) then
                        begin
                                SetText(Copy(FText, 1, FCaret - 1) + Copy(FText, FCaret + 1, MaxInt));
                                if (FCaret > 0) then Dec(FCaret);
                        end
                        else begin
                                SStart:= Min(FSelStart, FSelEnd);
                                SEnd:= Max(FSelStart, FSelEnd);

                                SetText(Copy(FText, 1, SStart) + Copy(FText, SEnd + 1, MaxInt));
                                FCaret:= SStart;
                                FSelStart:= 0;
                                FSelEnd:= 0;
                        end;

                        UpdateCaret;
                        Changed;
                  end;
                  //
                end;


                // clipboard requests.
                if (Keyboard.ShiftState and SS_CONTROL <> 0)and(FEditboxType and EBT_SELECT <> 0) then
                begin
                        SStart:= Min(FSelStart, FSelEnd);
                        SEnd:= Max(FSelStart, FSelEnd);

                        case CharUpper(Char(WParam)) of
                         'C': if (FEditboxType and EBT_PASSWORD = 0)and(FSelStart <> FSelEnd) then Clipboard.SetText(Copy(FRealText, SStart + 1, SEnd - SStart));
                         //
                         'V':
                         if (not FDisabled) then
                         begin
                                S:= Clipboard.GetText;
                                if (FSelStart <> FSelEnd) then
                                begin
                                        SetText(Copy(FText, 1, SStart) + S + Copy(FText, SEnd + 1, MaxInt));
                                        FCaret:= SStart + Length(S);
                                        FSelStart:= SStart;
                                        FSelEnd:= FCaret;
                                end
                                else begin
                                        SetText(Copy(FText, 1, FCaret) + S + Copy(FText, FCaret + 1, MaxInt));
                                        FCaret:= FCaret + Length(S);
                                end;

                                UpdateCaret;
                                Changed;
                         end;
                         //
                         'X':
                         if (not FDisabled)and(FSelStart <> FSelEnd) then
                         begin
                                if (FEditboxType and EBT_PASSWORD = 0) then Clipboard.SetText(Copy(FRealText, SStart + 1, SEnd - SStart));
                                
                                SetText(Copy(FText, 1, SStart) + Copy(FText, SEnd + 1, MaxInt));
                                FCaret:= SStart;
                                FSelStart:= 0;
                                FSelEnd:= 0;
                                UpdateCaret;
                                Changed;
                         end;
                         //
                        end;
                end;
          end;
          //
          AM_KEY_CHAR:
          if (not FDisabled) then
          begin
                  if (WParam <> VK_BACKSPACE)and(WParam <> VK_TAB)and
                     ((FEditboxType and EBT_NUMBER = 0)or(Char(WParam) in ['0'..'9'])) then
                  begin
                        if (Keyboard.ShiftState and SS_CONTROL = 0) then
                        begin
                                if (FSelStart = FSelEnd) then
                                begin
                                        SetText(Copy(FText, 1, FCaret) + Char(WParam) + Copy(FText, FCaret + 1, MaxInt));
                                        Inc(FCaret);
                                end
                                else begin
                                        SStart:= Min(FSelStart, FSelEnd);
                                        SEnd:= Max(FSelStart, FSelEnd);

                                        SetText(Copy(FText, 1, SStart) + Char(WParam) + Copy(FText, SEnd + 1, MaxInt));
                                        FCaret:= SStart + 1;
                                        FSelStart:= 0;
                                        FSelEnd:= 0;
                                end;
                        end;

                        UpdateCaret;
                        Changed;
                  end;
          end;
          //
          AM_SET_FOCUS:
          begin
                TimerManager.AddTimer(TT_HOOK, TID_CARET, 100, Self);

                if (FEditboxType and EBT_SELECT <> 0) then
                begin
                        FSelStart:= 0;
                        FSelEnd:= FCaret;
                end;

                FCaret:= Length(FRealText);
                UpdateCaret;
                Changed;
          end;
          //
          AM_RELEASE_FOCUS:
          begin
                TimerManager.RemoveTimer(TT_HOOK, TID_CARET, Self);

                FSelStart:= 0;
                FSelEnd:= 0;
                UpdateCaret;
                Changed;
          end;
          //
          AM_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnChange)) then FOnChange(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_CARET:
                  begin
                        FBlink:= not FBlink;

                        Changed;
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.Paint;
var SL: Extended;
    SStart, SEnd: Integer;
    Point: TPoint;
    X: Integer;
begin
        FBuffer.Manipulate(MOP_FILL, 0, M_ALPHA);

        if (FText <> '') then
        begin
                SL:= FScrollRec.SmoothLeft*Integer(FLeftScrolling) + FLeftScroll*Integer(not FLeftScrolling);

                SStart:= Min(FSelStart, FSelEnd);
                SEnd:= Max(FSelStart, FSelEnd);

                if (FSelStart = FSelEnd) then
                begin
                        Point.X:= -Trunc(SL);
                        Point.Y:= (FHeight shr 1) - (FontManager.FontSize(FFont).Y shr 1);
                        FontManager.RenderText(FFont, FBuffer, Point, FRealText, A_OPAQUE, RM_COPY);
                end
                else begin
                        Point.X:= -Trunc(SL);
                        Point.Y:= (FHeight shr 1) - (FontManager.FontSize(FFont).Y shr 1);
                        FontManager.RenderText(FFont, FBuffer, Point, Copy(FRealText, 1, SStart), A_OPAQUE, RM_COPY);

                        Point.X:= -Trunc(SL) + FontManager.FontStringSize(FFont, Copy(FRealText, 1, SStart)).X;
                        Point.Y:= (FHeight shr 1) - (FontManager.FontSize(FFontSel).Y shr 1);
                        FontManager.RenderText(FFontSel, FBuffer, Point, Copy(FRealText, SStart + 1, SEnd - SStart), A_OPAQUE, RM_COPY);

                        Point.X:= -Trunc(SL) + FontManager.FontStringSize(FFont, Copy(FRealText, 1, SStart)).X + FontManager.FontStringSize(FFontSel, Copy(FRealText, SStart + 1, SEnd - SStart)).X;
                        Point.Y:= (FHeight shr 1) - (FontManager.FontSize(FFont).Y shr 1);
                        FontManager.RenderText(FFont, FBuffer, Point, Copy(FRealText, SEnd + 1, MaxInt), A_OPAQUE, RM_COPY);
                end;

                // draw the caret.
                if (GetFocused)and(FBlink) then
                begin
                        X:= GetCaret(FCaret);
                        FBuffer.Manipulate(MOP_FILL, $FF000000, M_ALPHACOLOR, NewRect(-Trunc(SL) + X, 0, -Trunc(SL) + X + 1, FHeight));
                end;
        end
        // draw only the caret.
        else if (GetFocused)and(FBlink) then FBuffer.Manipulate(MOP_FILL, $FF000000, M_ALPHACOLOR, NewRect(0, 0, 1, FHeight));
end;


procedure TAEditbox.UpdateCaret;
var SL: Extended;
    X: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SL:= FScrollRec.SmoothLeft*Integer(FLeftScrolling) + FLeftScroll*Integer(not FLeftScrolling);
        X:= GetCaret(FCaret);


        SetWidthScroll(GetCaret(Length(FRealText)) - FWidth + 1);
        if (FCaret = 0) then SetLeftScroll(0)
        else if (FCaret = Length(FRealText)) then SetLeftScroll(GetCaret(Length(FRealText)) - FWidth + 1)
        else if (X < Trunc(SL)) then SetLeftScroll(X)
        else if (X >= Trunc(SL) + FWidth) then SetLeftScroll(X - FWidth + 1);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.UpdateEdit;
var AWidth, AHeight: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AWidth:= FWidth;
        AHeight:= Max(FontManager.FontSize(FFont).Y, FontManager.FontSize(FFontSel).Y);

        FBuffer.Resize(AWidth, AHeight);
        Size(AWidth, AHeight);
        UpdateSmoothInc;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.Load(const AFont, AFontSel: String; ACount, ATimeOut: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;


        FFont:= AFont;
        FFontSel:= AFontSel;

        FScrollRec.TimeOutLeft:= ATimeOut;

        FCountLeft:= ACount;

        UpdateCaret;
        UpdateEdit;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAEditbox.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        StopLeftScroll;

        FFont:= '';
        FFontSel:= '';
        FCountLeft:= 0;

        UpdateCaret;
        UpdateEdit;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                 LISTBOX                                  ##
//##############################################################################


{ TAListbox }




constructor TAListbox.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT or BT_RESIZE, AControlType);



        FListboxType:= LBT_TEXT_ITEMHEIGHT;
        FDisabled:= False;
        FIndex:= -1;



        FList:= TAList.Create;
        FCount:= 0;
end;


destructor TAListbox.Destroy;
begin
        Clear;

        FList.Free;



inherited;
end;


procedure TAListbox.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType or BT_RESIZE;

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAListbox.GetItem(AIndex: Integer): TListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FCount) then Result:= PListboxItem(FList.Items[AIndex])^
        else begin
                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Getitem index out of bounds.', 'TAListbox.GetItem', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.SetItem(AIndex: Integer; AItem: TListboxItem);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FCount) then
        begin
                PListboxItem(FList.Items[AIndex])^:= AItem;

                UpdateIndex;
                Changed;
        end
        else begin
                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Setitem index out of bounds.', 'TAListbox.SetItem', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListBox.SetListboxType(AListboxType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AListboxType <> FListboxType) then
        begin
                FListboxType:= AListboxType;


                UpdateIndex;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.SetDisabled(ADisabled: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ADisabled <> FDisabled) then
        begin
                FDisabled:= ADisabled;


                if (FDisabled) then FIndex:= -1;
                UpdateIndex;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.SetIndex(AIndex: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AIndex, -1, FCount-1);

        if (FDisabled) then AIndex:= -1;

        if (AIndex <> FIndex) then
        begin
                FIndex:= AIndex;


                if (FIndex = GetTopIndex)and(not FTopScrolling) then SetTopIndex(FIndex)
                else if (FIndex = GetBottomIndex)and(not FTopScrolling) then SetBottomIndex(FIndex);
                UpdateIndex;
                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAListbox.GetIndex(AX: Integer): Integer;
var ST, Y, H: Integer;
    AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        ST:= Trunc(FTopScroll*Integer(not FTopScrolling) + FScrollRec.SmoothTop*Integer(FTopScrolling));

        Y:= 0;
        while (Result < FCount - 1) do
        begin
                AItem:= FList.Items[Result];

                H:= 0;

                if (FListboxType and LBT_TEXT_ITEMHEIGHT <> 0) then
                begin
                        if (FListboxType and LBT_MULTILINE <> 0) then
                        begin
                                if (Result = FIndex) then H:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text).Y
                                else H:= FontManager.FontStringSize(AItem^.Font, AItem^.Text).Y;
                        end
                        else begin
                                if (Result = FIndex) then H:= FontManager.FontSize(AItem^.FontSel).Y
                                else H:= FontManager.FontSize(AItem^.Font).Y;
                        end;
                end;
                if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0)and(AItem^.Control <> nil) then H:= Max(H, AItem^.Control.Height);

                Inc(Y, H);

                if (Y >= ST + AX) then Break
                else Inc(Result);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

function TAListbox.GetTopIndex: Integer;
begin
        Result:= GetIndex(0);
end;


procedure TAListbox.SetTopIndex(AIndex: Integer);
var i, Y, H: Integer;
    AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AIndex, -1, FCount-1);

        if (AIndex > -1) then
        begin
                Y:= 0;
                for i:= 0 to AIndex-1 do
                begin
                        AItem:= FList.Items[i];

                        H:= 0;

                        if (FListboxType and LBT_TEXT_ITEMHEIGHT <> 0) then
                        begin
                                if (FListboxType and LBT_MULTILINE <> 0) then
                                begin
                                        if (i = FIndex) then H:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text).Y
                                        else H:= FontManager.FontStringSize(AItem^.Font, AItem^.Text).Y;
                                end
                                else begin
                                        if (i = FIndex) then H:= FontManager.FontSize(AItem^.FontSel).Y
                                        else H:= FontManager.FontSize(AItem^.Font).Y;
                                end;
                        end;
                        if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                        if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0)and(AItem^.Control <> nil) then H:= Max(H, AItem^.Control.Height);

                        Inc(Y, H);
                end;

                SetTopScroll(Y);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAListbox.GetBottomIndex: Integer;
begin
        Result:= GetIndex(FHeight - 1);

        if (FCount > 1)and(Result = FCount - 1) then Result:= -1;
end;


procedure TAListbox.SetBottomIndex(AIndex: Integer);
var i, Y, H: Integer;
    AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AIndex, -1, FCount-1);

        if (AIndex > -1) then
        begin
                Y:= 0;
                for i:= 0 to AIndex do
                begin
                        AItem:= FList.Items[i];

                        H:= 0;

                        if (FListboxType and LBT_TEXT_ITEMHEIGHT <> 0) then
                        begin
                                if (FListboxType and LBT_MULTILINE <> 0) then
                                begin
                                        if (i = FIndex) then H:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text).Y
                                        else H:= FontManager.FontStringSize(AItem^.Font, AItem^.Text).Y;
                                end
                                else begin
                                        if (i = FIndex) then H:= FontManager.FontSize(AItem^.FontSel).Y
                                        else H:= FontManager.FontSize(AItem^.Font).Y;
                                end;
                        end;
                        if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                        if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0)and(AItem^.Control <> nil) then H:= Max(H, AItem^.Control.Height);

                        Inc(Y, H);
                end;

                SetTopScroll(Y - FHeight);
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

procedure TAListbox.ProcessMessage(Msg, WParam, LParam: Integer);
var AItem: PListboxItem;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SIZE: UpdateIndex;
          //
          AM_MESSAGE_NOTIFY:
          begin
                case WParam of
                 AM_SIZE:
                 begin
                        UpdateIndex;
                        Changed;
                 end;
                 //
                 AM_MOUSE_DOWNL: if (not FDisabled) then SetIndex(FindItem(TAControl(LParam)));
                 //
                end;
          end;
          //
          AM_KEY_DOWN:
          if (not FDisabled) then
          begin
                case WParam of
                  VK_UP: SetIndex(FIndex - 1);
                  //
                  VK_DOWN: SetIndex(FIndex + 1);
                  //
                  VK_HOME: SetIndex(0);
                  //
                  VK_END: SetIndex(FCount - 1);
                  //
                end;
          end;
          //
          AM_MOUSE_WHEEL: SetTopScroll(FTopScroll - HighInt(WParam) div 6);
          //
          AM_SET_PARENT:
          begin
                for i:= 0 to FCount-1 do
                begin
                        AItem:= FList.Items[i];

                        if (AItem^.Control <> nil) then
                        begin
                                AItem^.Control.Parent:= FParent;
                                FLayerManager.AddMessageNotify(AM_SIZE, AItem^.Control, Self);
                                FLayerManager.AddMessageNotify(AM_MOUSE_DOWNL, AItem^.Control, Self);
                        end;
                end;
          end;
          //
          AM_RELEASE_PARENT:
          begin
                for i:= 0 to FCount-1 do
                begin
                        AItem:= FList.Items[i];

                        if (AItem^.Control <> nil) then
                        begin
                                AItem^.Control.Parent:= nil;
                                FLayerManager.RemoveMessageNotify(AM_SIZE, AItem^.Control, Self);
                                FLayerManager.RemoveMessageNotify(AM_MOUSE_DOWNL, AItem^.Control, Self);
                        end;
                end;
          end;
          //
          AM_MOUSE_DOWNL: if (not FDisabled) then SetIndex(GetIndex(CursorPos.Y));
          //
          AM_TOPSCROLL_CHANGE: UpdateIndex;
          //
          AM_LEFTSCROLL_CHANGE: UpdateIndex;
          //
          AM_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnChange)) then FOnChange(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  TID_TOPSCROLL_SMOOTH, TID_LEFTSCROLL_SMOOTH: UpdateIndex;
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.Paint;
var i, SL, ST, Y, H, FH: Integer;
    AItem: PListboxItem;
    ATop, ABottom: Integer;
    Point: TPoint;
    Rect: TRect;
begin
        FBuffer.Manipulate(MOP_FILL, 0, M_ALPHA);

        if (FCount > 0) then
        begin
                SL:= Trunc(FLeftScroll*Integer(not FLeftScrolling) + FScrollRec.SmoothLeft*Integer(FLeftScrolling));
                ST:= Trunc(FTopScroll*Integer(not FTopScrolling) + FScrollRec.SmoothTop*Integer(FTopScrolling));
                ATop:= GetTopIndex;
                ABottom:= GetBottomIndex;
                if ABottom = -1 then ABottom:= FCount - 1;

                // get the topitem position.
                Y:= -ST;
                for i:= 0 to ATop-1 do
                begin
                        AItem:= FList.Items[i];

                        H:= 0;

                        if (FListboxType and LBT_TEXT_ITEMHEIGHT <> 0) then
                        begin
                                if (FListboxType and LBT_MULTILINE <> 0) then
                                begin
                                        if (i = FIndex) then H:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text).Y
                                        else H:= FontManager.FontStringSize(AItem^.Font, AItem^.Text).Y;
                                end
                                else begin
                                        if (i = FIndex) then H:= FontManager.FontSize(AItem^.FontSel).Y
                                        else H:= FontManager.FontSize(AItem^.Font).Y;
                                end;
                        end;
                        if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                        if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0)and(AItem^.Control <> nil) then H:= Max(H, AItem^.Control.Height);

                        Inc(Y, H);
                end;

                for i:= ATop to ABottom do
                begin
                        AItem:= FList.Items[i];

                        if (FListboxType and LBT_MULTILINE <> 0) then
                        begin
                                if (i = FIndex) then H:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text).Y
                                else H:= FontManager.FontStringSize(AItem^.Font, AItem^.Text).Y;
                                FH:= H;
                                if (FListboxType and LBT_TEXT_ITEMHEIGHT = 0) then H:= 0;
                        end
                        else begin
                                if (i = FIndex) then H:= FontManager.FontSize(AItem^.FontSel).Y
                                else H:= FontManager.FontSize(AItem^.Font).Y;
                                FH:= H;
                                if (FListboxType and LBT_TEXT_ITEMHEIGHT = 0) then H:= 0;
                        end;
                        if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                        if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0)and(AItem^.Control <> nil) then H:= Max(H, AItem^.Control.Height);

                        // draw the text.
                        if (AItem^.Text <> '') then
                        begin
                                if (FH > H)and(FListboxType and LBT_RESTRICT <> 0) then
                                begin
                                        Point.X:= AItem^.TextOffset - SL;
                                        Point.Y:= Y + (H shr 1) - (FH shr 1);

                                        if (i = FIndex) then FontManager.RenderText(AItem^.FontSel, FBuffer, Point, NewRect(Point.X, Y, MaxInt, Y + FH), AItem^.Text, A_OPAQUE, RM_COPY)
                                        else FontManager.RenderText(AItem^.Font, FBuffer, Point, NewRect(Point.X, Y, MaxInt, Y + FH), AItem^.Text, A_OPAQUE, RM_COPY);
                                end
                                else begin
                                        Point.X:= AItem^.TextOffset - SL;
                                        if (FH <> H) then Point.Y:= Y + (H shr 1) - (FH shr 1)
                                        else Point.Y:= Y;

                                        if (i = FIndex) then FontManager.RenderText(AItem^.FontSel, FBuffer, Point, AItem^.Text, A_OPAQUE, RM_COPY)
                                        else FontManager.RenderText(AItem^.Font, FBuffer, Point, AItem^.Text, A_OPAQUE, RM_COPY);
                                end;
                        end;

                        // draw the foot.
                        if (AItem^.Foot <> nil) then
                        begin
                                if (AItem^.Foot.Height > H)and(FListboxType and LBT_RESTRICT <> 0) then
                                begin
                                        Point.X:= AItem^.FootOffset - SL;
                                        Point.Y:= Y;
                                        Rect.Left:= 0;
                                        Rect.Top:= Y - (H shr 1) + (AItem^.Foot.Height shr 1);
                                        Rect.Right:= AItem^.Foot.Width;
                                        Rect.Bottom:= Rect.Top + AItem^.Foot.Height;

                                        AItem^.Foot.Render(FBuffer, Point, Rect, A_OPAQUE, RM_COPY);
                                end
                                else begin
                                        Point.X:= AItem^.FootOffset - SL;
                                        if (AItem^.Foot.Height <> H) then Point.Y:= Y + (H shr 1) - (AItem^.Foot.Height shr 1)
                                        else Point.Y:= Y;

                                        AItem^.Foot.Render(FBuffer, Point, A_OPAQUE, RM_COPY);
                                end;
                        end;

                        Inc(Y, H);
                end;
        end;
end;


procedure TAListbox.UpdateIndex;
var i, SL, ST, X, Y, H: Integer;
    Point: TPoint;
    AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SL:= Trunc(FLeftScroll*Integer(not FLeftScrolling) + FScrollRec.SmoothLeft*Integer(FLeftScrolling));
        ST:= Trunc(FTopScroll*Integer(not FTopScrolling) + FScrollRec.SmoothTop*Integer(FTopScrolling));

        X:= 0;
        Y:= 0;
        for i:= 0 to FCount-1 do
        begin
                AItem:= FList.Items[i];

                H:= 0;

                if (FListboxType and LBT_TEXT_ITEMHEIGHT <> 0) then
                begin
                        if (FListboxType and LBT_MULTILINE <> 0) then
                        begin
                                if (i = FIndex) then Point:= FontManager.FontStringSize(AItem^.FontSel, AItem^.Text)
                                else Point:= FontManager.FontStringSize(AItem^.Font, AItem^.Text);
                                H:= Point.Y;
                                X:= Max(X, Point.X);
                        end
                        else begin
                                if (i = FIndex) then Point:= FontManager.FontSize(AItem^.FontSel)
                                else Point:= FontManager.FontSize(AItem^.Font);
                                H:= Point.Y;
                                X:= Max(X, Point.X);
                        end;
                end;
                if (FListboxType and LBT_FOOT_ITEMHEIGHT <> 0)and(AItem^.Foot <> nil) then H:= Max(H, AItem^.Foot.Height);
                if (AItem^.Control <> nil) then
                begin
                        if (FListboxType and LBT_CONTROL_ITEMHEIGHT <> 0) then H:= Max(H, AItem^.Control.Height);

                        if (FTop + Y - ST + AItem^.Control.Height < 0)or(FTop + Y - ST > FHeight)or
                           (FLeft + AItem^.ControlOffset - SL + AItem^.Control.Width < 0)or(FLeft + AItem^.ControlOffset - SL > FWidth) then
                                AItem^.Control.Visible:= False
                        else begin
                                AItem^.Control.Visible:= True;
                                AItem^.Control.Move(FLeft + AItem^.ControlOffset - SL, FTop + Y - ST);
                        end;

                        X:= Max(X, AItem^.Control.Width);
                end;

                Inc(Y, H);
        end;

        SetWidthScroll(X);
        SetHeightScroll(Y);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.Load(ACountLeft, ACountTop, ATimeOutLeft, ATimeOutTop: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        FScrollRec.TimeOutLeft:= ATimeOutLeft;
        FScrollRec.TimeOutTop:= ATimeOutTop;

        FCountLeft:= ACountLeft;
        FCountTop:= ACountTop;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        StopLeftScroll;
        StopTopScroll;

        FCountLeft:= 0;
        FCountTop:= 0;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.AddItem(const AFont, AFontSel, AText: String; ATextOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;

        FList.Add(AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.AddItem(const AFont, AFontSel, AText: String; AFoot: TFoot; ATextOffset: Integer = 0; AFootOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Foot:= AFoot;
        AItem^.FootOffset:= AFootOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;

        FList.Add(AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.AddItem(const AFont, AFontSel, AText: String; AControl: TAControl; ATextOffset: Integer = 0; AControlOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;
        AItem^.Control:= AControl;
        AItem^.ControlOffset:= AControlOffset;

        if (AControl <> nil) then
        begin
                // update control properties to be in the list.
                AControl.Parent:= FParent;

                SetContainerFlags(FContainerFlags or CF_PARENT or CF_MOVE);
                AddContainerChild(AControl, CF_PARENT or CF_MOVE);
                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
                FLayerManager.AddMessageNotify(AM_MOUSE_DOWNL, AControl, Self);
        end;

        FList.Add(AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.AddItem(const AFont, AFontSel, AText: String; AFoot: TFoot; AControl: TAControl; ATextOffset: Integer = 0; AFootOffset: Integer = 0; AControlOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Foot:= AFoot;
        AItem^.FootOffset:= AFootOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;
        AItem^.Control:= AControl;
        AItem^.ControlOffset:= AControlOffset;

        if (AControl <> nil) then
        begin
                // update control properties to be in the list.
                AControl.Parent:= FParent;

                SetContainerFlags(FContainerFlags or CF_PARENT or CF_MOVE);
                AddContainerChild(AControl, CF_PARENT or CF_MOVE);
                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
                FLayerManager.AddMessageNotify(AM_MOUSE_DOWNL, AControl, Self);
        end;

        FList.Add(AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; ATextOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;

        FList.Insert(AIndex, AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AFoot: TFoot; ATextOffset: Integer = 0; AFootOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Foot:= AFoot;
        AItem^.FootOffset:= AFootOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;

        FList.Insert(AIndex, AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AControl: TAControl; ATextOffset: Integer = 0; AControlOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;
        AItem^.Control:= AControl;
        AItem^.ControlOffset:= AControlOffset;

        if (AControl <> nil) then
        begin
                // update control properties to be in the list.
                AControl.Parent:= FParent;

                SetContainerFlags(FContainerFlags or CF_PARENT or CF_MOVE);
                AddContainerChild(AControl, CF_PARENT or CF_MOVE);
                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
                FLayerManager.AddMessageNotify(AM_MOUSE_DOWNL, AControl, Self);
        end;

        FList.Insert(AIndex, AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.InsertItem(AIndex: Integer; const AFont, AFontSel, AText: String; AFoot: TFoot; AControl: TAControl; ATextOffset: Integer = 0; AFootOffset: Integer = 0; AControlOffset: Integer = 0);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        GetMem(AItem, SizeOf(TListboxItem));

        AItem^.Text:= AText;
        AItem^.TextOffset:= ATextOffset;
        AItem^.Foot:= AFoot;
        AItem^.FootOffset:= AFootOffset;
        AItem^.Font:= AFont;
        AItem^.FontSel:= AFontSel;
        AItem^.Control:= AControl;
        AItem^.ControlOffset:= AControlOffset;

        if (AControl <> nil) then
        begin
                // update control properties to be in the list.
                AControl.Parent:= FParent;

                SetContainerFlags(FContainerFlags or CF_PARENT or CF_MOVE);
                AddContainerChild(AControl, CF_PARENT or CF_MOVE);
                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
                FLayerManager.AddMessageNotify(AM_MOUSE_DOWNL, AControl, Self);
        end;

        FList.Insert(AIndex, AItem);
        Inc(FCount);

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAListbox.RemoveItem(AIndex: Integer);
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AIndex > -1)and(AIndex < FCount) then
        begin
                AItem:= FList.Items[AIndex];

                // update control properties to be out of the list.
                if (AItem^.Control <> nil) then
                begin
                        FLayerManager.RemoveMessageNotify(AM_SIZE, AItem^.Control, Self);
                        FLayerManager.RemoveMessageNotify(AM_MOUSE_DOWNL, AItem^.Control, Self);
                        RemoveContainerChild(AItem^.Control);

                        AItem^.Control.Parent:= nil;
                end;

                Finalize(AItem^.Text);
                FreeMem(AItem);
                FList.Delete(AIndex);
                Dec(FCount);

                UpdateIndex;
                Changed;
        end
        else begin
                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Removeitem index out of bounds.', 'TAListbox.RemoveItem', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

procedure TAListbox.Clear;
var AItem: PListboxItem;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // remove all items.
        while (FCount > 0) do
        begin
                AItem:= FList.Items[0];

                // update control properties to be out of the list.
                if (AItem^.Control <> nil) then
                begin
                        FLayerManager.RemoveMessageNotify(AM_SIZE, AItem^.Control, Self);
                        FLayerManager.RemoveMessageNotify(AM_MOUSE_DOWNL, AItem^.Control, Self);
                        RemoveContainerChild(AItem^.Control);

                        AItem^.Control.Parent:= nil;
                end;

                Finalize(AItem^.Text);
                FreeMem(AItem);
                FList.Delete(0);
                Dec(FCount);
        end;

        UpdateIndex;
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAListbox.FindItem(const AText: String; AControl: TAControl; ACaseSensitive: Boolean = True): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FCount)and
              ((not StringEqual(AText, PListboxItem(FList.Items[Result])^.Text, ACaseSensitive))or
              (AControl <> PListboxItem(FList.Items[Result])^.Control)) do
        Inc(Result);

        if (Result = FCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}
end;


function TAListbox.FindItem(const AText: String; ACaseSensitive: Boolean = True): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FCount)and
              (not StringEqual(AText, PListboxItem(FList.Items[Result])^.Text, ACaseSensitive)) do
        Inc(Result);

        if (Result = FCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAListbox.FindItem(AControl: TAControl): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FCount)and(AControl <> PListboxItem(FList.Items[Result])^.Control) do
                Inc(Result);

        if (Result = FCount) then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                  MENU                                    ##
//##############################################################################


{ TAMenu }




constructor TAMenu.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT, AControlType);



        FPopped:= False;

        

        FList:= TAList.Create;
        FCount:= 0;
end;


destructor TAMenu.Destroy;
begin
        Clear;

        FList.Free;



inherited;
end;


procedure TAMenu.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.ProcessMessage(Msg, WParam, LParam: Integer);
var AControl: TAControl;
    i: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_MESSAGE_NOTIFY:
          begin
                case WParam of
                 AM_SIZE: UpdateMenu;
                end;
          end;
          //
          AM_SET_PARENT:
          begin
                for i:= 0 to FCount-1 do
                begin
                        AControl:= FList.Items[i];

                        if (AControl <> nil) then
                        begin
                                AControl.Parent:= FParent;
                                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
                        end;
                end;
          end;
          //
          AM_RELEASE_PARENT:
          begin
                for i:= 0 to FCount-1 do
                begin
                        AControl:= FList.Items[i];

                        if (AControl <> nil) then
                        begin
                                AControl.Parent:= nil;
                                FLayerManager.RemoveMessageNotify(AM_SIZE, AControl, Self);
                        end;
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.UpdateMenu;
var i, X, Y: Integer;
    AControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        X:= 0;
        Y:= 0;
        for i:= 0 to FCount-1 do
        begin
                AControl:= FList.Items[i];

                AControl.Move(FLeft, FTop + Y);

                Inc(X, AControl.Width);
                Inc(Y, AControl.Height);
        end;

        Size(X, Y);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.Load(AMaxAlpha: Byte; ATimeOut: Integer; ASpeed: Extended = 0; AAcceleration: Extended = 0);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        FMaxAlpha:= AMaxAlpha;
        FTimeOut:= ATimeOut;
        FSpeed:= ASpeed;
        FAcceleration:= AAcceleration;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.Unload;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        StopAlphaAnimation;

        FTimeOut:= 0;
        FSpeed:= 0;
        FAcceleration:= 0;

        Unpop;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.Pop(AX, AY: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unpop;

        SetVisible(True);
        Move(AX, AY);

        if (FTimeOut <> 0) then StartAlphaAnimation(A_CLEAR, FMaxAlpha, FSpeed, FAcceleration, FTimeOut)
        else SetAlpha(FMaxAlpha);

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.Unpop;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        SetVisible(False);

        StopAlphaAnimation;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;

procedure TAMenu.AddItem(AControl: TAControl);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AControl <> nil) then
        begin
                // update control properties to be in the menu.
                AControl.Parent:= FParent;
                AControl.Alpha:= FAlpha;

                SetContainerFlags(FContainerFlags or CF_PARENT or CF_MOVE or CF_ALPHA);
                AddContainerChild(AControl, CF_PARENT or CF_MOVE or CF_ALPHA);
                FLayerManager.AddMessageNotify(AM_SIZE, AControl, Self);
        end;

        FList.Add(AControl);
        Inc(FCount);

        UpdateMenu;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.RemoveItem(AControl: TAControl);
var AIndex: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        AIndex:= FindItem(AControl);

        if (AIndex > -1) then
        begin
                // update control properties to be out of the list.
                if (AControl <> nil) then
                begin
                        FLayerManager.RemoveMessageNotify(AM_SIZE, AControl, Self);
                        RemoveContainerChild(AControl);

                        AControl.Parent:= nil;
                end;

                FList.Delete(AIndex);
                Dec(FCount);

                UpdateMenu;
        end
        else begin
                {$IFDEF THREADSAFE}
                 ThreadManager.ClearExclusive;
                {$ENDIF}

                (*++++++++++++++*)
                (**) RaiseException('Removeitem index out of bounds.', 'TAMenu.RemoveItem', Self);
                (*++++++++++++++*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAMenu.Clear;
var AControl: TAControl;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        // remove all items.
        while (FCount > 0) do
        begin
                AControl:= FList.Items[0];

                // update control properties to be out of the list.
                if (AControl <> nil) then
                begin
                        FLayerManager.RemoveMessageNotify(AM_SIZE, AControl, Self);
                        RemoveContainerChild(AControl);

                        AControl.Parent:= nil;
                end;

                FList.Delete(0);
                Dec(FCount);
        end;

        UpdateMenu;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAMenu.FindItem(AControl: TAControl): Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Result:= 0;
        while (Result < FCount)and(Integer(FList.Items[Result]) <> Integer(AControl)) do
              Inc(Result);

        if Result = FCount then Result:= -1;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
end;

//##############################################################################
//##############################################################################

End.
