(*==============*)
        // AN EVENT IS RAN
(*--------------*)
        // A MESSAGE IS POSTED OR SENT
(*++++++++++++++*)
        // AN EXCEPTION IS RAISED




// v4.0
//##############################################################################
//#######                             PRIMITIVES                          ######
//##############################################################################


        (*
          DEFINE THREADSAFE TO MAKE ALL THE OBJECTS THREADSAFE.
          || TAPanel
          || TAAnimation
          || TAButton
          || TARadio
          || TACheck
          || TAProgress
          || TATrack
        *)
        {$DEFINE THREADSAFE}


//##############################################################################
//#######                             PRIMITIVES                          ######
//##############################################################################
Unit UPrimitives;




        		//###############
        		//## INTERFACE ##
        		//###############
        		Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
        		//######################## SYSTEM ######################
                                		  {System,}
                                		  HWindows,
                                                  HMessages,
                                                  HMultimedia,

                        //######################################################
                        //######################### OWN ########################
                                                  AHeap,
                                                  ARoutine,
                                                  ADevices,
                                                  UCore,
                                                  UBasic,

                        //######################################################
                        //######################### FOOT #######################
                                                  Foot;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //################### TIMER CONSTANTS ##################

  TID_FIRST_PRIMITIVES = TID_LAST_BASIC + 1;
  TID_LAST_PRIMITIVES  = TID_FIRST_PRIMITIVES + 9;

                        //######################################################
                        //################ ANIMATION TIMERS  ###################

    TID_ANIMATION_STATE     = TID_FIRST_PRIMITIVES + 1;
    TID_ANIMATION_STATEFADE = TID_FIRST_PRIMITIVES + 2;
    TID_ANIMATION_FRAME     = TID_FIRST_PRIMITIVES + 3;
    TID_ANIMATION_FRAMEFADE = TID_FIRST_PRIMITIVES + 4;
    //
    TID_REPEAT_WAIT         = TID_FIRST_PRIMITIVES + 5;
    TID_REPEAT              = TID_FIRST_PRIMITIVES + 6;
    //
    TID_PROGRESS_SMOOTH     = TID_FIRST_PRIMITIVES + 7;
    //
    TID_TRACK_SMOOTH        = TID_FIRST_PRIMITIVES + 8;

                        //######################################################
                        //################## MESSAGE CONSTANTS #################

  AM_FIRST_PRIMITIVES = AM_LAST_BASIC + 1;
  AM_LAST_PRIMITIVES  = AM_FIRST_PRIMITIVES + 18;

                        //######################################################
                        //################### LAYER MESSAGES ###################

    AM_STATE_ANIMATION_START            = AM_FIRST_PRIMITIVES + 1;
    // || WParam = bypass the repeaters
    AM_STATE_ANIMATION_STOP             = AM_FIRST_PRIMITIVES + 2;
    AM_STATEFADE_ANIMATION_START        = AM_FIRST_PRIMITIVES + 3;
    // || WParam = bypass the repeaters
    AM_STATEFADE_ANIMATION_STOP         = AM_FIRST_PRIMITIVES + 4;
    //
    AM_FRAME_ANIMATION_START            = AM_FIRST_PRIMITIVES + 5;
    // || WParam = bypass the repeaters
    AM_FRAME_ANIMATION_STOP             = AM_FIRST_PRIMITIVES + 6;
    AM_FRAMEFADE_ANIMATION_START        = AM_FIRST_PRIMITIVES + 7;
    // || WParam = bypass the repeaters
    AM_FRAMEFADE_ANIMATION_STOP         = AM_FIRST_PRIMITIVES + 8;
    //
    AM_PUSH                             = AM_FIRST_PRIMITIVES + 9;
    AM_DISABLED_CHANGE                  = AM_FIRST_PRIMITIVES + 10;
    AM_ACTIVE_CHANGE                    = AM_FIRST_PRIMITIVES + 11;
    //
    // || WParam = activated (object)
    // || LParam = group id
    AM_RADIO                            = AM_FIRST_PRIMITIVES + 12;
    //
    AM_PROGRESS_START                   = AM_FIRST_PRIMITIVES + 13;
    AM_PROGRESS_STOP                    = AM_FIRST_PRIMITIVES + 14;
    AM_PROGRESS_CHANGE                  = AM_FIRST_PRIMITIVES + 15;
    //
    AM_TRACK_START                      = AM_FIRST_PRIMITIVES + 16;
    AM_TRACK_STOP                       = AM_FIRST_PRIMITIVES + 17;
    AM_TRACK_CHANGE                     = AM_FIRST_PRIMITIVES + 18;

                        //######################################################
                        //##################### ORIENTATION ####################

  O_HORIZONTAL = 1;  //01
  O_VERTICAL   = 3;  //11

                        //######################################################
                        //###################### DIRECTION #####################

  D_FORWARD    = 1;
  D_BACKWARD   = -1;

                        //######################################################
                        //################### ANIMATION TYPES ##################

  //# animation repeaters
  ATR_STATE_CIRCULAR  = 1;     //000000001
  ATR_STATE_FLIPFLOP  = 3;     //000000011
  ATR_STATE_ALL       = 3;     //000000011       // reserved
  ATR_FRAME_CIRCULAR  = 4;     //000000100
  ATR_FRAME_FLIPFLOP  = 12;    //000001100
  ATR_FRAME_ALL       = 12;    //000001100       // reserved
  ATR_ALL             = 15;    //000001111       // reserved
  //
  //# animation waits
  ATW_STATE_FRAMECHANGE  = 16;    //00010000
  ATW_STATE_FRAMESTOP    = 48;    //00110000
  ATW_STATE_ALL          = 48;    //00110000       // reserved
  ATW_FRAME_STATECHANGE  = 64;    //01000000
  ATW_FRAME_STATESTOP    = 192;   //11000000
  ATW_FRAME_ALL          = 192;   //11000000       // reserved
  ATW_ALL                = 240;   //11110000       // reserved

                        //######################################################
                        //#################### BUTTON TYPES ####################

  BT_PUSH       = 4;
  BT_TOGGLE     = 8;

                        //######################################################
                        //############### BUTTON ANIMATION TYPES ###############

  BAT_STATE_FADE              = 1;
  BAT_FRAME_FADE              = 2;
  //#
  // animation repeaters
  BATR_FRAME_CIRCULAR          = 4;
  BATR_FRAME_FLIPFLOP          = 8;
  BATR_FRAME_FORWARD           = 0;
  BATR_FRAME_ALL               = 12;
  //#
  // animation triggers
  BATT_FRAME_HOVER             = 32;
  BATT_FRAME_DOWN              = 64;
  BATT_FRAME_HOVERDOWN         = 96;
  BATT_FRAME_ACTIVE            = 128;
  BATT_FRAME_ALL               = 224;

                        //######################################################
                        //##################### BUTTON STATES ##################

  BSP_UP         = 0;
  BSP_HOVER      = 1;
  BSP_DOWN       = 2;
  BSP_DISABLED   = 3;
  //#
  // toggle button states
  BST_ACTIVE_UP         = 0;
  BST_ACTIVE_HOVER      = 1;
  BST_ACTIVE_DOWN       = 2;
  BST_ACTIVE_DISABLED   = 3;
  BST_INACTIVE_UP       = 4;
  BST_INACTIVE_HOVER    = 5;
  BST_INACTIVE_DOWN     = 6;
  BST_INACTIVE_DISABLED = 7;

                        //######################################################
                        //################## BUTTON FRAMEANIMATION #############

  BFA_NONE              = 0;
  BFA_FORWARD_0         = 1;
  BFA_FORWARD_FC        = 2;
  BFA_CIRCULAR_FC       = 3;
  BFA_CIRCULAR_0_STOP   = 4;
  BFA_FLIPFLOP_FC       = 5;
  BFA_FLIPFLOP_FC_STOP  = 6;
  BFA_FLIPFLOP_0        = 7;
  BFA_FLIPFLOP_0_STOP   = 8;


                        //######################################################
                        //################### PROGRESS TYPES ###################

  PT_BAR          = 1;
  PT_CURSOR       = 2;
  PT_FRAMED       = 4;

                        //######################################################
                        //############## PROGRESS ANIMATION TYPES ##############

  PAT_FORWARD          = 0;
  PAT_CIRCULAR         = 1;
  PAT_FLIPFLOP         = 2;

                        //######################################################
                        //##################### TRACK TYPES ####################

  TT_PUSH            = 4;
  TT_TOGGLE          = 8;
  TT_FRAMED_FORWARD  = 16;
  TT_FRAMED_CIRCULAR = 32;
  TT_FRAMED_ALL      = 48;

                        //######################################################
                        //################ TRACK ANIMATION TYPES ###############

  TAT_STATE_FADE              = 1;
  TAT_FRAME_FADE              = 2;
  //#
  // animation repeaters
  TATR_FRAME_CIRCULAR          = 4;
  TATR_FRAME_FLIPFLOP          = 8;
  TATR_FRAME_FORWARD           = 0;
  TATR_FRAME_ALL               = 12;
  //#
  // animation triggers
  TATT_FRAME_HOVER             = 32;
  TATT_FRAME_DOWN              = 64;
  TATT_FRAME_HOVERDOWN         = 96;
  TATT_FRAME_ACTIVE            = 128;
  TATT_FRAME_ALL               = 224;

                        //######################################################
                        //###################### TRACK STATES ##################

  TSP_UP         = 0;
  TSP_HOVER      = 1;
  TSP_DOWN       = 2;
  TSP_DISABLED   = 3;
  //#
  // toggle trackbar states
  TST_ACTIVE_UP         = 0;
  TST_ACTIVE_HOVER      = 1;
  TST_ACTIVE_DOWN       = 2;
  TST_ACTIVE_DISABLED   = 3;
  TST_INACTIVE_UP       = 4;
  TST_INACTIVE_HOVER    = 5;
  TST_INACTIVE_DOWN     = 6;
  TST_INACTIVE_DISABLED = 7;




                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //#################### ANIMATION STRUCT ################

  TAnimationRec = record
    Src,
    Dest: Integer;
    //#
    TimeOut: Integer;
    //#
    StateFrame: Integer;
    StateFrameStop: Boolean;
    //#
    Bypass: Boolean;
  end;

                        //######################################################
                        //################# FADE ANIMATION STRUCT ##############

  TFadeAnimationRec = record
    Src,
    Dest: Integer;
    Speed,
    Acceleration: Extended;
    //#
    Frame: Integer;
    BlankFrameMax,
    BlankFrameCount: Integer;
    //#
    Alpha: Byte;
    TimeOut: Integer;
    //#
    Bypass: Boolean;
  end;

                        //######################################################
                        //############## PROGRESS ANIMATION STRUCT #############

  TProgressRec = record
    SmoothProgress,
    SmoothProgressInc: Extended;
    //#
    TimeOut: Integer;
  end;

                        //######################################################
                        //############## TRACKBAR ANIMATION STRUCT #############

  TTrackRec = record
    SmoothValue,
    SmoothValueInc: Extended;
    //#
    TimeOut: Integer;
  end;

                        //######################################################
                        //################## ANIMATION METHODS #################

  TSuspendResume = procedure of object;
  TStop = function(Bypass: Boolean = False): Boolean of object;

                        //######################################################
                        //####################### CLASS TYPES ##################

  TAPanel = class;
  //#
  TAAnimation = class;
  //#
  TAButton = class;
  TARadio = class;
  TACheck = class;
  //#
  TAProgress = class;
  //#
  TATrack = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                  PANEL                                   ##
//##############################################################################




  TAPanel = class(TAControl)
  protected
    procedure SetBufferType(ABufferType: Integer); override;
(*============================================================================*)
  public
    //#
    //#
    // you can load both foot and tilefoot. if a foot is loaded then the
    // BT_RESIZE property will be disabled until the buffertype is changed to
    // BT_TILEFOOT or a tilefoot is loaded.
    procedure Load(const AFileName: String);
    procedure UnLoad;
  end;




//##############################################################################
//##                                ANIMATION                                 ##
//##############################################################################




  // THE ANIMATION HAS A NUMBER OF STATES IN BETWEEN YOU CAN SWITCH WITH FADE OR
  // WITHOUT. EACH STATE CAN HAVE MORE THAN ONE FRAME WHICH IT CAN SWITCH BETWEEN
  // WITH FADE OR WITHOUT. REPEATERS CAN BE SET TO MAKE AN ANIMATION START OVER WHEN
  // IT STOPS. REPEATERS WILL CONTINUE THE ANIMATION BETWEEN THE FRAMES OR STATES
  // SPECIFIED IN THE STARTANIMATION CALL BUT WILL NOT START THE ANIMAITON ITSELF.
  // YOU CAN'T CHANGE STATE OR FRAME WHILE RESPECTIVE ANIMATION IN PROGRESS.

  TAAnimation = class(TAControl)
  protected
    FStateAnimating,
    FStateFadeAnimating,
    FFrameAnimating,
    FFrameFadeAnimating: Boolean;
    FStateAnimationRec: TAnimationRec;
    FStateFadeAnimationRec: TFadeAnimationRec;
    FFrameAnimationRec: TAnimationRec;
    FFrameFadeAnimationRec: TFadeAnimationRec;
    //#
    FState,
    FStateCount,
    FFrame,
    FFrameCount: Integer;
    //#
    // composed of repeaters and waits.
    FAnimationType: Integer;
    //#
    //#
    // the size that the buffer should have.
    FAnimationWidth,
    FAnimationHeight: Integer;
    FAnimationBuffer: TFoot;
    // the orientation of the states and frames in the foot.
    FOrientation: Integer;
    //#
    //#
    // used to make the fade composition between the frames of different states.
    FFadeBuffer: TFoot;
    //#
    // animation needs to set the state or frame to the source on first run.
    FStateFirst,
    FFrameFirst: Boolean;
(*============================================================================*)
    FOnStateAnimationStart,              //# RAN ON MESSAGE
    FOnStateAnimating,                   //# RAN ON MESSAGE
    FOnStateAnimationStop,               //# RAN ON MESSAGE
    FOnStateFadeAnimationStart,          //# RAN ON MESSAGE
    FOnStateFadeAnimating,               //# RAN ON MESSAGE
    FOnStateFadeAnimationStop,           //# RAN ON MESSAGE
    FOnFrameAnimationStart,              //# RAN ON MESSAGE
    FOnFrameAnimating,                   //# RAN ON MESSAGE
    FOnFrameAnimationStop,               //# RAN ON MESSAGE
    FOnFrameFadeAnimationStart,          //# RAN ON MESSAGE
    FOnFrameFadeAnimating,               //# RAN ON MESSAGE
    FOnFrameFadeAnimationStop: TOnEvent; //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    //#
    procedure SetState(AState: Integer);
    procedure SetFrame(AFrame: Integer);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateAnimation;
    //#
    class procedure RunAnimation(ASelf: TAControl; Suspend, Resume: TSuspendResume; Stop: TStop; var Struct: TAnimationRec; var X, Y: Integer; AAnimationType, WAll, WChange, WStop: Integer; var AFirst: Boolean);
    class procedure RunFadeAnimation(ASelf: TAControl; Suspend, Resume: TSuspendResume; Stop: TStop; var Struct: TAnimationRec; var FadeStruct: TFadeAnimationRec; var X, Y: Integer; AAnimationType, WAll, WChange, WStop: Integer; var AFirst: Boolean);
    //#
    procedure SuspendStateAnimation;
    procedure SuspendFrameAnimation;
    procedure ResumeStateAnimation;
    procedure ResumeFrameAnimation;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // you can load only foot. BT_RESIZE will be excluded from buffertype.
    procedure Load(const AFileName: String; AStateCount, AFrameCount: Integer; AOrientation: Integer);
    procedure UnLoad;
    //#
    //#
    function StartStateAnimation(ASrcState, ADestState: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopStateAnimation(Bypass: Boolean = False): Boolean;
    property StateAnimating: Boolean read FStateAnimating;
    property StateAnimationRec: TAnimationRec read FStateAnimationRec;
    //#
    function StartStateFadeAnimation(ASrcState, ADestState: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopStateFadeAnimation(Bypass: Boolean = False): Boolean;
    property StateFadeAnimating: Boolean read FStateFadeAnimating;
    property StateFadeAnimationRec: TFadeAnimationRec read FStateFadeAnimationRec;
    //#
    function StartFrameAnimation(ASrcFrame, ADestFrame: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopFrameAnimation(Bypass: Boolean = False): Boolean;
    property FrameAnimating: Boolean read FFrameAnimating;
    property FrameAnimationRec: TAnimationRec read FFrameAnimationRec;
    //#
    function StartFrameFadeAnimation(ASrcFrame, ADestFrame: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopFrameFadeAnimation(Bypass: Boolean = False): Boolean;
    property FrameFadeAnimating: Boolean read FFrameFadeAnimating;
    property FrameFadeAnimationRec: TFadeAnimationRec read FFrameFadeAnimationRec;
    //#
    property State: Integer read FState write SetState;
    property StateCount: Integer read FStateCount;
    property Frame: Integer read FFrame write SetFrame;
    property FrameCount: Integer read FFrameCount;
    //#
    property AnimationType: Integer read FAnimationType write FAnimationType;
    //#
    //#
    // properties that can be set only when loading the control.
    property AnimationWidth: Integer read FAnimationWidth;
    property AnimationHeight: Integer read FAnimationHeight;
    property AnimationBuffer: TFoot read FAnimationBuffer;
    //#
    property Orientation: Integer read FOrientation;
(*============================================================================*)
    property OnStateAnimationStart: TOnEvent read FOnStateAnimationStart write FOnStateAnimationStart;
    property OnStateAnimating: TOnEvent read FOnStateAnimating write FOnStateAnimating;
    property OnStateAnimationStop: TOnEvent read FOnStateAnimationStop write FOnStateAnimationStop;
    property OnStateFadeAnimationStart: TOnEvent read FOnStateFadeAnimationStart write FOnStateFadeAnimationStart;
    property OnStateFadeAnimating: TOnEvent read FOnStateFadeAnimating write FOnStateFadeAnimating;
    property OnStateFadeAnimationStop: TOnEvent read FOnStateFadeAnimationStop write FOnStateFadeAnimationStop;
    property OnFrameAnimationStart: TOnEvent read FOnFrameAnimationStart write FOnFrameAnimationStart;
    property OnFrameAnimating: TOnEvent read FOnFrameAnimating write FOnFrameAnimating;
    property OnFrameAnimationStop: TOnEvent read FOnFrameAnimationStop write FOnFrameAnimationStop;
    property OnFrameFadeAnimationStart: TOnEvent read FOnFrameFadeAnimationStart write FOnFrameFadeAnimationStart;
    property OnFrameFadeAnimating: TOnEvent read FOnFrameFadeAnimating write FOnFrameFadeAnimating;
    property OnFrameFadeAnimationStop: TOnEvent read FOnFrameFadeAnimationStop write FOnFrameFadeAnimationStop;
  end;




//##############################################################################
//##                                  BUTTON                                  ##
//##############################################################################



  // BUTTONS ARE LIKE ANIMATIONS EXCEPT ONLY FRAME ANIMATIONS CAN BE STARTED MANUALLY.
  // IF A REPEATER IS SELECTED THEN THE ANIMATION WILL START AUTOMATICALLY.

  // UP | HOVER | DOWN | DISABLED

  // UP | HOVER | DOWN | DISABLED || UP | HOVER | DOWN | DISABLED
  // 
  //          ACTIVE              ||          INACTIVE

  TAButton = class(TAControl)
  protected
    FStateFadeAnimating,
    FFrameAnimating,
    FFrameFadeAnimating: Boolean;
    FStateFadeAnimationRec: TFadeAnimationRec;
    FFrameAnimationRec: TAnimationRec;
    FFrameFadeAnimationRec: TFadeAnimationRec;
    //#
    FState: Integer;
    FStateCount: Integer;
    FFrame,
    FFrameCount: Integer;
    //#
    // composed of repeaters, triggers and fade flags.
    FAnimationType: Integer;
    FDisabled,
    FActive: Boolean;
    FRepeatWait, // the amount of time to wait until repeat begins.
    FRepeatInt: Integer; // the interval between repeated mouseupevents.
    //#
    //#
    // the size that the buffer should have.
    FButtonWidth,
    FButtonHeight: Integer;
    FButtonBuffer: TFoot;
    // the orientation of the states and frames in the foot.
    FOrientation: Integer;
    //#
    //#
    // used to make the fade composition between the frames of different states.
    FFadeBuffer: TFoot;
    //#
    // animation needs to set the state or frame to the source on first run.
    FFrameFirst: Boolean;
    //#
    // the button is repeating the push event.
    FRepeating: Boolean;
    //#
    // no deactivation by mouse.
    FRadio: Boolean;
    //#
    // for repeating animations it tells which animation will start
    // after the current is completed or if it should stop.
    FFrameAnimation: Integer;
(*============================================================================*)
    FOnStateFadeAnimationStart,          //# RAN ON MESSAGE
    FOnStateFadeAnimating,               //# RAN ON MESSAGE
    FOnStateFadeAnimationStop,           //# RAN ON MESSAGE
    FOnFrameAnimationStart,              //# RAN ON MESSAGE
    FOnFrameAnimating,                   //# RAN ON MESSAGE
    FOnFrameAnimationStop,               //# RAN ON MESSAGE
    FOnFrameFadeAnimationStart,          //# RAN ON MESSAGE
    FOnFrameFadeAnimating,               //# RAN ON MESSAGE
    FOnFrameFadeAnimationStop: TOnEvent; //# RAN ON MESSAGE
    //#
    FOnPush,                             //# RAN ON MESSAGE
    FOnActiveChange,                     //# RAN ON MESSAGE
    FOnDisabledChange: TOnEvent;         //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    //#
    procedure SetAnimationType(AAnimationType: Integer);
    //#
    procedure SetActive(AActive: Boolean);
    procedure SetDisabled(ADisabled: Boolean);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateAnimation;
    procedure UpdateButton; virtual;
    procedure UpdateState;
    //#
    function StartStateFadeAnimation(ASrcState, ADestState: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer): Boolean;
    function StopStateFadeAnimation: Boolean;
    //#
    procedure Start;
    procedure Stop;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // you can load only foot. BT_RESIZE will be excluded from buffertype.
    procedure Load(const AFileName: String; AButtonType, AFrameCount: Integer; AOrientation: Integer; AStateSpeed: Extended = 0; AStateAcceleration: Extended = 0; AStateTimeOut: Integer = 0; AFrameSpeed: Extended = 0; AFrameAcceleration: Extended = 0; AFrameTimeOut: Integer = 0);
    procedure UnLoad;
    //#
    //#
    property StateFadeAnimating: Boolean read FStateFadeAnimating;
    property StateFadeAnimationRec: TFadeAnimationRec read FStateFadeAnimationRec;
    //#
    function StartFrameAnimation(ASrcFrame, ADestFrame: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopFrameAnimation(Bypass: Boolean = False): Boolean;
    property FrameAnimating: Boolean read FFrameAnimating;
    property FrameAnimationRec: TAnimationRec read FFrameAnimationRec;
    //#
    function StartFrameFadeAnimation(ASrcFrame, ADestFrame: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
    function StopFrameFadeAnimation(Bypass: Boolean = False): Boolean;
    property FrameFadeAnimating: Boolean read FFrameFadeAnimating;
    property FrameFadeAnimationRec: TFadeAnimationRec read FFrameFadeAnimationRec;
    //#
    property State: Integer read FState;
    property StateCount: Integer read FStateCount;
    property Frame: Integer read FFrame;
    property FrameCount: Integer read FFrameCount;
    //#
    property AnimationType: Integer read FAnimationType write SetAnimationType;
    property Active: Boolean read FActive write SetActive;
    property Disabled: Boolean read FDisabled write SetDisabled;
    property RepeatWait: Integer read FRepeatWait write FRepeatWait;
    property RepeatInt: Integer read FRepeatInt write FRepeatInt;
    //#
    //#
    // properties that can be set only when loading the control.
    property ButtonWidth: Integer read FButtonWidth;
    property ButtonHeight: Integer read FButtonHeight;
    property ButtonBuffer: TFoot read FButtonBuffer;
    //#
    property ButtonType: Integer read FStateCount;
    property Orientation: Integer read FOrientation;
(*============================================================================*)
    property OnStateFadeAnimationStart: TOnEvent read FOnStateFadeAnimationStart write FOnStateFadeAnimationStart;
    property OnStateFadeAnimating: TOnEvent read FOnStateFadeAnimating write FOnStateFadeAnimating;
    property OnStateFadeAnimationStop: TOnEvent read FOnStateFadeAnimationStop write FOnStateFadeAnimationStop;
    property OnFrameAnimationStart: TOnEvent read FOnFrameAnimationStart write FOnFrameAnimationStart;
    property OnFrameAnimating: TOnEvent read FOnFrameAnimating write FOnFrameAnimating;
    property OnFrameAnimationStop: TOnEvent read FOnFrameAnimationStop write FOnFrameAnimationStop;
    property OnFrameFadeAnimationStart: TOnEvent read FOnFrameFadeAnimationStart write FOnFrameFadeAnimationStart;
    property OnFrameFadeAnimating: TOnEvent read FOnFrameFadeAnimating write FOnFrameFadeAnimating;
    property OnFrameFadeAnimationStop: TOnEvent read FOnFrameFadeAnimationStop write FOnFrameFadeAnimationStop;
    //#
    property OnPush: TOnEvent read FOnPush write FOnPush;
    property OnActiveChange: TOnEvent read FOnActiveChange write FOnActiveChange;
    property OnDisabledChange: TOnEvent read FOnDisabledChange write FOnDisabledChange;
  end;




//##############################################################################
//##                                  RADIO                                   ##
//##############################################################################




  TARadio = class(TAButton)
  protected
    FGroup: Integer;
(*============================================================================*)
    procedure SetGroup(AGroup: Integer);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
(*============================================================================*)
  public
    property StateFadeAnimating;
    property StateFadeAnimationRec;
    property FrameAnimating;
    property FrameAnimationRec;
    property FrameFadeAnimating;
    property FrameFadeAnimationRec;
    //#
    property State;
    property StateCount;
    property Frame;
    property FrameCount;
    //#
    property AnimationType;
    property Active;
    property Disabled;
    property RepeatWait;
    property RepeatInt;
    property Group: Integer read FGroup write SetGroup;
    //#
    //#
    // properties that can be set only when loading the control.
    property ButtonWidth;
    property ButtonHeight;
    property ButtonBuffer;
    //#
    property ButtonType;
    property Orientation;
(*============================================================================*)
    property OnStateFadeAnimationStart;
    property OnStateFadeAnimating;
    property OnStateFadeAnimationStop;
    property OnFrameAnimationStart;
    property OnFrameAnimating;
    property OnFrameAnimationStop;
    property OnFrameFadeAnimationStart;
    property OnFrameFadeAnimating;
    property OnFrameFadeAnimationStop;
    //#
    property OnPush;
    property OnActiveChange;
    property OnDisabledChange;
  end;




//##############################################################################
//##                                  CHECK                                   ##
//##############################################################################




  TACheck = class(TAButton)
  protected
  public
  end;




//##############################################################################
//##                                 PROGRESS                                 ##
//##############################################################################




  // PROGRESS WILL UPDATE TO THE REAL POSITION WHEN SETTING PROGRESS. IF TIMEOUT
  // IS <> 0 THEN A SMOOTH ANIMATION WILL MOVE THE SLIDER ONE PIXEL / TIMEOUT.
  // UNDETERMINED MEANS THAT THE PROGRESS WILL RUN WITHOUT MODIFYING YOU HAVING
  // TO MODIFY PROGRESS. RUN START TO BEGIN AN UNDETERMINED ANIMATION. WHEN
  // UNDETERMINED THE MAXVALUE WILL BE SET TO A VALUE > 0 AND WON'T BE CHANGEABLE
  // UNTIL SET TO FALSE. IF THE CURSOR IS LONGER THEN THE WIDTH OR HEIGHT
  // THEN ANIMATION DIFFERS.

  TAProgress = class(TAControl)
  protected
    FProgressing: Boolean;
    FProgressRec: TProgressRec;
    FFrameCount: Integer;
    //#
    // flip flop or circular.
    FAnimationType: Integer;
    // progress runs without increasing the value.
    FUndetermined: Boolean;
    FMinValue,
    FMaxValue,
    FProgress: Integer;
    //#
    //#
    FProgressWidth,
    FProgressHeight: Integer;
    FProgressBuffer: TFoot;
    // bar, cursor or framed.
    FProgressType: Integer;
    // the orientation of the foot or of the progress.
    FOrientation: Integer;
    // times progress completes and starts over.
    FCount: Integer;
(*============================================================================*)
    FOnProgressStart,                    //# RAN ON MESSAGE
    FOnProgressing,                      //# RAN ON MESSAGE
    FOnProgressStop,                     //# RAN ON MESSAGE
    FOnProgressChange: TOnEvent;         //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    //#
    procedure SetMinValue(AMinValue: Integer);
    procedure SetMaxValue(AMaxValue: Integer);
    procedure SetProgress(AProgress: Integer);
    //#
    procedure SetUndetermined(AUndetermined: Boolean);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateProgress;
    procedure UpdateSmoothInc;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // you can load only foot. BT_RESIZE will be excluded from buffertype.
    procedure Load(const AFileName: String; AFrameCount: Integer; AProgressType, AOrientation: Integer; ACount, ATimeOut: Integer);
    procedure Unload;
    //#
    //#
    function StartProgress: Boolean;
    function StopProgress: Boolean;
    property Progressing: Boolean read FProgressing;
    property ProgressRec: TProgressRec read FProgressRec;
    //#
    property FrameCount: Integer read FFrameCount;
    //#
    property AnimationType: Integer read FAnimationType write FAnimationType;
    property Undetermined: Boolean read FUndetermined write SetUndetermined;
    property MinValue: Integer read FMinValue write SetMinValue;
    property MaxValue: Integer read FMaxValue write SetMaxValue;
    property Progress: Integer read FProgress write SetProgress;
    //#
    //#
    // properties that can be set only when loading the control.
    property ProgressWidth: Integer read FProgressWidth;
    property ProgressHeight: Integer read FProgressHeight;
    property ProgressBuffer: TFoot read FProgressBuffer;
    //#
    property ProgressType: Integer read FProgressType;
    property Orientation: Integer read FOrientation;
    property Count: Integer read FCount;
(*============================================================================*)
    property OnProgressStart: TOnEvent read FOnProgressStart write FOnProgressStart;
    property OnProgressing: TOnEvent read FOnProgressing write FOnProgressing;
    property OnProgressStop: TOnEvent read FOnProgressStop write FOnProgressStop;
    property OnProgressChange: TOnEvent read FOnProgressChange write FOnProgressChange;
  end;




//##############################################################################
//##                                 TRACKBAR                                 ##
//##############################################################################




  // TRACKBAR WILL UPDATE TO THE REAL POSITION WHEN SETTING VALUE. IF TIMEOUT
  // IS <> 0 THEN A SMOOTH ANIMATION WILL MOVE THE SLIDER ONE PIXEL / TIMEOUT.

  TATrack = class(TAButton)
  protected
    FTracking: Boolean;
    FTrackRec: TTrackRec;
    //#
    FMinValue,
    FMaxValue,
    FValue: Integer;
    //#
    //#
    // stateorientation for push and toggle.
    FFrameOrientation: Integer;
    // how many times increase smooth speed.
    FCount: Integer;
    //#
    //#
    // used to calculate the angle for framed circle progress.
    Ft1, Ft2: Extended;
    FSetting: Boolean;
(*============================================================================*)
    FOnTrackStart,                       //# RAN ON MESSAGE
    FOnTracking,                         //# RAN ON MESSAGE
    FOnTrackStop,                        //# RAN ON MESSAGE
    FOnTrackChange: TOnEvent;                 //# RAN ON MESSAGE
(*============================================================================*)
    procedure SetBufferType(ABufferType: Integer); override;
    //#
    procedure SetMinValue(AMinValue: Integer);
    procedure SetMaxValue(AMaxValue: Integer);
    procedure SetValue(AValue: Integer);
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
    //#
    procedure Paint; override;
    //#
    procedure UpdateButton; override;
    procedure UpdateFrameOrientation;
    procedure UpdateSmoothInc;
    //#
    function StartTrack: Boolean;
    function StopTrack: Boolean;
(*============================================================================*)
  public
    constructor Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer); override;
    destructor Destroy; override;
    //#
    //#
    // you can load only foot. BT_RESIZE will be excluded from buffertype.
    procedure Load(const AFileName: String; ATrackType, AFrameCount: Integer; AOrientation, AFrameOrientation: Integer; ACount, ATimeOut: Integer; AStateSpeed: Extended = 0; AStateAcceleration: Extended = 0; AStateTimeOut: Integer = 0; AFrameSpeed: Extended = 0; AFrameAcceleration: Extended = 0; AFrameTimeOut: Integer = 0);
    procedure UnLoad;
    //#
    //#
    property StateFadeAnimating;
    property StateFadeAnimationRec;
    property FrameAnimating;
    property FrameAnimationRec;
    property FrameFadeAnimating;
    property FrameFadeAnimationRec;
    property Tracking: Boolean read FTracking;
    //#
    property State;
    property StateCount;
    property Frame;
    property FrameCount;
    //#
    property AnimationType;
    property Active;
    property Disabled;
    property RepeatWait;
    property RepeatInt;
    //#
    property MinValue: Integer read FMinValue write SetMinValue;
    property MaxValue: Integer read FMaxValue write SetMaxValue;
    property Value: Integer read FValue write SetValue;
    //#
    //#
    // properties that can be set only when loading the control.
    property TrackWidth: Integer read FButtonWidth;
    property TrackHeight: Integer read FButtonHeight;
    property TrackBuffer: TFoot read FButtonBuffer;
    //#
    property TrackType: Integer read FStateCount;
    property FrameOrientation: Integer read FFrameOrientation;
    property Orientation;
    property Count: Integer read FCount;
(*============================================================================*)
    property OnStateFadeAnimationStart;
    property OnStateFadeAnimating;
    property OnStateFadeAnimationStop;
    property OnFrameAnimationStart;
    property OnFrameAnimating;
    property OnFrameAnimationStop;
    property OnFrameFadeAnimationStart;
    property OnFrameFadeAnimating;
    property OnFrameFadeAnimationStop;
    //#
    property OnPush;
    property OnActiveChange;
    property OnDisabledChange;
    //#
    property OnTrackStart: TOnEvent read FOnTrackStart write FOnTrackStart;
    property OnTracking: TOnEvent read FOnTracking write FOnTracking;
    property OnTrackStop: TOnEvent read FOnTrackStop write FOnTrackStop;
    property OnTrackChange: TOnEvent read FOnTrackChange write FOnTrackChange;
  end;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Init;
procedure Final;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




//##############################################################################
//##                                  PANEL                                   ##
//##############################################################################


{ TAPanel }




procedure TAPanel.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ABufferType and BT_FOOT <> 0) then ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAPanel.Load(const AFileName: String);
var Ext: String;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                Ext:= StringUpper(FileExtractExt(AFileName));
                if (Ext = 'TF') then SetBufferType(BT_TILEFOOT)
                else if (Ext = 'F')or(Ext = 'BMP') then SetBufferType(BT_FOOT);

                FBuffer.Load(AFileName);

                // invalidate the control.
                Changed;
                UpdateConstraints;

                (*{}{}{}{}{}{}{}*)
                (**) UpdateRgnList;
                (*{}{}{}{}{}{}{}*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAPanel.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FBufferType and BT_TILEFOOT <> 0) then TTileFoot(FBuffer).TileEmpty:= True;
        FBuffer.Empty:= True;

        // invalidate the control.
        Changed;
        UpdateConstraints;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                ANIMATION                                 ##
//##############################################################################


{ TAAnimation }




constructor TAAnimation.Create(const AName: String; AParent: TAForm; ABufferType: Integer; AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT or BT_RESIZE, AControlType);



        FStateAnimating:= False;
        FStateFadeAnimating:= False;
        FFrameAnimating:= False;
        FFrameFadeAnimating:= False;

        FState:= 0;
        FFrame:= 0;
        FStateCount:= 0;
        FFrameCount:= 0;



        FFadeBuffer:= TFoot.Create;

        FStateFirst:= False;
        FFrameFirst:= False;



        FOrientation:= 0;

        FAnimationWidth:= 0;
        FAnimationHeight:= 0;
        FAnimationBuffer:= TFoot.Create;
end;


destructor TAAnimation.Destroy;
begin
        FFadeBuffer.Free;

        FAnimationBuffer.Free;

        StopStateAnimation(True);
        StopStateFadeAnimation(True);
        StopFrameAnimation(True);
        StopFrameFadeAnimation(True);



inherited;
end;


procedure TAAnimation.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.SetState(AState: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AState, 0, FStateCount - 1);

        if (AState <> FState)and(not FStateAnimating)and(not FStateFadeAnimating) then
        begin
                FState:= AState;


                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.SetFrame(AFrame: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AFrame, 0, FFrameCount - 1);

        if (AFrame <> FFrame)and(not FFrameAnimating)and(not FFrameFadeAnimating) then
        begin
                FFrame:= AFrame;


                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.ProcessMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_STATE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnStateAnimationStart)) then FOnStateAnimationStart(Self);
                (*==============*)
          //
          AM_STATE_ANIMATION_STOP:
          begin
                if (not Boolean(WParam)) then
                case (FAnimationType and ATR_STATE_ALL) of
                  ATR_STATE_CIRCULAR: StartStateAnimation(FStateAnimationRec.Src, FStateAnimationRec.Dest, FStateAnimationRec.TimeOut);
                  ATR_STATE_FLIPFLOP: StartStateAnimation(FStateAnimationRec.Dest, FStateAnimationRec.Src, FStateAnimationRec.TimeOut);
                end;

                FFrameAnimationRec.StateFrameStop:= True;
                ResumeFrameAnimation;

                (*==============*)
                (**) if (Assigned(FOnStateAnimationStop)) then FOnStateAnimationStop(Self);
                (*==============*)
          end;
          //
          AM_STATEFADE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnStateFadeAnimationStart)) then FOnStateFadeAnimationStart(Self);
                (*==============*)
          //
          AM_STATEFADE_ANIMATION_STOP:
          begin
                if (not Boolean(WParam)) then
                case (FAnimationType and ATR_STATE_ALL) of
                  ATR_STATE_CIRCULAR: StartStateFadeAnimation(FStateAnimationRec.Src, FStateAnimationRec.Dest, A_CLEAR, FStateFadeAnimationRec.Speed, FStateFadeAnimationRec.Acceleration, FStateFadeAnimationRec.TimeOut);
                  ATR_STATE_FLIPFLOP: StartStateFadeAnimation(FStateAnimationRec.Dest, FStateAnimationRec.Src, A_CLEAR, FStateFadeAnimationRec.Speed, FStateFadeAnimationRec.Acceleration, FStateFadeAnimationRec.TimeOut);
                end;

                FFrameAnimationRec.StateFrameStop:= True;
                ResumeFrameAnimation;

                (*==============*)
                (**) if (Assigned(FOnStateFadeAnimationStop)) then FOnStateFadeAnimationStop(Self);
                (*==============*)
          end;
          //
          AM_FRAME_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnFrameAnimationStart)) then FOnFrameAnimationStart(Self);
                (*==============*)
          //
          AM_FRAME_ANIMATION_STOP:
          begin
                if (not Boolean(WParam)) then
                case (FAnimationType and ATR_FRAME_ALL) of
                  ATR_FRAME_CIRCULAR: StartFrameAnimation(FFrameAnimationRec.Src, FFrameAnimationRec.Dest, FFrameAnimationRec.TimeOut);
                  ATR_FRAME_FLIPFLOP: StartFrameAnimation(FFrameAnimationRec.Dest, FFrameAnimationRec.Src, FFrameAnimationRec.TimeOut);
                end;

                FStateAnimationRec.StateFrameStop:= True;
                ResumeStateAnimation;

                (*==============*)
                (**) if (Assigned(FOnFrameAnimationStop)) then FOnFrameAnimationStop(Self);
                (*==============*)
          end;
          //
          AM_FRAMEFADE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnFrameFadeAnimationStart)) then FOnFrameFadeAnimationStart(Self);
                (*==============*)
          //
          AM_FRAMEFADE_ANIMATION_STOP:
          begin
                if (not Boolean(WParam)) then
                case (FAnimationType and ATR_FRAME_ALL) of
                  ATR_FRAME_CIRCULAR: StartFrameFadeAnimation(FFrameAnimationRec.Src, FFrameAnimationRec.Dest, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut);
                  ATR_FRAME_FLIPFLOP: StartFrameFadeAnimation(FFrameAnimationRec.Dest, FFrameAnimationRec.Src, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut);
                end;

                FStateAnimationRec.StateFrameStop:= True;
                ResumeStateAnimation;

                (*==============*)
                (**) if (Assigned(FOnFrameFadeAnimationStop)) then FOnFrameFadeAnimationStop(Self);
                (*==============*)
          end;
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_ANIMATION_STATE:
                  begin
                        RunAnimation(Self, SuspendStateAnimation, ResumeFrameAnimation, StopStateAnimation, FStateAnimationRec, FState, FFrame, FAnimationType, ATW_STATE_ALL, ATW_STATE_FRAMECHANGE, ATW_STATE_FRAMESTOP, FStateFirst);

                        (*==============*)
                        (**) if (Assigned(FOnStateAnimating)) then FOnStateAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ANIMATION_STATEFADE:
                  begin
                        RunFadeAnimation(Self, SuspendStateAnimation, ResumeFrameAnimation, StopStateFadeAnimation, FStateAnimationRec, FStateFadeAnimationRec, FState, FFrame, FAnimationType, ATW_STATE_ALL, ATW_STATE_FRAMECHANGE, ATW_STATE_FRAMESTOP, FStateFirst);

                        (*==============*)
                        (**) if (Assigned(FOnStateFadeAnimating)) then FOnStateFadeAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ANIMATION_FRAME:
                  begin
                        RunAnimation(Self, SuspendFrameAnimation, ResumeStateAnimation, StopFrameAnimation, FFrameAnimationRec, FFrame, FState, FAnimationType, ATW_FRAME_ALL, ATW_FRAME_STATECHANGE, ATW_FRAME_STATESTOP, FFrameFirst);

                        (*==============*)
                        (**) if (Assigned(FOnFrameAnimating)) then FOnFrameAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ANIMATION_FRAMEFADE:
                  begin
                        RunFadeAnimation(Self, SuspendFrameAnimation, ResumeStateAnimation, StopFrameFadeAnimation, FFrameAnimationRec, FFrameFadeAnimationRec, FFrame, FState, FAnimationType, ATW_FRAME_ALL, ATW_FRAME_STATECHANGE, ATW_FRAME_STATESTOP, FFrameFirst);

                        (*==============*)
                        (**) if (Assigned(FOnFrameFadeAnimating)) then FOnFrameFadeAnimating(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.Paint;
var Hori, Vert: Integer;
    Rect: TRect;
begin
        if (FAnimationWidth > 0)and(FAnimationHeight > 0) then
        begin
                Hori:= Integer(FOrientation = O_HORIZONTAL);
                Vert:= Integer(FOrientation = O_VERTICAL);

                if (not FStateFadeAnimating) then
                begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FState*Hori + FFrame*Vert), FAnimationHeight*(FState*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);
                        end
                        else begin
                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FState*Hori + FFrameFadeAnimationRec.Src*Vert), FAnimationHeight*(FState*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FState*Hori + FFrameFadeAnimationRec.Dest*Vert), FAnimationHeight*(FState*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end
                else begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Src*Hori + FFrame*Vert), FAnimationHeight*(FStateFadeAnimationRec.Src*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Dest*Hori + FFrame*Vert), FAnimationHeight*(FStateFadeAnimationRec.Dest*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end
                        else begin
                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Src*Vert), FAnimationHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Dest*Vert), FAnimationHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Src*Vert), FAnimationHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FAnimationWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Dest*Vert), FAnimationHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FAnimationWidth, Rect.Top + FAnimationHeight);
                                FAnimationBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                FFadeBuffer.Render(FBuffer, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end;
        end;
end;


procedure TAAnimation.UpdateAnimation;
var Hori, Vert: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Hori:= Integer(FOrientation = O_HORIZONTAL);
        Vert:= Integer(FOrientation = O_VERTICAL);

        if (FStateCount*Hori + FFrameCount*Vert <> 0) then FAnimationWidth:= FAnimationBuffer.Width div (FStateCount*Hori + FFrameCount*Vert)
        else FAnimationWidth:= 0;
        if (FStateCount*Vert + FFrameCount*Hori <> 0) then FAnimationHeight:= FAnimationBuffer.Height div (FStateCount*Vert + FFrameCount*Hori)
        else FAnimationHeight:= 0;

        FFadeBuffer.Resize(FAnimationWidth, FAnimationHeight);
        FBuffer.Resize(FAnimationWidth, FAnimationHeight);
        Size(FAnimationWidth, FAnimationHeight);
        Changed;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


class procedure TAAnimation.RunAnimation(ASelf: TAControl; Suspend, Resume: TSuspendResume; Stop: TStop; var Struct: TAnimationRec; var X, Y: Integer; AAnimationType, WAll, WChange, WStop: Integer; var AFirst: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        with Struct do
        begin
                // suspend if needed by FWait.
                if (AAnimationType and WAll = WChange) then
                begin
                        if (Struct.StateFrame = Y) then begin Suspend; Exit; end
                        else Struct.StateFrame:= Y;
                end
                else if (AAnimationType and WAll = WStop) then
                begin
                        if (not Struct.StateFrameStop) then begin Suspend; Exit; end
                        else Struct.StateFrameStop:= False;
                end;

                // determine if after the first frame set there should be a delay.
                if AFirst then
                begin
                        AFirst:= False;
                        if (X <> Src) then
                        begin
                                X:= Src;
                                ASelf.Changed;
                                if (AAnimationType <> 0) then Resume;

                                {$IFDEF THREADSAFE}
                                 ThreadManager.ClearExclusive;
                                {$ENDIF}

                                Exit;
                        end;
                end;

                // do the animation.
                if (Dest > X) then
                begin
                        Inc(X);
                        ASelf.Changed;
                        if (AAnimationType <> 0) then Resume;
                end
                else if (Dest < X) then
                begin
                        Dec(X);
                        ASelf.Changed;
                        if (AAnimationType <> 0) then Resume;
                end;
                if (Dest = X) then
                begin
                        ASelf.Changed;
                        Stop;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


class procedure TAAnimation.RunFadeAnimation(ASelf: TAControl; Suspend, Resume: TSuspendResume; Stop: TStop; var Struct: TAnimationRec; var FadeStruct: TFadeAnimationRec; var X, Y: Integer; AAnimationType, WAll, WChange, WStop: Integer; var AFirst: Boolean);
var a: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        with FadeStruct do
        begin
                // suspend animation id needed by FWait.
                if (AAnimationType and WAll = WChange) then
                begin
                        if (Struct.StateFrame = Y)and(Alpha = 0)and(BlankFrameCount = 0) then begin Suspend; Exit; end
                        else if (Alpha = A_CLEAR)and(BlankFrameCount = 0) then Struct.StateFrame:= Y;
                end
                else if (AAnimationType and WAll = WStop) then
                begin
                        if (not Struct.StateFrameStop)and(Alpha = 0)and(BlankFrameCount = 0) then begin Suspend; Exit; end
                        else if (Alpha = A_CLEAR)and(BlankFrameCount = 0) then Struct.StateFrameStop:= False;
                end;

                // determine if after the first frame set there should be a delay.
                if AFirst then
                begin
                        if (X <> Struct.Src) then
                        begin
                                // do the animation.
                                a:= Trunc(Speed*Frame + Acceleration*Frame*Frame);

                                if (a >= A_OPAQUE) then
                                begin
                                        X:= Struct.Src;
                                        Src:= Struct.Src;
                                        if Struct.Dest > Struct.Src then Dest:= Src + 1
                                        else Dest:= Src - 1;

                                        Alpha:= A_CLEAR;
                                        Frame:= 0;
                                        AFirst:= False;
                                        ASelf.Changed;
                                        if (AAnimationType <> 0) then Resume;
                                end
                                else if (a > Alpha) then
                                begin
                                        Alpha:= a;
                                        BlankFrameCount:= 0;
                                        ASelf.Changed;
                                end
                                else if (a = Alpha) then Inc(BlankFrameCount)
                                else if (a < Alpha) then
                                begin
                                        ASelf.Changed;
                                        Stop;
                                end;

                                Inc(Frame);
                                if (BlankFrameCount > BlankFrameMax) then Stop;


                                {$IFDEF THREADSAFE}
                                 ThreadManager.ClearExclusive;
                                {$ENDIF}

                                Exit;
                        end
                        else begin
                                AFirst:= False;
                                Src:= Struct.Src;
                                if Struct.Dest > Struct.Src then Dest:= Src + 1
                                else Dest:= Src - 1;
                        end;
                end;

                // do the animation.
                a:= Trunc(Speed*Frame + Acceleration*Frame*Frame);

                if (a >= A_OPAQUE) then
                begin
                        Alpha:= A_CLEAR;

                        if (Struct.Dest > X) then
                        begin
                                Inc(X);
                                Src:= X;
                                Dest:= X + 1;
                                Frame:= 0;

                                if (AAnimationType <> 0) then Resume;
                                BlankFrameCount:= 0;
                                ASelf.Changed;
                        end
                        else if (Struct.Dest < X) then
                        begin
                                Dec(X);
                                Src:= X;
                                Dest:= X - 1;
                                Frame:= 0;

                                if (AAnimationType <> 0) then Resume;
                                BlankFrameCount:= 0;
                                ASelf.Changed;
                        end;
                        if (Struct.Dest = X) then
                        begin
                                Dest:= X;
                                ASelf.Changed;
                                Stop;
                        end;
                end
                else if (a > Alpha) then
                begin
                        Alpha:= a;
                        BlankFrameCount:= 0;
                        ASelf.Changed;
                end
                else if (a = Alpha) then Inc(BlankFrameCount)
                else if (a < Alpha) then
                begin
                        ASelf.Changed;
                        Stop;
                end;

                Inc(Frame);
                if (BlankFrameCount > BlankFrameMax) then Stop;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.SuspendStateAnimation;
begin
        if (FStateAnimating) then TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_STATE, Self)
        else if (FStateFadeAnimating) then TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_STATEFADE, Self);
end;


procedure TAAnimation.SuspendFrameAnimation;
begin
        if (FFrameAnimating) then TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_FRAME, Self)
        else if (FFrameFadeAnimating) then TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, Self);
end;


procedure TAAnimation.ResumeStateAnimation;
begin
        if (FStateAnimating) then TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_STATE, FStateAnimationRec.TimeOut, Self)
        else if (FStateFadeAnimating) then TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_STATEFADE, FStateFadeAnimationRec.TimeOut, Self);
end;


procedure TAAnimation.ResumeFrameAnimation;
begin
        if (FFrameAnimating) then TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_FRAME, FFrameAnimationRec.TimeOut, Self)
        else if (FFrameFadeAnimating) then TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, FFrameFadeAnimationRec.TimeOut, Self);
end;


procedure TAAnimation.Load(const AFileName: String; AStateCount, AFrameCount: Integer; AOrientation: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                FAnimationBuffer.Load(AFileName);

                FStateCount:= AStateCount;
                FFrameCount:= AFrameCount;

                FOrientation:= AOrientation;
                UpdateAnimation;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAAnimation.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        FAnimationBuffer.Empty:= True;

        StopStateAnimation(True);
        StopStateFadeAnimation(True);
        StopFrameAnimation(True);
        StopFrameFadeAnimation(True);

        FStateCount:= 0;
        FFrameCount:= 0;

        FOrientation:= 0;
        UpdateAnimation;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StartStateAnimation(ASrcState, ADestState: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FStateAnimating)and(not FStateFadeAnimating)and(ATimeOut > 0) then
        begin
                FStateAnimating:= True;
                FStateFirst:= True;
                Result:= True;

                FStateAnimationRec.Src:= ASrcState;
                FStateAnimationRec.Dest:= ADestState;
                FStateAnimationRec.TimeOut:= ATimeOut;
                FStateAnimationRec.StateFrame:= FFrame;
                FStateAnimationRec.StateFrameStop:= False;
                FStateAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_STATE, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StopStateAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FStateAnimating) then
        begin
                FStateAnimating:= False;
                FStateFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_STATE, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATE_ANIMATION_STOP, Integer(Bypass or FStateAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StartStateFadeAnimation(ASrcState, ADestState: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FStateFadeAnimating)and(not FStateAnimating)and
           (ASpeed > 0)and(ATimeOut > 0) then
        begin
                FStateFadeAnimating:= True;
                FStateFirst:= True;
                Result:= True;

                FStateAnimationRec.Src:= ASrcState;
                FStateAnimationRec.Dest:= ADestState;
                FStateAnimationRec.StateFrame:= FFrame;
                FStateAnimationRec.StateFrameStop:= False;

                FStateFadeAnimationRec.Src:= FState;
                FStateFadeAnimationRec.Dest:= ASrcState;
                FStateFadeAnimationRec.Speed:= ASpeed;
                FStateFadeAnimationRec.Acceleration:= AAcceleration;
                if AAcceleration = 0 then FStateFadeAnimationRec.Frame:= 1 + Trunc(AAlpha / ASpeed)
                else FStateFadeAnimationRec.Frame:= 1 + Trunc((-ASpeed + Sqrt(ASpeed*ASpeed + 4*AAcceleration*AAlpha)) / (2*AAcceleration));
                FStateFadeAnimationRec.BlankFrameMax:= Ceil(1 / ASpeed);
                FStateFadeAnimationRec.BlankFrameCount:= 0;
                FStateFadeAnimationRec.Alpha:= AAlpha;
                FStateFadeAnimationRec.TimeOut:= ATimeOut;
                FStateFadeAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_STATEFADE, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATEFADE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StopStateFadeAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FStateFadeAnimating) then
        begin
                FStateFadeAnimating:= False;
                FStateFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_STATEFADE, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATEFADE_ANIMATION_STOP, Integer(Bypass or FStateFadeAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StartFrameAnimation(ASrcFrame, ADestFrame: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FFrameAnimating)and(not FFrameFadeAnimating)and(ATimeOut > 0) then
        begin
                FFrameAnimating:= True;
                FFrameFirst:= True;
                Result:= True;

                FFrameAnimationRec.Src:= ASrcFrame;
                FFrameAnimationRec.Dest:= ADestFrame;
                FFrameAnimationRec.TimeOut:= ATimeOut;
                FFrameAnimationRec.StateFrame:= FState;
                FFrameAnimationRec.StateFrameStop:= False;
                FFrameAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_Frame, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAME_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StopFrameAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFrameAnimating) then
        begin
                FFrameAnimating:= False;
                FFrameFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_Frame, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAME_ANIMATION_STOP, Integer(Bypass or FFrameAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StartFrameFadeAnimation(ASrcFrame, ADestFrame: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FFrameFadeAnimating)and(not FFrameAnimating)and
           (ASpeed > 0)and(ATimeOut > 0) then
        begin
                FFrameFadeAnimating:= True;
                FFrameFirst:= True;
                Result:= True;

                FFrameAnimationRec.Src:= ASrcFrame;
                FFrameAnimationRec.Dest:= ADestFrame;
                FFrameAnimationRec.StateFrame:= FState;
                FFrameAnimationRec.StateFrameStop:= False;

                FStateFadeAnimationRec.Src:= FFrame;
                FStateFadeAnimationRec.Dest:= ASrcFrame;
                FFrameFadeAnimationRec.Speed:= ASpeed;
                FFrameFadeAnimationRec.Acceleration:= AAcceleration;
                if AAcceleration = 0 then FStateFadeAnimationRec.Frame:= 1 + Trunc(AAlpha / ASpeed)
                else FStateFadeAnimationRec.Frame:= 1 + Trunc((-ASpeed + Sqrt(ASpeed*ASpeed + 4*AAcceleration*AAlpha)) / (2*AAcceleration));
                FFrameFadeAnimationRec.BlankFrameMax:= Ceil(1 / ASpeed);
                FFrameFadeAnimationRec.BlankFrameCount:= 0;
                FFrameFadeAnimationRec.Alpha:= AAlpha;
                FFrameFadeAnimationRec.TimeOut:= ATimeOut;
                FFrameFadeAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAMEFADE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAAnimation.StopFrameFadeAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFrameFadeAnimating) then
        begin
                FFrameFadeAnimating:= False;
                FFrameFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAMEFADE_ANIMATION_STOP, Integer(Bypass or FFrameFadeAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                  BUTTON                                  ##
//##############################################################################


{ TAButton }




constructor TAButton.Create(const AName: String; AParent: TAForm; ABufferType: Integer; AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT, AControlType);



        FStateFadeAnimating:= False;
        FFrameAnimating:= False;
        FFrameFadeAnimating:= False;

        FState:= 0;
        FFrame:= 0;
        FStateCount:= 0;
        FFrameCount:= 0;

        FAnimationType:= 0;
        FActive:= False;
        FDisabled:= False;



        FFadeBuffer:= TFoot.Create;

        FFrameFirst:= False;

        FRepeating:= False;

        FRadio:= False;

        FFrameAnimation:= 0;



        FOrientation:= 0;

        FButtonWidth:= 0;
        FButtonHeight:= 0;
        FButtonBuffer:= TFoot.Create;
end;


destructor TAButton.Destroy;
begin
        FFadeBuffer.Free;

        FButtonBuffer.Free;

        StopStateFadeAnimation;
        StopFrameAnimation(True);
        StopFrameFadeAnimation(True);

        TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT_WAIT, Self);
        TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT, Self);



inherited;
end;


procedure TAButton.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.SetAnimationType(AAnimationType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAnimationType <> AAnimationType) then
        begin
                FAnimationType:= AAnimationType;


                UpdateAnimation;
        end;


      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.SetActive(AActive: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AActive <> FActive) then
        begin
                FActive:= AActive;


                // run the animations.
                if (FAnimationType and BATT_FRAME_ACTIVE <> 0) then
                begin
                        if (FActive) then Start
                        else Stop;
                end;

                UpdateState;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_ACTIVE_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.SetDisabled(ADisabled: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ADisabled <> FDisabled) then
        begin
                FDisabled:= ADisabled;


                UpdateState;

                if (FParent <> nil) then
                begin
                        TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT_WAIT, Self);
                        TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT, Self);
                        FRepeating:= False;

                        (*--------------*)
                        (**) FLayerManager.SendMessage(AM_DISABLED_CHANGE, 0, 0, Self);
                        (*--------------*)
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.ProcessMessage(Msg, WParam, LParam: Integer);
var a: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_MOUSE_ENTER, AM_MOUSE_LEAVE: UpdateState;
          //
          AM_MOUSE_DOWNL:
          if (not FDisabled) then
          begin
                UpdateState;

                TimerManager.AddTimer(TT_HOOK, TID_REPEAT_WAIT, FRepeatWait, Self);
          end;
          //
          AM_MOUSE_UPL:
          if (not FDisabled) then
          begin
                UpdateState;

                TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT_WAIT, Self);
                TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT, Self);
                FRepeating:= False;
          end;
          //
          AM_MOUSE_CLICKL:
          if (not FDisabled) then
          begin
                if (FStateCount = BT_TOGGLE) then
                begin
                        if (not FRadio) then SetActive(not FActive)
                        else SetActive(True)
                end
                else UpdateState;

                (*--------------*)
                (**) if (not FRepeating) then FLayerManager.SendMessage(AM_PUSH, 0, 0, Self);
                (*--------------*)
          end;
          //
          AM_STATEFADE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnStateFadeAnimationStart)) then FOnStateFadeAnimationStart(Self);
                (*==============*)
          //
          AM_STATEFADE_ANIMATION_STOP:
                (*==============*)
                (**) if (Assigned(FOnStateFadeAnimationStop)) then FOnStateFadeAnimationStop(Self);
                (*==============*)
          //
          AM_FRAME_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnFrameAnimationStart)) then FOnFrameAnimationStart(Self);
                (*==============*)
          //
          AM_FRAME_ANIMATION_STOP:
          begin
                (*==============*)
                (**) if (Assigned(FOnFrameAnimationStop)) then FOnFrameAnimationStop(Self);
                (*==============*)

                if (not Boolean(WParam)) then
                begin
                        if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_CIRCULAR) then
                        begin
                                if (FFrameAnimation = BFA_CIRCULAR_FC) then StartFrameAnimation(0, FFrameCount-1, FFrameAnimationRec.TimeOut)
                                else if (FFrameAnimation = BFA_CIRCULAR_0_STOP) then
                                begin
                                        FFrameAnimation:= BFA_CIRCULAR_FC;
                                        StartFrameAnimation(0, 0, FFrameAnimationRec.TimeOut, True);
                                end
                                else StartFrameAnimation(0, FFrameCount-1, FFrameAnimationRec.TimeOut);
                        end
                        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FLIPFLOP) then
                        begin
                                if (FFrameAnimation = BFA_FLIPFLOP_0) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_FC;
                                        StartFrameAnimation(FFrameCount-1, 0, FFrameAnimationRec.TimeOut)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_FC) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_0;
                                        StartFrameAnimation(0, FFrameCount-1, FFrameAnimationRec.TimeOut)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_0_STOP) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_FC_STOP;
                                        StartFrameAnimation(FFrameCount-1, 0, FFrameAnimationRec.TimeOut, True)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_FC_STOP) then FFrameAnimation:= BFA_NONE
                                else StartFrameAnimation(FFrameAnimationRec.Dest, FFrameAnimationRec.Src, FFrameAnimationRec.TimeOut)
                        end
                        else FFrameAnimation:= BFA_NONE;
                end
                else FFrameAnimation:= BFA_NONE;
          end;
          //
          AM_FRAMEFADE_ANIMATION_START:
                (*==============*)
                (**) if (Assigned(FOnFrameFadeAnimationStart)) then FOnFrameFadeAnimationStart(Self);
                (*==============*)
          //
          AM_FRAMEFADE_ANIMATION_STOP:
          begin
                (*==============*)
                (**) if (Assigned(FOnFrameFadeAnimationStop)) then FOnFrameFadeAnimationStop(Self);
                (*==============*)

                if (not Boolean(WParam)) then
                begin
                        if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_CIRCULAR) then
                        begin
                                if (FFrameAnimation = BFA_CIRCULAR_FC) then StartFrameFadeAnimation(0, FFrameCount-1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut)
                                else if (FFrameAnimation = BFA_CIRCULAR_0_STOP) then
                                begin
                                        FFrameAnimation:= BFA_NONE;
                                        StartFrameFadeAnimation(0, 0, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut, True)
                                end
                                else StartFrameFadeAnimation(0, FFrameCount-1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut)
                        end
                        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FLIPFLOP) then
                        begin
                                if (FFrameAnimation = BFA_FLIPFLOP_0) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_FC;
                                        StartFrameFadeAnimation(FFrameCount-1, 0, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_FC) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_0;
                                        StartFrameFadeAnimation(0, FFrameCount-1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_0_STOP) then
                                begin
                                        FFrameAnimation:= BFA_FLIPFLOP_FC_STOP;
                                        StartFrameFadeAnimation(FFrameCount-1, 0, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut)
                                end
                                else if (FFrameAnimation = BFA_FLIPFLOP_FC_STOP) then FFrameAnimation:= BFA_NONE
                                else StartFrameFadeAnimation(FFrameAnimationRec.Dest, FFrameAnimationRec.Src, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut);
                        end
                        else FFrameAnimation:= BFA_NONE;
                end
                else FFrameAnimation:= BFA_NONE;
          end;
          //
          AM_ACTIVE_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnActiveChange)) then FOnActiveChange(Self);
                (*==============*)
          //
          AM_DISABLED_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnDisabledChange)) then FOnDisabledChange(Self);
                (*==============*)
          //
          AM_PUSH:
                (*==============*)
                (**) if (Assigned(FOnPush)) then FOnPush(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_REPEAT_WAIT:
                  begin
                        TimerManager.RemoveTimer(TT_HOOK, TID_REPEAT_WAIT, Self);
                        TimerManager.AddTimer(TT_HOOK, TID_REPEAT, FRepeatInt, Self);
                        FRepeating:= True;

                        (*--------------*)
                        (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_PUSH, 0, 0, Self);
                        (*--------------*)
                  end;
                  //
                  TID_REPEAT:
                        (*--------------*)
                        (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_PUSH, 0, 0, Self);
                        (*--------------*)
                  //
                  TID_ANIMATION_STATEFADE:
                  begin
                        with FStateFadeAnimationRec do
                        begin
                                a:= Trunc(Speed*Frame + Acceleration*Frame*Frame);

                                if (a >= A_OPAQUE) then
                                begin
                                        Alpha:= A_OPAQUE;
                                        StopStateFadeAnimation;
                                        Changed;
                                end
                                else if (a > Alpha) then
                                begin
                                        Alpha:= a;
                                        BlankFrameCount:= 0;
                                        Changed;
                                end
                                else if (a = Alpha) then Inc(BlankFrameCount)
                                else if (a < Alpha) then StopStateFadeAnimation;

                                Inc(Frame);
                                if (BlankFrameCount > BlankFrameMax) then StopStateFadeAnimation;
                        end;

                        (*==============*)
                        (**) if (Assigned(FOnStateFadeAnimating)) then FOnStateFadeAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ANIMATION_FRAME:
                  begin
                        TAAnimation.RunAnimation(Self, nil, nil, StopFrameAnimation, FFrameAnimationRec, FFrame, FState, 0, 1, 1, 1, FFrameFirst);

                        (*==============*)
                        (**) if (Assigned(FOnFrameAnimating)) then FOnFrameAnimating(Self);
                        (*==============*)
                  end;
                  //
                  TID_ANIMATION_FRAMEFADE:
                  begin
                        TAAnimation.RunFadeAnimation(Self, nil, nil, StopFrameFadeAnimation, FFrameAnimationRec, FFrameFadeAnimationRec, FFrame, FState, 0, 1, 1, 1, FFrameFirst);

                        (*==============*)
                        (**) if (Assigned(FOnFrameFadeAnimating)) then FOnFrameFadeAnimating(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.Paint;
var Hori, Vert: Integer;
    Rect: TRect;
begin
        if (FButtonWidth > 0)and(FButtonHeight > 0) then
        begin
                Hori:= Integer(FOrientation = O_HORIZONTAL);
                Vert:= Integer(FOrientation = O_VERTICAL);

                if (not FStateFadeAnimating) then
                begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrame*Vert), FButtonHeight*(FState*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);
                        end
                        else begin
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FState*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FState*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end
                else begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrame*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrame*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end
                        else begin
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                FFadeBuffer.Render(FBuffer, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end;
        end;
end;


procedure TAButton.UpdateAnimation;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAnimationType and BATR_FRAME_ALL <> 0) then
        begin
                if (FAnimationType and BATT_FRAME_ALL = 0) then
                begin
                        if (FAnimationType and BAT_FRAME_FADE = 0) then StartFrameAnimation(0, FFrameCount - 1, FFrameAnimationRec.TimeOut)
                        else StartFrameFadeAnimation(0, FFrameCount - 1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameAnimationRec.TimeOut);
                end
                else begin
                        if (FAnimationType and BATT_FRAME_ALL = BATT_FRAME_ACTIVE) then
                        begin
                                if (FActive) then Start
                                else Stop;
                        end;
                end;
        end
        else begin
                StopFrameAnimation;
                StopFrameFadeAnimation;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.UpdateButton;
var Hori, Vert: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Hori:= Integer(FOrientation = O_HORIZONTAL);
        Vert:= Integer(FOrientation = O_VERTICAL);

        if (FStateCount*Hori + FFrameCount*Vert <> 0) then FButtonWidth:= FButtonBuffer.Width div (FStateCount*Hori + FFrameCount*Vert)
        else FButtonWidth:= 0;
        if (FStateCount*Vert + FFrameCount*Hori <> 0) then FButtonHeight:= FButtonBuffer.Height div (FStateCount*Vert + FFrameCount*Hori)
        else FButtonHeight:= 0;

        FFadeBuffer.Resize(FButtonWidth, FButtonHeight);
        FBuffer.Resize(FButtonWidth, FButtonHeight);
        Size(FButtonWidth, FButtonHeight);
        Changed;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.UpdateState;
var NewState, Offset: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        NewState:= FState;

        // only changestate if the button is not an inherited component.
        if (FStateCount = BT_PUSH)or(FStateCount = BT_TOGGLE) then
        case FStateCount of
          BT_PUSH:
          begin
                if FDisabled then NewState:= BSP_DISABLED
                else if (FParent <> nil)and(FLayerManager.HoverLayer = Self) then
                begin
                        if (Mouse.Button and MB_LEFT <> 0) then NewState:= BSP_DOWN
                        else NewState:= BSP_HOVER;
                end
                else NewState:= BSP_UP;
          end;
          //
          BT_TOGGLE:
          begin
                case FActive of
                  True: Offset:= 0;
                  else Offset:= BST_INACTIVE_UP;
                end;

                if FDisabled then NewState:= Offset + BSP_DISABLED
                else if (FParent <> nil)and(FLayerManager.HoverLayer = Self) then
                begin
                        if (Mouse.Button and MB_LEFT <> 0) then NewState:= Offset + BSP_DOWN
                        else NewState:= Offset + BSP_HOVER;
                end
                else NewState:= Offset + BSP_UP;
          end;
          //
        end;

        // run the animations.
        if ((not FStateFadeAnimating)and(NewState <> FState))or((FStateFadeAnimating)and(FStateFadeAnimationRec.Dest <> NewState)) then
        begin
                if (FAnimationType and BAT_STATE_FADE <> 0) then StartStateFadeAnimation(FState, NewState, FStateFadeAnimationRec.Speed, FStateFadeAnimationRec.Acceleration, FStateFadeAnimationRec.TimeOut)
                else FState:= NewState;

                if  (FAnimationType and BATT_FRAME_ALL <> 0)and
                    (FAnimationType and BATT_FRAME_ALL <> BATT_FRAME_ACTIVE) then
                begin
                        if ((FAnimationType and BATT_FRAME_HOVERDOWN = BATT_FRAME_HOVERDOWN)and((NewState = BSP_HOVER)or(NewState = BSP_DOWN)or(NewState = BST_INACTIVE_HOVER)or(NewState = BST_INACTIVE_DOWN)))or
                           ((FAnimationType and BATT_FRAME_HOVER <> 0)and((NewState = BSP_HOVER)or(NewState = BST_INACTIVE_HOVER)))or
                           ((FAnimationType and BATT_FRAME_DOWN <> 0)and((NewState = BSP_DOWN)or(NewState = BST_INACTIVE_DOWN)))
                        then Start
                        else Stop;
                end;

                // update the button buffer.
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StartStateFadeAnimation(ASrcState, ADestState: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (ASrcState <> ADestState)and(ASpeed > 0)and(ATimeOut > 0) then
        begin
                if (FStateFadeAnimationRec.Src = BSP_DOWN)and(FStateFadeAnimationRec.Dest = BSP_HOVER)and
                   (ASrcState = BSP_HOVER)and(ADestState = BSP_UP)and(FStateFadeAnimationRec.Alpha < 70) then ASrcState:= BSP_DOWN
                else if (FStateFadeAnimationRec.Src = BST_INACTIVE_DOWN)and(FStateFadeAnimationRec.Dest = BST_INACTIVE_HOVER)and
                   (ASrcState = BST_INACTIVE_HOVER)and(ADestState = BST_INACTIVE_UP)and(FStateFadeAnimationRec.Alpha < 70) then ASrcState:= BSP_DOWN;

                FState:= ADestState;
                FStateFadeAnimating:= True;
                Result:= True;

                if ((ASrcState <> BSP_DOWN)and(ASrcState <> BST_INACTIVE_DOWN)and(ADestState = FStateFadeAnimationRec.Src)and(FStateFadeAnimating))or
                   (((ASrcState = BSP_DOWN)or(ASrcState = BST_INACTIVE_DOWN))and(FStateFadeAnimating)and((FStateFadeAnimationRec.Src = BSP_UP)or(FStateFadeAnimationRec.Src = BST_INACTIVE_UP))) then FStateFadeAnimationRec.Alpha:= A_OPAQUE - FStateFadeAnimationRec.Alpha
                else FStateFadeAnimationRec.Alpha:= A_CLEAR;
                FStateFadeAnimationRec.Src:= ASrcState;
                FStateFadeAnimationRec.Dest:= ADestState;
                FStateFadeAnimationRec.Speed:= ASpeed;
                FStateFadeAnimationRec.Acceleration:= AAcceleration;
                FStateFadeAnimationRec.BlankFrameMax:= Ceil(1 / ASpeed);
                FStateFadeAnimationRec.BlankFrameCount:= 0;
                if AAcceleration = 0 then FStateFadeAnimationRec.Frame:= 1 + Trunc(FStateFadeAnimationRec.Alpha / ASpeed)
                else FStateFadeAnimationRec.Frame:= 1 + Trunc((-ASpeed + Sqrt(ASpeed*ASpeed + 4*AAcceleration*FStateFadeAnimationRec.Alpha)) / (2*AAcceleration));
                FStateFadeAnimationRec.TimeOut:= ATimeOut;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_STATEFADE, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATEFADE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StopStateFadeAnimation: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FStateFadeAnimating) then
        begin
                FState:= FStateFadeAnimationRec.Dest;
                FStateFadeAnimating:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_STATEFADE, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_STATEFADE_ANIMATION_STOP, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.Start;
var AAlpha: Byte;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FORWARD) then
        begin
                if (FFrameAnimation = BFA_FORWARD_0) then
                begin
                        StopFrameAnimation(True);
                        StopFrameFadeAnimation(True);
                        AAlpha:= A_OPAQUE - FFrameFadeAnimationRec.Alpha;
                end
                else AAlpha:= A_CLEAR;

                FFrameAnimation:= BFA_FORWARD_FC;
                if (FAnimationType and BAT_FRAME_FADE <> 0) then StartFrameFadeAnimation(FFrame, FFrameCount-1, AAlpha, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut)
                else StartFrameAnimation(FFrame, FFrameCount-1, FFrameAnimationRec.TimeOut);
        end
        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_CIRCULAR) then
        begin
                if (FFrameAnimation = BFA_NONE) then
                begin
                        FFrameAnimation:= BFA_CIRCULAR_FC;
                        if (FAnimationType and BAT_FRAME_FADE <> 0) then StartFrameFadeAnimation(0, FFrameCount-1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut)
                        else StartFrameAnimation(0, FFrameCount-1, FFrameAnimationRec.TimeOut);
                end
                else if (FFrameAnimation = BFA_CIRCULAR_0_STOP) then FFrameAnimation:= BFA_CIRCULAR_FC;

                FFrameAnimationRec.Bypass:= False;
                FFrameFadeAnimationRec.Bypass:= False;
        end
        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FLIPFLOP) then
        begin
                if (FFrameAnimation = BFA_NONE) then
                begin
                        FFrameAnimation:= BFA_FLIPFLOP_0;
                        if (FAnimationType and BAT_FRAME_FADE <> 0) then StartFrameFadeAnimation(0, FFrameCount-1, A_CLEAR, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut)
                        else StartFrameAnimation(0, FFrameCount-1, FFrameAnimationRec.TimeOut);
                end
                else if (FFrameAnimation = BFA_FLIPFLOP_0_STOP) then FFrameAnimation:= BFA_FLIPFLOP_0
                else if (FFrameAnimation = BFA_FLIPFLOP_FC_STOP) then FFrameAnimation:= BFA_FLIPFLOP_FC;

                FFrameAnimationRec.Bypass:= False;
                FFrameFadeAnimationRec.Bypass:= False;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.Stop;
var AAlpha: Byte;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FORWARD) then
        begin
                if (FFrameAnimation = BFA_FORWARD_FC) then
                begin
                        StopFrameAnimation(True);
                        StopFrameFadeAnimation(True);
                        AAlpha:= A_OPAQUE - FFrameFadeAnimationRec.Alpha
                end
                else AAlpha:= A_CLEAR;

                FFrameAnimation:= BFA_FORWARD_0;
                if (FAnimationType and BAT_FRAME_FADE <> 0) then StartFrameFadeAnimation(FFrame, 0, AAlpha, FFrameFadeAnimationRec.Speed, FFrameFadeAnimationRec.Acceleration, FFrameFadeAnimationRec.TimeOut)
                else StartFrameAnimation(FFrame, 0, FFrameAnimationRec.TimeOut);
        end
        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_CIRCULAR) then
        begin
                if (FFrameAnimation <> BFA_NONE) then FFrameAnimation:= BFA_CIRCULAR_0_STOP
        end
        else if (FAnimationType and BATR_FRAME_ALL = BATR_FRAME_FLIPFLOP) then
        begin
                if (FFrameAnimation <> BFA_NONE) then
                begin
                        if (FFrameAnimation = BFA_FLIPFLOP_FC) then FFrameAnimation:= BFA_FLIPFLOP_FC_STOP
                        else FFrameAnimation:= BFA_FLIPFLOP_0_STOP;
                end;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.Load(const AFileName: String; AButtonType, AFrameCount: Integer; AOrientation: Integer; AStateSpeed: Extended = 0; AStateAcceleration: Extended = 0; AStateTimeOut: Integer = 0; AFrameSpeed: Extended = 0; AFrameAcceleration: Extended = 0; AFrameTimeOut: Integer = 0);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                FButtonBuffer.Load(AFileName);

                FStateCount:= AButtonType;
                FFrameCount:= AFrameCount;

                FStateFadeAnimationRec.Speed:= AStateSpeed;
                FStateFadeAnimationRec.Acceleration:= AStateAcceleration;
                FStateFadeAnimationRec.TimeOut:= AStateTimeOut;
                FFrameFadeAnimationRec.Speed:= AFrameSpeed;
                FFrameFadeAnimationRec.Acceleration:= AFrameAcceleration;
                FFrameFadeAnimationRec.TimeOut:= AFrameTimeOut;
                FFrameAnimationRec.TimeOut:= AFrameTimeOut;

                FOrientation:= AOrientation;
                UpdateButton;
                UpdateState;
                UpdateAnimation;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAButton.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        FButtonBuffer.Empty:= True;

        StopStateFadeAnimation;
        StopFrameAnimation(True);
        StopFrameFadeAnimation(True);

        FState:= 0;
        FStateCount:= 0;
        FFrame:= 0;
        FFrameCount:= 0;

        FOrientation:= 0;
        UpdateButton;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StartFrameAnimation(ASrcFrame, ADestFrame: Integer; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FFrameAnimating)and(not FFrameFadeAnimating)and(ATimeOut > 0) then
        begin
                FFrameAnimating:= True;
                FFrameFirst:= True;
                Result:= True;

                FFrameAnimationRec.Src:= ASrcFrame;
                FFrameAnimationRec.Dest:= ADestFrame;
                FFrameAnimationRec.TimeOut:= ATimeOut;
                FFrameAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_Frame, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAME_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StopFrameAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFrameAnimating) then
        begin
                FFrameAnimating:= False;
                FFrameFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_Frame, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAME_ANIMATION_STOP, Integer(Bypass or FFrameAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StartFrameFadeAnimation(ASrcFrame, ADestFrame: Integer; AAlpha: Integer; ASpeed, AAcceleration: Extended; ATimeOut: Integer; Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FFrameFadeAnimating)and(not FFrameAnimating)and
           (ASpeed > 0)and(ATimeOut > 0) then
        begin
                FFrameFadeAnimating:= True;
                FFrameFirst:= True;
                Result:= True;

                FFrameAnimationRec.Src:= ASrcFrame;
                FFrameAnimationRec.Dest:= ADestFrame;

                FFrameFadeAnimationRec.Alpha:= AAlpha;
                FFrameFadeAnimationRec.Src:= FFrame;
                FFrameFadeAnimationRec.Dest:= ASrcFrame;
                FFrameFadeAnimationRec.Speed:= ASpeed;
                FFrameFadeAnimationRec.Acceleration:= AAcceleration;
                if AAcceleration = 0 then FFrameFadeAnimationRec.Frame:= 1 + Trunc(FFrameFadeAnimationRec.Alpha / ASpeed)
                else FFrameFadeAnimationRec.Frame:= 1 + Trunc((-ASpeed + Sqrt(ASpeed*ASpeed + 4*AAcceleration*FFrameFadeAnimationRec.Alpha)) / (2*AAcceleration));
                FFrameFadeAnimationRec.BlankFrameMax:= Ceil(1 / ASpeed);
                FFrameFadeAnimationRec.BlankFrameCount:= 0;
                FFrameFadeAnimationRec.TimeOut:= ATimeOut;
                FFrameFadeAnimationRec.Bypass:= Bypass;

                TimerManager.AddTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, ATimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAMEFADE_ANIMATION_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAButton.StopFrameFadeAnimation(Bypass: Boolean = False): Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FFrameFadeAnimating) then
        begin
                FFrameFadeAnimating:= False;
                FFrameFirst:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_ANIMATION_FRAMEFADE, Self);

                (*--------------*)
                // || WParam = bypass the repeaters
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_FRAMEFADE_ANIMATION_STOP, Integer(Bypass or FFrameFadeAnimationRec.Bypass), 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                  RADIO                                   ##
//##############################################################################


{ TARadio }




procedure TARadio.SetGroup(AGroup: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (AGroup <> FGroup) then
        begin
                FGroup:= AGroup;


                (*--------------*)
                (**) if (FParent <> nil)and(FActive) then FLayerManager.SendMessage(AM_RADIO, Integer(Self), FGroup, MT_BROADCAST);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TARadio.ProcessMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SET_PARENT:
          begin
                FRadio:= True;

                (*--------------*)
                (**) if (FActive) then FLayerManager.SendMessage(AM_RADIO, Integer(Self), FGroup, MT_BROADCAST);
                (*--------------*)
          end;
          //
          AM_ACTIVE_CHANGE:
                  (*--------------*)
                  (**) if (FActive) then FLayerManager.SendMessage(AM_RADIO, Integer(Self), FGroup, MT_BROADCAST);
                  (*--------------*)
          //
          AM_RADIO: if (LParam = FGroup)and(WParam <> Integer(Self)) then SetActive(False);
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                 PROGRESS                                 ##
//##############################################################################


{ TAProgress }



constructor TAProgress.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT, AControlType);


        FProgressing:= False;
        FFrameCount:= 0;

        FAnimationType:= 0;
        FUndetermined:= False;
        FMinValue:= 0;
        FMaxValue:= 0;
        FProgress:= 0;



        FProgressType:= 0;
        FOrientation:= 0;
        FCount:= 0;

        FProgressWidth:= 0;
        FProgressHeight:= 0;
        FProgressBuffer:= TFoot.Create;
end;


destructor TAProgress.Destroy;
begin
        FProgressBuffer.Free;

        StopProgress;



inherited;
end;


procedure TAProgress.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.SetMinValue(AMinValue: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AMinValue, 0, FMaxValue);

        if (AMinValue <> FMinValue) then
        begin
                FMinValue:= AMinValue;


                if (FProgress < FMinValue) then SetProgress(FMinValue);
                UpdateSmoothInc;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.SetMaxValue(AMaxValue: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AMaxValue, FMinValue, MAX_INT);

        if (AMaxValue <> FMaxValue) then
        begin
                FMaxValue:= AMaxValue;


                if (FProgress > FMaxValue) then SetProgress(FMaxValue);
                UpdateSmoothInc;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.SetProgress(AProgress: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AProgress, FMinValue, FMaxValue);

        if (AProgress <> FProgress) then
        begin
                FProgress:= AProgress;


                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_PROGRESS_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.SetUndetermined(AUndetermined: Boolean);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FUndetermined <> AUndetermined) then
        begin
                FUndetermined:= AUndetermined;


                if (not FUndetermined) then StopProgress;

                UpdateSmoothInc;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.ProcessMessage(Msg, WParam, LParam: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SIZE: if (FProgressType and PT_FRAMED = 0) then UpdateProgress;
          //
          AM_PROGRESS_START:
                (*==============*)
                (**) if (Assigned(FOnProgressStart)) then FOnProgressStart(Self);
                (*==============*)
          //
          AM_PROGRESS_STOP:
                (*==============*)
                (**) if (Assigned(FOnProgressStop)) then FOnProgressStop(Self);
                (*==============*)
          //
          AM_PROGRESS_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnProgressChange)) then FOnProgressChange(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_PROGRESS_SMOOTH:
                  begin
                        if (FProgress <> FProgressRec.SmoothProgress)or(FUndetermined) then
                        begin
                                if (not FUndetermined) then
                                begin
                                        if (FProgress > FProgressRec.SmoothProgress)and(FProgress < FProgressRec.SmoothProgress + FProgressRec.SmoothProgressInc) then FProgressRec.SmoothProgress:= FProgress
                                        else if (FProgress < FProgressRec.SmoothProgress)and(FProgress > FProgressRec.SmoothProgress - FProgressRec.SmoothProgressInc) then FProgressRec.SmoothProgress:= FProgress
                                        else FProgressRec.SmoothProgress:= FProgressRec.SmoothProgress + Sgn(FProgress - FProgressRec.SmoothProgress) * FProgressRec.SmoothProgressInc;
                                end
                                else FProgressRec.SmoothProgress:= FProgressRec.SmoothProgress + FProgressRec.SmoothProgressInc;

                                Changed;
                        end;

                        (*==============*)
                        (**) if (Assigned(FOnProgressing)) then FOnProgressing(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.Paint;
var Hori, Vert, X, W, H: Integer;
    Fwd, Long: Boolean;
    Rect: TRect;
    Point: TPoint;
    SP: Extended;
begin
        Hori:= Integer(FOrientation = O_HORIZONTAL);
        Vert:= Integer(FOrientation = O_VERTICAL);

        if (FProgressWidth > 0)and(FProgressHeight > 0) then
        case FProgressType of
          PT_BAR:
          begin
                SP:= FProgressRec.SmoothProgress*Integer(FProgressing) + FProgress*Integer(not FProgressing);

                if (FMaxValue - FMinValue <> 0) then X:= Trunc((FProgressWidth*Hori + FProgressHeight*Vert) * (FCount + 1) / (FMaxValue - FMinValue) * SP)
                else X:= 0;
                Fwd:= Odd(X div (FProgressWidth*Hori + FProgressHeight*Vert));
                X:= X mod (FProgressWidth*Hori + FProgressHeight*Vert);

                Rect.Left:= X*Hori*Integer(not Fwd);
                Rect.Top:= X*Vert*Integer(not Fwd);
                Rect.Right:= (Integer(not Fwd)*FProgressWidth + Integer(Fwd) * X)*Hori + FProgressWidth*Vert;
                Rect.Bottom:= (Integer(not Fwd)*FProgressHeight + Integer(Fwd) * X)*Vert + FProgressHeight*Hori;
                FProgressBuffer.Render(FBuffer, A_OPAQUE, RM_COPY or RMX_TILE);
                FBuffer.Manipulate(MOP_FILL, 0, M_ALPHA, Rect);
          end;
          //
          PT_CURSOR:
          begin
                FBuffer.Manipulate(MOP_FILL, 0, M_ALPHA);

                case FAnimationType of
                  PAT_FORWARD, PAT_CIRCULAR:
                  begin
                        Long:= ((FProgressBuffer.Width*Hori - FProgressWidth) > 0)or((FProgressBuffer.Height*Vert - FProgressHeight) > 0);

                        if (FCount = 0)and(not FUndetermined) then
                        begin
                                SP:= FProgressRec.SmoothProgress*Integer(FProgressing) + FProgress*Integer(not FProgressing);
                                W:= (FProgressWidth - FProgressBuffer.Width)*Integer(not Long) + (FProgressBuffer.Width - FProgressWidth)*Integer(Long);
                                H:= (FProgressHeight - FProgressBuffer.Height)*Integer(not Long) + (FProgressBuffer.Height - FProgressHeight)*Integer(Long);
                                if (FMaxValue - FMinValue <> 0) then X:= Trunc((W*Hori + H*Vert) * (FCount + 1) / (FMaxValue - FMinValue) * SP)
                                else X:= 0;

                                Point.X:= (X - W*Integer(Long))*Hori;
                                Point.Y:= (X - H*Integer(Long))*Vert;
                                FProgressBuffer.Render(FBuffer, Point, A_OPAQUE, RM_COPY);
                        end
                        else begin
                                SP:= FProgressRec.SmoothProgress*Integer(FProgressing) + FProgress*Integer(not FProgressing);
                                W:= (FProgressWidth + FProgressBuffer.Width)*Integer(not Long) + FProgressBuffer.Width*Integer(Long);
                                H:= (FProgressHeight + FProgressBuffer.Height)*Integer(not Long) + FProgressBuffer.Height*Integer(Long);
                                if (FMaxValue - FMinValue <> 0) then X:= Trunc((W*Hori + H*Vert) * (FCount + 1) / (FMaxValue - FMinValue) * SP) mod (W*Hori + H*Vert)
                                else X:= 0;

                                Point.X:= (X - FProgressBuffer.Width)*Hori;
                                Point.Y:= (X - FProgressBuffer.Height)*Vert;
                                FProgressBuffer.Render(FBuffer, Point, A_OPAQUE, RM_COPY);
                                if Long then
                                begin
                                        Point.X:= (Point.X + 2*FProgressBuffer.Width*Integer(Point.X < 0) - FProgressBuffer.Width)*Hori;
                                        Point.Y:= (Point.Y + 2*FProgressBuffer.Height*Integer(Point.Y < 0) - FProgressBuffer.Height)*Vert;
                                        FProgressBuffer.Render(FBuffer, Point, A_OPAQUE, RM_COPY);
                                end;
                        end;
                  end;
                  //
                  PAT_FLIPFLOP:
                  begin
                        SP:= FProgressRec.SmoothProgress*Integer(FProgressing) + FProgress*Integer(not FProgressing);
                        Long:= ((FProgressBuffer.Width - FProgressWidth)*Hori > 0)or((FProgressBuffer.Height - FProgressHeight)*Vert > 0);
                        W:= (FProgressWidth - FProgressBuffer.Width)*Integer(not Long) + (FProgressBuffer.Width - FProgressWidth)*Integer(Long);
                        H:= (FProgressHeight - FProgressBuffer.Height)*Integer(not Long) + (FProgressBuffer.Height - FProgressHeight)*Integer(Long);

                        if (FMaxValue - FMinValue <> 0) then X:= Trunc((W*Hori + H*Vert) * (FCount + 1) / (FMaxValue - FMinValue) * SP)
                        else X:= 0;
                        Fwd:= not Odd(X div (W*Hori + H*Vert));
                        X:= X mod (W*Hori + H*Vert);

                        Point.X:= (Integer(not Fwd)*W + Integer(Fwd)*2*X - X - W*Integer(Long))*Hori;
                        Point.Y:= (Integer(not Fwd)*H + Integer(Fwd)*2*X - X - H*Integer(Long))*Vert;
                        FProgressBuffer.Render(FBuffer, Point, A_OPAQUE, RM_COPY);
                  end;
                  //
                end;
          end;
          //
          PT_FRAMED:
          if (FFrameCount > 0) then
          begin
                SP:= FProgressRec.SmoothProgress*Integer(FProgressing) + FProgress*Integer(not FProgressing);
                if (FMaxValue - FMinValue <> 0) then X:= Trunc(FFrameCount * (FCount + 1) / (FMaxValue - FMinValue) * SP)
                else X:= 0;

                case FAnimationType of
                  PAT_FORWARD, PAT_CIRCULAR:
                  begin
                        X:= X mod FFrameCount;

                        Rect.Left:= (FProgressWidth * X)*Hori;
                        Rect.Top:= (FProgressHeight * X)*Vert;
                        Rect.RightBottom:= NewPoint(Rect.Left + FProgressWidth, Rect.Top + FProgressHeight);
                        FProgressBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);
                  end;
                  //
                  PAT_FLIPFLOP:
                  begin
                        Fwd:= not Odd(X div FFrameCount);
                        X:= X mod FFrameCount;

                        Rect.Left:= (FProgressWidth * (Integer(not Fwd)*FFrameCount + Integer(Fwd)*2*X - X))*Hori;
                        Rect.Top:= (FProgressHeight * (Integer(not Fwd)*FFrameCount + Integer(Fwd)*2*X - X))*Vert;
                        Rect.RightBottom:= NewPoint(Rect.Left + FProgressWidth, Rect.Top + FProgressHeight);
                        FProgressBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);
                  end;
                  //
                end;
          end;
          //
        end;

end;


procedure TAProgress.UpdateProgress;
var Hori, Vert: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Hori:= Integer(FOrientation = O_HORIZONTAL);
        Vert:= Integer(FOrientation = O_VERTICAL);

        case FProgressType of
          PT_BAR, PT_CURSOR:
          begin
                FProgressWidth:= (FWidth*Hori + FProgressBuffer.Width*Vert);
                FProgressHeight:= (FHeight*Vert + FProgressBuffer.Height*Hori);
          end;
          //
          PT_FRAMED:
          begin
                if ((FFrameCount*Hori + Vert) <> 0) then FProgressWidth:= FProgressBuffer.Width div (FFrameCount*Hori + Vert)
                else FProgressWidth:= 0;
                if ((FFrameCount*Vert + Hori) <> 0) then FProgressHeight:= FProgressBuffer.Height div (FFrameCount*Vert + Hori)
                else FProgressHeight:= 0;
          end;
          //
        end;

        FBuffer.Resize(FProgressWidth, FProgressHeight);
        Size(FProgressWidth, FProgressHeight);
        UpdateSmoothInc;
        Changed;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.UpdateSmoothInc;
var Hori, Vert, W, H: Integer;
    Long: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Hori:= Integer(FOrientation = O_HORIZONTAL);
        Vert:= Integer(FOrientation = O_VERTICAL);
        Long:= ((FProgressBuffer.Width - FProgressWidth)*Hori > 0)or((FProgressBuffer.Height - FProgressHeight)*Vert > 0);

        case FProgressType of
          PT_BAR:
          begin
                W:= FProgressWidth;
                H:= FProgressHeight;
          end;
          //
          PT_CURSOR:
          begin
                if (FAnimationType = PAT_FLIPFLOP) then
                begin
                        W:= (FProgressWidth - FProgressBuffer.Width)*Integer(not Long) + (FProgressBuffer.Width - FProgressWidth)*Integer(Long);
                        H:= (FProgressHeight - FProgressBuffer.Height)*Integer(not Long) + (FProgressBuffer.Height - FProgressHeight)*Integer(Long);
                end
                else begin
                        if (FCount = 0)and(not FUndetermined) then
                        begin
                                W:= (FProgressWidth - FProgressBuffer.Width)*Integer(not Long) + (FProgressBuffer.Width - FProgressWidth)*Integer(Long);
                                H:= (FProgressHeight - FProgressBuffer.Height)*Integer(not Long) + (FProgressBuffer.Height - FProgressHeight)*Integer(Long);
                        end
                        else begin
                                W:= (FProgressWidth + FProgressBuffer.Width)*Integer(not Long) + FProgressBuffer.Width*Integer(Long);
                                H:= (FProgressHeight + FProgressBuffer.Height)*Integer(not Long) + FProgressBuffer.Height*Integer(Long);
                        end;
                end;
          end;
          //
          // PT_FRAMED:
          else begin
                W:= FFrameCount;
                H:= FFrameCount;
          end;
          //
        end;

        if (FUndetermined) then FMaxValue:= FMinValue + (W*Hori + H*Vert);

        if (W*Hori + H*Vert <> 0) then FProgressRec.SmoothProgressInc:= (FMaxValue - FMinValue) * (FCount + 1) / (W*Hori + H*Vert)
        else FProgressRec.SmoothProgressInc:= 0;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.Load(const AFileName: String; AFrameCount: Integer; AProgressType, AOrientation: Integer; ACount, ATimeOut: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                FProgressBuffer.Load(AFileName);

                FFrameCount:= AFrameCount;

                FProgressRec.TimeOut:= ATimeOut;

                FProgressType:= AProgressType;
                FOrientation:= AOrientation;
                FCount:= ACount;
                UpdateProgress;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TAProgress.Unload;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        FProgressBuffer.Empty:= True;

        StopProgress;

        FFrameCount:= 0;

        FProgressType:= 0;
        FOrientation:= 0;
        FCount:= 0;
        UpdateProgress;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAProgress.StartProgress: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FProgressing)and(FProgressRec.TimeOut <> 0)and(FProgressRec.SmoothProgressInc > 0) then
        begin
                FProgressing:= True;
                Result:= True;

                TimerManager.AddTimer(TT_HOOK, TID_PROGRESS_SMOOTH, FProgressRec.TimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_PROGRESS_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TAProgress.StopProgress: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FProgressing) then
        begin
                FProgress:= Trunc(FProgressRec.SmoothProgress);
                FProgressing:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_PROGRESS_SMOOTH, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_PROGRESS_STOP, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##                                 TRACKBAR                                 ##
//##############################################################################


{ TATrack }





constructor TATrack.Create(const AName: String; AParent: TAForm; ABufferType, AControlType: Integer);
begin
inherited Create(AName, AParent, BT_FOOT, AControlType);



        FTracking:= False;



        Ft1:= 0;
        Ft2:= 0;
        FSetting:= False;



        FMinValue:= 0;
        FMaxValue:= 0;
        FValue:= 0;
end;


destructor TATrack.Destroy;
begin
        StopTrack;



inherited;
end;


procedure TATrack.SetBufferType(ABufferType: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        ABufferType:= ABufferType and (not BT_RESIZE);

        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.SetMinValue(AMinValue: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AMinValue, 0, FMaxValue);

        if (AMinValue <> FMinValue) then
        begin
                FMinValue:= AMinValue;


                if (FValue < FMinValue) then SetValue(FMinValue);
                UpdateSmoothInc;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.SetMaxValue(AMaxValue: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AMaxValue, FMinValue, MAX_INT);

        if (AMaxValue <> FMaxValue) then
        begin
                FMaxValue:= AMaxValue;


                if (FValue > FMaxValue) then SetValue(FMaxValue);
                UpdateSmoothInc;
                Changed;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.SetValue(AValue: Integer);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Restrict(AValue, FMinValue, FMaxValue);

        if (AValue <> FValue) then
        begin
                FValue:= AValue;


                StartTrack;
                Changed;

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TRACK_CHANGE, 0, 0, Self);
                (*--------------*)
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.ProcessMessage(Msg, WParam, LParam: Integer);
var Ho, Ve, W, H: Integer;
    SV: Extended;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case Msg of
          AM_SIZE: if (FStateCount and TT_FRAMED_ALL = 0) then UpdateButton;
          //
          AM_MOUSE_DOWNL:
          if (not FDisabled) then
          begin
                Ho:= Integer(FOrientation = O_HORIZONTAL);
                Ve:= Integer(FOrientation = O_VERTICAL);

                SV:= FTrackRec.SmoothValue*Integer(FTracking) + FValue*Integer(not FTracking);

                case FStateCount of
                  TT_PUSH, TT_TOGGLE:
                  begin
                        if (FButtonWidth > 0)and(FButtonHeight > 0) then
                        begin
                                W:= FButtonWidth*Ve + (FWidth - FButtonWidth)*Ho;
                                H:= FButtonHeight*Ho + (FHeight - FButtonHeight)*Ve;
                                if (FMaxValue - FMinValue <> 0) then Fx:= Trunc(LowInt(LParam)*Ho + HighInt(LParam)*Ve - (W*Ho + H*Ve) / (FMaxValue - FMinValue) * SV)
                                else Fx:= 0;

                                FSetting:= True;
                        end;
                  end;
                  //
                  TT_FRAMED_FORWARD:
                  begin
                        if (FFrameCount > 0)and(FOrientation <> 0) then
                        begin
                                Fx:= LowInt(LParam)*Ho + FValue*Ve;
                                Fy:= HighInt(LParam)*Ve + FValue*Ho;


                                FSetting:= True;
                        end;
                  end;
                  //
                  TT_FRAMED_CIRCULAR:
                  begin
                        if (FFrameCount > 0) then
                        begin
                                if (LowInt(LParam) - (FButtonWidth / 2)) <> 0 then Ft1:= ArcTan((HighInt(LParam) - (FButtonHeight / 2)) / (LowInt(LParam) - (FButtonWidth / 2)))
                                else Ft1:= 0;

                                Fx:= FValue;

                                FSetting:= True;
                        end;
                  end;
                  //
                end;

                SetCapture(True);
          end;
          //
          AM_MOUSE_MOVE:
          if (not FDisabled)and(FSetting) then
          begin
                Ho:= Integer(FOrientation = O_HORIZONTAL);
                Ve:= Integer(FOrientation = O_VERTICAL);

                case FStateCount of
                  TT_PUSH, TT_TOGGLE:
                  begin
                        W:= FButtonWidth*Ve + (FWidth - FButtonWidth)*Ho;
                        H:= FButtonHeight*Ho + (FHeight - FButtonHeight)*Ve;
                        SetValue(Trunc(((LowInt(LParam) - Fx)*Ho + (HighInt(LParam) - Fx)*Ve) * (FMaxValue - FMinValue) / (W*Ho + H*Ve)));
                  end;
                  //
                  TT_FRAMED_FORWARD: SetValue(Trunc((Fy*Ho + Fx*Ve + LowInt(LParam)*Ho + HighInt(LParam)*Ve - Fx*Ho - Fy*Ve) * (FMaxValue - FMinValue) / (FButtonWidth*Ho + FButtonHeight*Ve)));
                  //
                  TT_FRAMED_CIRCULAR:
                  begin
                        if (LowInt(LParam) - (FButtonWidth / 2)) <> 0 then Ft2:= ArcTan((HighInt(LParam) - (FButtonHeight / 2)) / (LowInt(LParam) - (FButtonWidth / 2)))
                        else Ft2:= 0;

                        SetValue(Trunc(Fx + (Ft2 - Ft1) * (FMaxValue - FMinValue) * 2*Pi));
                  end;
                  //
                end;
          end;
          //
          AM_MOUSE_UPL, AM_DISABLED_CHANGE:
          begin
                FSetting:= False;

                SetCapture(False);
          end;
          //
          AM_TRACK_START:
                (*==============*)
                (**) if (Assigned(FOnTrackStart)) then FOnTrackStart(Self);
                (*==============*)
          //
          AM_TRACK_STOP:
                (*==============*)
                (**) if (Assigned(FOnTrackStop)) then FOnTrackStop(Self);
                (*==============*)
          //
          AM_TRACK_CHANGE:
                (*==============*)
                (**) if (Assigned(FOnTrackChange)) then FOnTrackChange(Self);
                (*==============*)
          //
          AM_TIMER:
          begin
                case WParam of
                  //
                  TID_TRACK_SMOOTH:
                  begin
                        if (FValue <> FTrackRec.SmoothValue) then
                        begin
                                if (FValue > FTrackRec.SmoothValue)and(FValue < FTrackRec.SmoothValue + FTrackRec.SmoothValueInc) then FTrackRec.SmoothValue:= FValue
                                else if (FValue < FTrackRec.SmoothValue)and(FValue > FTrackRec.SmoothValue - FTrackRec.SmoothValueInc) then FTrackRec.SmoothValue:= FValue
                                else FTrackRec.SmoothValue:= FTrackRec.SmoothValue + Sgn(FValue - FTrackRec.SmoothValue) * FTrackRec.SmoothValueInc;

                                Changed;
                        end
                        else StopTrack;

                        (*==============*)
                        (**) if (Assigned(FOnTracking)) then FOnTracking(Self);
                        (*==============*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.Paint;
var Hori, Vert, Ho, Ve, X, W, H: Integer;
    Rect: TRect;
    Point: TPoint;
    SV: Extended;
begin
        Hori:= Integer(FFrameOrientation = O_HORIZONTAL);
        Vert:= Integer(FFrameOrientation = O_VERTICAL);
        Ho:= Integer(FOrientation = O_HORIZONTAL);
        Ve:= Integer(FOrientation = O_VERTICAL);

        SV:= FTrackRec.SmoothValue*Integer(FTracking) + FValue*Integer(not FTracking);

        case FStateCount of
          TT_PUSH, TT_TOGGLE:
          if (FButtonWidth > 0)and(FButtonHeight > 0) then
          begin
                W:= FButtonWidth*Ve + (FWidth - FButtonWidth)*Ho;
                H:= FButtonHeight*Ho + (FHeight - FButtonHeight)*Ve;
                if (FMaxValue - FMinValue <> 0) then X:= Trunc((W*Ho + H*Ve) / (FMaxValue - FMinValue) * SV)
                else X:= 0;

                FBuffer.Manipulate(MOP_FILL, 0, M_ALPHA);

                if (not FStateFadeAnimating) then
                begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Point:= NewPoint(X*Ho, X*Ve);
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrame*Vert), FButtonHeight*(FState*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, A_OPAQUE, RM_COPY);
                        end
                        else begin
                                Point:= NewPoint(X*Ho, X*Ve);
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FState*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FState*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FState*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end
                else begin
                        if (not FFrameFadeAnimating) then
                        begin
                                Point:= NewPoint(X*Ho, X*Ve);
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrame*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrame*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrame*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end
                        else begin
                                Point:= NewPoint(X*Ho, X*Ve);
                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Src*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FStateFadeAnimationRec.Src*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FBuffer, Point, Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Src*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Src*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);

                                Rect.LeftTop:= NewPoint(FButtonWidth*(FStateFadeAnimationRec.Dest*Hori + FFrameFadeAnimationRec.Dest*Vert), FButtonHeight*(FStateFadeAnimationRec.Dest*Vert + FFrameFadeAnimationRec.Dest*Hori));
                                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                                FButtonBuffer.Render(FFadeBuffer, NewPoint(0, 0), Rect, FFrameFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);

                                FFadeBuffer.Render(FBuffer, Point, FStateFadeAnimationRec.Alpha, RM_LOCALALPHA or RM_GLOBALALPHA);
                        end;
                end;
          end;
          //
          TT_FRAMED_FORWARD, TT_FRAMED_CIRCULAR:
          if (FFrameCount > 0)and(FMinValue <> FMaxValue) then
          begin
                if (FMaxValue - FMinValue <> 0) then X:= Trunc(FFrameCount / (FMaxValue - FMinValue) * SV)
                else X:= 0;

                Rect.Left:= (FButtonWidth * X)*Hori;
                Rect.Top:= (FButtonHeight * X)*Vert;
                Rect.RightBottom:= NewPoint(Rect.Left + FButtonWidth, Rect.Top + FButtonHeight);
                FButtonBuffer.Render(FBuffer, NewPoint(0, 0), Rect, A_OPAQUE, RM_COPY);
          end;
          //
        end;
end;


procedure TATrack.UpdateButton;
var Ho, Ve, AWidth, AHeight: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Ho:= Integer(FOrientation = O_HORIZONTAL);
        Ve:= Integer(FOrientation = O_VERTICAL);

        case FStateCount of
          TT_PUSH, TT_TOGGLE:
          begin
                AWidth:= FButtonWidth*Ve + FWidth*Ho;
                AHeight:= FButtonHeight*Ho + FHeight*Ve;
          end;
          //
          // TT_FRAMED_FORWARD, TT_FRAMED_CIRCULAR:
          else begin
                AWidth:= FButtonWidth;
                AHeight:= FButtonHeight;
          end;
          //
        end;

        FBuffer.Resize(AWidth, AHeight);
        Size(AWidth, AHeight);
        UpdateSmoothInc;
        Changed;

        (*{}{}{}{}{}{}{}*)
        (**) UpdateRgnList;
        (*{}{}{}{}{}{}{}*)

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.UpdateFrameOrientation;
var Hori, Vert: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Hori:= Integer(FFrameOrientation = O_HORIZONTAL);
        Vert:= Integer(FFrameOrientation = O_VERTICAL);

        case FStateCount of
          TT_PUSH, TT_TOGGLE:
          begin
                if (FStateCount*Hori + FFrameCount*Vert <> 0) then FButtonWidth:= FButtonBuffer.Width div (FStateCount*Hori + FFrameCount*Vert)
                else FButtonWidth:= 0;
                if (FStateCount*Vert + FFrameCount*Hori <> 0) then FButtonHeight:= FButtonBuffer.Height div (FStateCount*Vert + FFrameCount*Hori)
                else FButtonHeight:= 0;
          end;
          //
          TT_FRAMED_FORWARD, TT_FRAMED_CIRCULAR:
          begin
                if (Vert + FFrameCount*Hori <> 0) then FButtonWidth:= FButtonBuffer.Width div (Vert + FFrameCount*Hori)
                else FButtonWidth:= 0;
                if (Hori + FFrameCount*Vert <> 0) then FButtonHeight:= FButtonBuffer.Height div (Hori + FFrameCount*Vert)
                else FButtonHeight:= 0;
          end;
          //
        end;

        FFadeBuffer.Resize(FButtonWidth, FButtonHeight);
        Changed;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.UpdateSmoothInc;
var Ho, Ve, W, H: Integer;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        case FStateCount of
          TT_PUSH, TT_TOGGLE:
          begin
                Ho:= Integer(FOrientation = O_HORIZONTAL);
                Ve:= Integer(FOrientation = O_VERTICAL);

                W:= FButtonWidth*Ve + (FWidth - FButtonWidth)*Ho;
                H:= FButtonHeight*Ho + (FHeight - FButtonHeight)*Ve;
          end;
          //
          // TT_FRAMED_FORWARD, TT_FRAMED_CIRCULAR:
          else begin
                Ho:= Integer(FFrameOrientation = O_HORIZONTAL);
                Ve:= Integer(FFrameOrientation = O_VERTICAL);

                W:= FFrameCount;
                H:= FFrameCount;
          end;
          //
        end;

        if (W*Ho + H*Ve) <> 0 then FTrackRec.SmoothValueInc:= (FMaxValue - FMinValue) * (FCount + 1)/ (W*Ho + H*Ve)
        else FTrackRec.SmoothValueInc:= 0;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TATrack.StartTrack: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (not FTracking)and(FTrackRec.TimeOut <> 0)and(FTrackRec.SmoothValueInc <> 0) then
        begin
                FTracking:= True;
                Result:= True;

                TimerManager.AddTimer(TT_HOOK, TID_TRACK_SMOOTH, FTrackRec.TimeOut, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TRACK_START, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


function TATrack.StopTrack: Boolean;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        if (FTracking) then
        begin
                FValue:= Trunc(FTrackRec.SmoothValue);        
                FTracking:= False;
                Result:= True;

                TimerManager.RemoveTimer(TT_HOOK, TID_TRACK_SMOOTH, Self);

                (*--------------*)
                (**) if (FParent <> nil) then FLayerManager.SendMessage(AM_TRACK_STOP, 0, 0, Self);
                (*--------------*)
        end
        else Result:= False;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.Load(const AFileName: String; ATrackType, AFrameCount: Integer; AOrientation, AFrameOrientation: Integer; ACount, ATimeOut: Integer; AStateSpeed: Extended = 0; AStateAcceleration: Extended = 0; AStateTimeOut: Integer = 0; AFrameSpeed: Extended = 0; AFrameAcceleration: Extended = 0; AFrameTimeOut: Integer = 0);
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        Unload;

        if FileExists(AFileName) then
        begin
                FButtonBuffer.Load(AFileName);

                FStateCount:= ATrackType;
                FFrameCount:= AFrameCount;

                FStateFadeAnimationRec.Speed:= AStateSpeed;
                FStateFadeAnimationRec.Acceleration:= AStateAcceleration;
                FStateFadeAnimationRec.TimeOut:= AStateTimeOut;
                FFrameFadeAnimationRec.Speed:= AFrameSpeed;
                FFrameFadeAnimationRec.Acceleration:= AFrameAcceleration;
                FFrameFadeAnimationRec.TimeOut:= AFrameTimeOut;
                FFrameAnimationRec.TimeOut:= AFrameTimeOut;

                FTrackRec.TimeOut:= ATimeOut;

                FOrientation:= AOrientation;
                FFrameOrientation:= AFrameOrientation;
                FCount:= ACount;
                UpdateFrameOrientation;
                UpdateButton;
                UpdateState;
                UpdateAnimation;
        end;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;


procedure TATrack.UnLoad;
begin
      {$IFDEF THREADSAFE}
       ThreadManager.SetExclusive;
      {$ENDIF}

        FButtonBuffer.Empty:= True;

        StopStateFadeAnimation;
        StopFrameAnimation(True);
        StopFrameFadeAnimation(True);
        StopTrack;

        FState:= 0;
        FStateCount:= 0;
        FFrame:= 0;
        FFrameCount:= 0;

        FFrameOrientation:= 0;
        FCount:= 0;
        FOrientation:= 0;
        UpdateFrameOrientation;
        UpdateButton;

      {$IFDEF THREADSAFE}
       ThreadManager.ClearExclusive;
      {$ENDIF}
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                              INITIALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Init;
begin
end;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//#######################                                 ######################
//#######################                                 ######################
//##                                FINALIZATION                              ##
//#######################                                 ######################
//#######################                                 ######################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
procedure Final;
begin
end;

//##############################################################################
//##############################################################################

End.
