Unit Unit1;

        		//###############
        		//## INTERFACE ##
        		//###############
                        Interface

        		//##############
        		//##   USES   ##
        		//##############
        		Uses
                        //######################################################
                        //######################## SYSTEM ######################
                                	          {System,}
                                   	          HWindows,
                                	          HMessages,
                                                  HMultimedia,
                                                  HNetwork,

                        //######################################################
                        //######################### FOOT #######################
                                                  Foot,

                        //######################################################
                        //########################## OWN #######################
                                                  AHeap,
                                		  ARoutine,
                                                  ADevices,
                                                  UCore,
                                                  UBasic,
                                                  UPrimitives,
                                                  UExtended;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                                INTERFACE                                 ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




                        //##############
                        //### CONST  ###
                        //##############
                        Const
                        //######################################################
                        //#################### SHARE GETINFO ###################

  STYPE_DISKTREE = 0; // directory share.
  STYPE_PRINTQ   = 1; // printer share.
  STYPE_DEVICE   = 2; // device share.
  STYPE_IPC      = 3; // IPC share.

  ACCESS_READ   = 1;
  ACCESS_WRITE  = 2;
  ACCESS_CREATE = 4;
  ACCESS_EXEC   = 8;
  ACCESS_DELETE = 10;
  ACCESS_ATRIB  = 20;
  ACCESS_PERM   = 40;
  ACCESS_ALL    = (ACCESS_READ or ACCESS_WRITE or ACCESS_CREATE or
                   ACCESS_EXEC or ACCESS_DELETE or ACCESS_ATRIB or
                   ACCESS_PERM);

  SHI_USES_UNLIMITED  = -1;

  SA_READONLY    = 1;                        // share is read only.
  SA_FULL        = 2;                        // share is full access.
  SA_DEPENDSON   = (SA_READONLY or SA_FULL); // access depends upon password entered by user.
  SA_PERSIST     = 256;                      // share is restored on system startup.
  SA_SYSTEM      = 512;                      // share is not normally visible.

                        //######################################################
                        //##################### GLOBAL USED ####################

  TID_UPDATENETWORK = 10;
  TID_UPDATEPROGRESS = 11;

  AM_FOOT_FREE   = AM_LAST_EXTENDED + 1;
  AM_BUTTON_FREE = AM_LAST_EXTENDED + 2;

  DS_DROPPED = 0;
  DS_DROPPING = 1;
  DS_UNDROPPING = 2;
  DS_UNDROPPED = 3;

  AS_ADDED = 0;
  AS_ADDING = 1;
  AS_REMOVING = 2;
  AS_REMOVED = 3;

  OP_ADD = 0;
  OP_REMOVE = 1;

                        //######################################################
                        //################### CURSOR SIZE ADD ##################

  CURSORADDX = 20;
  CURSORADDY = 20;

                        //##############
                        //### TYPES  ###
                        //##############
                        Type
                        //######################################################
                        //#################### SHARE GETINFO ###################

  SHARE_INFO50 = packed record
                   shi50_netname : array[0..12] of Char; {13}
                   shi50_type    : Byte;
                   shi50_flags   : Word;
                   shi50_remark  : PChar; {49}
                   shi50_path    : PChar; {260}
                   shi50_rw_password : array[0..8] of Char; {9}
                   shi50_ro_password : array[0..8] of Char; {9}
  end;

  SHARE_INFO2 = packed record
    shi2_netname: PChar;
    shi2_type: Integer;
    shi2_remark: PChar;
    shi2_permissions: Integer;
    shi2_max_uses: Integer;
    shi2_current_uses: Integer;
    shi2_path: PChar;
    shi2_passwd: PChar;
  end;

  TShareInfo = record
    Local,
    Remote: String;
    DevType: Integer;
    DevAccess: Integer;
  end;

                        //######################################################
                        //######################## CLASSES #####################

  TListButton = class;
  TListPanel = class;
  TMainForm = class;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                            EXPLICIT INTERFACE                            ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################




//##############################################################################
//##                                 LISTPANEL                                ##
//##############################################################################


  TListPanel = class(TAPanel)
  protected
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
(*============================================================================*)
  end;


//##############################################################################
//##                                 LISTBUTTON                               ##
//##############################################################################


  TListButton = class(TAButton)
  protected
    FDropState: Integer;
    FAddState: Integer;
(*============================================================================*)
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
(*============================================================================*)
    property DropState: Integer read FDropState write FDropState;
    property AddState: Integer read FAddState write FAddState;
  end;


//##############################################################################
//##                                  MAINFORM                                ##
//##############################################################################


  TMainForm = class(TAForm)
  protected
(*============================================================================*)
    function WindowProc(AHandle: LongWord; Msg, WParam, LParam: Integer): Integer; override; stdcall;
    procedure ProcessMessage(Msg, WParam, LParam: Integer); override;
(*============================================================================*)
  end;


                        //##############
                        //###  VARS  ###
                        //##############
                        Var
                        //######################################################
                        //##################### GLOBAL USED ####################

        MenuMin,
        MenuRes,
        MenuClo: TAButton;
        Cursor: TAAnimation;

        Cov: TAPanel;
        Min,
        Clo: TAButton;
        Move: TAPanel;
        Light: TAPanel;

        UserList: TAListbox;
        UserScroll: TAScroll;

        Foot: TAPanel;

        SharePan: TListPanel;
        ShareList: TAListbox;
        ShareScrollH,
        ShareScrollV: TAScroll;
        Updating: TAPanel;
        Upff: TAProgress;

        RUserList: TAStringList;
        RShareList: TAList;
        P, D, S: TFoot;


        mainForm: TMainForm;

        dropped: Boolean = False;
        droppedButton: TListButton = nil;
        droppedScroll: Integer = 0;
        updater: Boolean = False;
        updaterTime: Cardinal = 0;
        updaterLock: TALock;




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Initialize;
procedure Finalize;

//##############################################################################
//##                                 events                                   ##
//##############################################################################

procedure OnMinPush(Sender: TObject);
procedure OnCloPush(Sender: TObject);
procedure OnFootStop(Sender: TObject);

//##############################################################################
//##                             custom functions                             ##
//##############################################################################

procedure AddButton(const AUser: String; AInsertIndex: Integer = MaxInt);
procedure RemoveButton(AButton: TListButton);
//#
procedure DropButton(AButton: TListButton);
procedure UndropButton(AButton: TListButton);
//#
procedure UpdateNetwork;

//##############################################################################
//##                         share external functions                         ##
//##############################################################################

{
function XP_NetGetShareInfo(ServerName: PChar; NetName: PChar; ShareLevel: SmallInt; Buffer: Pointer): Integer; stdcall;
function XP_NetApiBufferFree(Buffer: Pointer): Integer; stdcall;
}
function ME_NetGetShareInfo(ServerName: PChar; NetName: PChar; ShareLevel: SmallInt; Buffer: Pointer; Size: Word; var Used: Word): Integer; stdcall;
//#
function NetGetShareInfo(const AUserName, AShareName: String; var AErr: Integer): TShareInfo;




//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##########################                          ##########################
//##########################                          ##########################
//##                              IMPLEMENTATION                              ##
//##########################                          ##########################
//##########################                          ##########################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
//##############################################################################
Implementation




//##############################################################################
//##                              init and final                              ##
//##############################################################################

procedure Initialize;
var AButton: TListButton;
begin
        P:= TFoot.Create;
        P.Load('Skin\_sP.f');
        D:= TFoot.Create;
        D.Load('Skin\_sD.f');
        S:= TFoot.Create;
        S.Load('Skin\_sS.f');


        mainForm:= TMainForm.Create('mainForm', BT_FOOT, FT_CONTROLS_ON or FT_ALWAYS_ON_TOP or FT_FOCUSABLE or FT_CREATERGN or FT_OPTIMALRGN, @TMainForm.WindowProc);
        mainForm.ConstraintsType:= CT_MIN_BUFFER;
        mainForm.Load('Skin\form.f');
        mainForm.RgnAlpha:= A_OPAQUE;


        MenuMin:= TAButton.Create('menuMin', mainForm, BT_FOOT, CT_ON or CT_VISIBLE);
        MenuMin.Load('Skin\_minimize.f', BT_PUSH, 1, O_VERTICAL, 1, 0.1, 4);
        MenuMin.AnimationType:= BAT_STATE_FADE;

        MenuRes:= TAButton.Create('menuRes', mainForm, BT_FOOT, CT_ON or CT_VISIBLE);
        MenuRes.Load('Skin\_restore.f', BT_PUSH, 1, O_VERTICAL, 1, 0.1, 4);
        MenuRes.AnimationType:= BAT_STATE_FADE;

        MenuClo:= TAButton.Create('menuClo', mainForm, BT_FOOT, CT_ON or CT_VISIBLE);
        MenuClo.Load('Skin\_close.f', BT_PUSH, 1, O_VERTICAL, 1, 0.1, 4);
        MenuClo.AnimationType:= BAT_STATE_FADE;

        SetMenu(MenuMin, MenuRes, MenuClo);


        Cursor:= TAAnimation.Create('cursor', nil, BT_FOOT, CT_ON);
        Cursor.Load('Skin\cursor.f', 4, 1, O_HORIZONTAL);
        Cursor.BufferRender:= RM_LOCALALPHA;
        Cursor.RgnAlpha:= A_OPAQUE - 100;

        SetCursor(Cursor, NewPoint(13, 13));


        Cov:= TAPanel.Create('cover', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Cov.ConstraintsType:= CT_MIN_BUFFER;
        Cov.Load('Skin\cov.f');
        Cov.Move(CURSORADDX, CURSORADDY);
        Cov.BufferRender:= RM_LOCALALPHA;
        Cov.LocationAlpha:= A_OPAQUE;

        Move:= TAPanel.Create('move', mainForm, BT_FOOT, CT_MSG or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Move.ConstraintsType:= CT_MIN_BUFFER;
        Move.Load('Skin\move.f');
        Move.Move(CURSORADDX, CURSORADDY);
        Move.LocationAlpha:= A_OPAQUE;
        mainForm.MoveControl:= Move;
        mainForm.ControlMovable:= True;

        Min:= TAButton.Create('min', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Min.Load('Skin\min.f', BT_PUSH, 1, O_HORIZONTAL, 1, 0.1, 4);
        Min.AnimationType:= BAT_STATE_FADE;
        Min.Move(CURSORADDX + 117, CURSORADDY + 7);
        Min.BufferRender:= RM_LOCALALPHA;
        Min.LocationAlpha:= A_OPAQUE;
        Min.OnPush:= OnMinPush;

        Clo:= TAButton.Create('clo', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Clo.Load('Skin\clo.f', BT_PUSH, 1, O_HORIZONTAL, 1, 0.1, 4);
        Clo.AnimationType:= BAT_STATE_FADE;
        Clo.Move(CURSORADDX + 135, CURSORADDY + 8);
        Clo.BufferRender:= RM_LOCALALPHA;
        Clo.LocationAlpha:= A_OPAQUE;
        Clo.OnPush:= OnCloPush;

        Light:= TAPanel.Create('light', mainForm, BT_FOOT, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Light.ConstraintsType:= CT_MIN_BUFFER;
        Light.Load('Skin\light.f');
        Light.Move(CURSORADDX + 6, CURSORADDY + 6);
        Light.BufferRender:= RM_LOCALALPHA;


        fontManager.AddFont('Skin\font.fnt');
        fontManager.AddFont('Skin\share.fnt');


        UserScroll:= TAScroll.Create('userscroll', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        UserScroll.Load('Skin\userscroll.f', TT_PUSH, 1, O_VERTICAL, O_HORIZONTAL, 6, 6, 1, 0.1, 4);
        UserScroll.AnimationType:= SAT_STATE_FADE;
        UserScroll.SetBounds(CURSORADDX + 149, CURSORADDY + 38, 0, 139);
        UserScroll.BufferRender:= RM_LOCALALPHA;
        UserScroll.LocationAlpha:= A_OPAQUE;
        UserScroll.RgnAlpha:= A_OPAQUE;

        UserList:= TAListbox.Create('userlist', mainForm, BT_FOOT, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        UserList.Load(6, 6, 10, 10);
        UserList.V:= UserScroll;
        UserList.SetBounds(CURSORADDX, CURSORADDY - 5, Cov.Width, Cov.Height);
        UserList.BufferRender:= RM_LOCALALPHA;
        UserList.ListboxType:= LBT_CONTROL_ITEMHEIGHT or LBT_RESTRICT;

                // create the top button.
                AButton:= TListButton.Create('topbutton', mainForm, BT_FOOT, 0);
                AButton.Load('Skin\but.f', BT_PUSH, 1, O_VERTICAL);
                AButton.Move(CURSORADDX, CURSORADDY);
                UserList.AddItem('font', 'font', '', AButton, 20, 10);


        Foot:= TAPanel.Create('foot', mainForm, BT_FOOT, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Foot.ConstraintsType:= CT_MIN_BUFFER;
        Foot.Load('Skin\foot.f');
        Foot.SetBounds(CURSORADDX + 45, CURSORADDY + 40, 66, 114);
        Foot.BufferRender:= RM_COPY or RM_GLOBALALPHA;
        Foot.OnAlphaAnimationStop:= OnFootStop;
        Foot.StartAlphaAnimation(A_OPAQUE, A_CLEAR, 1, 0.01, 32);


        SharePan:= TListPanel.Create('sharepan', mainForm, BT_FOOT, CT_ON or CT_ALWAYS_ON_TOP);
        SharePan.Load('Skin\sharepan.f');
        SharePan.ContainerFlags:= CF_PARENT or CF_MOVE or CF_ALPHA;
        SharePan.SetBounds(CURSORADDX, CURSORADDY, 140, 145);
        SharePan.BufferRender:= RM_COPY or RM_GLOBALALPHA;
        SharePan.Alpha:= A_CLEAR;

        ShareList:= TAListbox.Create('sharelist', mainForm, BT_FOOT or BT_RESIZE, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        ShareList.Load(3, 3, 6, 6);
        ShareList.SetBounds(CURSORADDX + 8, CURSORADDY + 1, 126, 140);
        ShareList.BufferRender:= RM_LOCALALPHA or RM_GLOBALALPHA;
        ShareList.Alpha:= A_CLEAR;
        ShareList.ListboxType:= LBT_FOOT_ITEMHEIGHT;
        SharePan.AddContainerChild(ShareList, CF_PARENT or CF_MOVE or CF_ALPHA);

        ShareScrollV:= TAScroll.Create('sharescrollv', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        ShareScrollV.Load('Skin\sharescrollv.f', TT_PUSH, 1, O_VERTICAL, O_HORIZONTAL, 3, 6, 2, 0.1, 6);
        ShareScrollV.AnimationType:= SAT_STATE_FADE;
        ShareScrollV.SetBounds(CURSORADDX + 119, CURSORADDY + 4, 0, 133);
        ShareScrollV.BufferRender:= RM_LOCALALPHA or RM_GLOBALALPHA;
        ShareScrollV.Alpha:= A_CLEAR;
        ShareScrollV.LocationAlpha:= A_OPAQUE - 150;
        SharePan.AddContainerChild(ShareScrollV, CF_PARENT or CF_MOVE or CF_ALPHA);

        ShareScrollH:= TAScroll.Create('sharescrollh', mainForm, BT_FOOT, CT_ON or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        ShareScrollH.Load('Skin\sharescrollh.f', TT_PUSH, 1, O_HORIZONTAL, O_VERTICAL, 3, 6, 2, 0.1, 6);
        ShareScrollH.AnimationType:= SAT_STATE_FADE;
        ShareScrollH.SetBounds(CURSORADDX + 11, CURSORADDY + 125, 107, 0);
        ShareScrollH.BufferRender:= RM_LOCALALPHA or RM_GLOBALALPHA;
        ShareScrollH.Alpha:= A_CLEAR;
        ShareScrollH.LocationAlpha:= A_OPAQUE - 150;
        SharePan.AddContainerChild(ShareScrollH, CF_PARENT or CF_MOVE or CF_ALPHA);
        ShareList.V:= ShareScrollV;
        ShareList.H:= ShareScrollH;

        RUserList:= TAStringList.Create;
        RShareList:= TAList.Create;

        Updating:= TAPanel.Create('updating', mainForm, BT_FOOT, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Updating.ConstraintsType:= CT_MIN_BUFFER;
        Updating.Load('Skin\updating.f');
        Updating.Move(CURSORADDX + 15, CURSORADDY + 29);
        Updating.BufferRender:= RM_LOCALALPHA or RM_GLOBALALPHA;
        Updating.Alpha:= A_CLEAR;

        Upff:= TAProgress.Create('upff', mainForm, BT_FOOT, CT_DRAW or CT_VISIBLE or CT_ALWAYS_ON_TOP);
        Upff.Load('Skin\upff.f', 1, PT_CURSOR, O_VERTICAL, 0, 8);
        Upff.AnimationType:= PAT_FLIPFLOP;
        Upff.SetBounds(CURSORADDX + 15, CURSORADDY, 0, 210);
        Upff.BufferRender:= RM_LOCALALPHA or RM_GLOBALALPHA;
        Upff.Alpha:= A_CLEAR;
        Upff.Undetermined:= True;
        Updating.AddContainerChild(Upff, CF_PARENT or CF_ALPHA);

        Cov.Surface;
        Light.Surface;
        UserScroll.Surface;
        Move.Surface;
        Min.Surface;
        Clo.Surface;



        mainForm.AddRgnLayer(mainForm);
        mainForm.AddRgnLayer(UserScroll);
        mainForm.Move(Screen.DesktopBounds.Right - mainForm.Width - 30, 100);
        mainForm.Show;

        TimerManager.AddTimer(TT_THREAD, TID_UPDATENETWORK, 30000, mainForm);
end;


procedure Finalize;
var AButton: TListButton;
begin
        mainForm.Hide;

        TimerManager.RemoveTimer(TT_THREAD, TID_UPDATENETWORK, mainForm);
        TimerManager.RemoveTimer(TT_HOOK, TID_UPDATEPROGRESS, mainForm);



        FreeNil(Upff);
        FreeNil(Updating);

        FreeNil(RUserList);
        FreeNil(RShareList);

        FreeNil(ShareScrollV);
        FreeNil(ShareScrollH);
        FreeNil(ShareList);
        FreeNil(SharePan);

        FreeNil(Foot);

                // free all the buttons in the list.
                while (UserList.ItemCount > 0) do
                begin
                        AButton:= TListButton(UserList.Items[0].Control);
                        UserList.RemoveItem(0);
                        FreeNil(AButton);
                end;

        FreeNil(UserList);
        FreeNil(UserScroll);

        fontManager.RemoveFont('font');
        fontManager.RemoveFont('share');

        FreeNil(Clo);
        FreeNil(Min);
        FreeNil(Move);
        FreeNil(Light);
        FreeNil(Cov);

        SetCursor(nil, NewPoint(0, 0));

        FreeNil(Cursor);

        SetMenu(nil, nil, nil);

        FreeNil(MenuMin);
        FreeNil(MenuRes);
        FreeNil(MenuClo);

        FreeNil(mainForm);

        FreeNil(P);
        FreeNil(D);
        FreeNil(S);
end;

//##############################################################################
//##                                 events                                   ##
//##############################################################################

procedure OnMinPush(Sender: TObject);
begin
        Application.Minimize;
end;


procedure OnCloPush(Sender: TObject);
begin
        Application.Terminate;
end;


procedure OnFootStop(Sender: TObject);
begin
        (*-----------*)
        (**) mainForm.LayerManager.PostMessage(AM_FOOT_FREE, 0, 0, mainForm);
        (*-----------*)
end;

//##############################################################################
//##                             custom functions                             ##
//##############################################################################

procedure AddButton(const AUser: String; AInsertIndex: Integer = MaxInt);
var AButton: TListButton;
begin
        AButton:= TListButton.Create(AUser, mainForm, BT_FOOT, CT_ON or CT_VISIBLE);
        AButton.Load('Skin\but.f', BT_PUSH, 1, O_VERTICAL, 2, 0.1, 6);
        AButton.Move(CURSORADDX, CURSORADDY);
        AButton.AnimationType:= BAT_STATE_FADE;
        AButton.ContainerFlags:= CF_PARENT or CF_MOVE;
        AButton.BufferRender:= RM_TRANSPARENCE or RM_GLOBALALPHA;
        AButton.Height:= 0;
        AButton.Surface;

        AButton.FDropState:= DS_UNDROPPED;
        AButton.FAddState:= AS_ADDING;

        AButton.StartSizeAnimation(AButton.Width, 0, AButton.Width, 37, 0, 1, 0, 0, 8);
        AButton.StartAlphaAnimation(A_CLEAR, A_OPAQUE, 1, 0, 4);
        // add now.
        UserList.InsertItem(AInsertIndex + 1, 'font', 'font', AUser, AButton, 30, 10);
end;


procedure RemoveButton(AButton: TListButton);
begin
        if (AButton.FDropState <> DS_UNDROPPED) then
        begin
                AButton.StopSizeAnimation;
                AButton.FDropState:= DS_UNDROPPING;
        end;

        if (AButton.FAddState <> AS_ADDED) then
        begin
                AButton.StopSizeAnimation;
                AButton.StopAlphaAnimation;
        end;

        AButton.FAddState:= AS_REMOVING;

        AButton.StartSizeAnimation(AButton.Width, AButton.Height, AButton.Width, 0, 0, 1, 0, 0, 8);
        AButton.StartAlphaAnimation(AButton.Alpha, A_CLEAR, 1, 0, 4);
        // remove delayed.
end;


//#
procedure DropButton(AButton: TListButton);
var i: Integer;
    AOneShareList: TAStringList;
begin
        if (AButton.FDropState = DS_UNDROPPED)and(AButton.FAddState = AS_ADDED) then
        begin
                // add pan now.
                AButton.AddContainerChild(SharePan, CF_PARENT or CF_MOVE);
                SharePan.Left:= AButton.Left;
                SharePan.Top:= AButton.Top + 3;
                SharePan.Visible:= True;
                SharePan.StopAlphaAnimation;
                SharePan.StartAlphaAnimation(0, A_OPAQUE, 3, 0.1, 4);

                AButton.StartSizeAnimation(AButton.Width, 37, AButton.Width, 146, 0, 3, 0, 0.1, 4);

                AButton.FDropState:= DS_DROPPING;

                // set now.
                dropped:= True;
                droppedButton:= AButton;
                droppedScroll:= Trunc(UserScroll.Value*Integer(not UserScroll.Scrolling) + UserScroll.ScrollRec.SmoothValueInc*Integer(UserScroll.Scrolling));


                AOneShareList:= RShareList.Items[UserList.FindItem(AButton) - 1];
                ShareList.Clear;
                for i:= 0 to AOneShareList.Count-1 do
                case AOneShareList.Items[i][1] of
                  'P': ShareList.AddItem('share', 'share', StringLower(Copy(AOneShareList.Items[i], 2, MAX_INT)), P, 35, 0);
                  'D': ShareList.AddItem('share', 'share', StringLower(Copy(AOneShareList.Items[i], 2, MAX_INT)), D, 35, 0);
                  'S': ShareList.AddItem('share', 'share', StringLower(Copy(AOneShareList.Items[i], 2, MAX_INT)), S, 35, 0);
                end;
        end;
end;


procedure UndropButton(AButton: TListButton);
begin
        if (AButton.FDropState = DS_DROPPED)and(AButton.FAddState = AS_ADDED) then
        begin
                // remove pan delayed.
                SharePan.StopAlphaAnimation;
                SharePan.StartAlphaAnimation(A_OPAQUE, 0, 3, 0.1, 4);

                AButton.StartSizeAnimation(AButton.Width, 146, AButton.Width, 37, 0, 3, 0, 0.1, 4);

                AButton.FDropState:= DS_UNDROPPING;

                // unset delayed.
        end;
end;


procedure UpdateNetwork;
var AUserList: TAStringList;
    AShareList: TAList;
    AOneShareList: TAStringList;
    AGroup: TWorkgroupRec;
    i, j: Integer;

    AIndex: Integer;
begin
        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.SetExclusive;
        (*/\/\/\/\/\/\/\/*)

          // start progress.
          updater:= True;
          updaterTime:= HMultimedia.timeGetTime;
          TimerManager.AddTimer(TT_HOOK, TID_UPDATEPROGRESS, 50, mainForm);

        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.ClearExclusive;
        (*/\/\/\/\/\/\/\/*)

        // update the network users.
        Network.UpdateWorkgroups;

        // make temp list with new users.
        AUserList:= TAStringList.Create;
        for i:= 0 to Network.WorkgroupCount-1 do
        begin
                AGroup:= Network.Workgroups[i];

                for j:= 0 to AGroup.UserCount-1 do
                        AUserList.Add(StringLower(AGroup.Users.Items[j]));
        end;
        AUserList.Sort;

        // update the network shares.
        AShareList:= TAList.Create;
        for i:= 0 to AUserList.Count-1 do
        begin
                Network.UpdateShares(AUserList.Items[i]);

                AOneShareList:= TAStringList.Create;
                for j:= 0 to Network.ShareCount-1 do
                begin
                        case Network.Shares[j].ResType of
                          RESOURCETYPE_DISK: AOneShareList.Add('D' + Network.Shares[j].Path);
                          RESOURCETYPE_PRINT: AOneShareList.Add('P' + Network.Shares[j].Path);
                          else AOneShareList.Add('S' + Network.Shares[j].Path);
                        end;
                end;
                AOneShareList.Sort;
                AShareList.Add(AOneShareList);
        end;

        // remove the users that appear to be online but aren't.
        i:= 0;
        while i < AUserList.Count do
        begin
                AOneShareList:= AShareList.Items[i];

                if AOneShareList.Count = 0 then
                begin
                        AUserList.Delete(i);
                        AOneShareList.Free;
                        AShareList.Delete(i);
                end
                else Inc(i);
        end;

        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.SetExclusive;
        (*/\/\/\/\/\/\/\/*)

          // update the real user list.
          i:= 0;
          j:= 0;
          while (i < AUserList.Count)and(j < RUserList.Count) do
          begin
                  if (AUserList.Items[i] = RUserList.Items[j]) then
                  begin
                          Inc(i);
                          Inc(j);
                  end
                  else begin
                          if (AUserList.Find(RUserList.Items[j]) = -1) then
                          begin
                                  AIndex:= UserList.FindItem(RUserList.Items[j]);
                                  RemoveButton(TListButton(UserList.Items[AIndex].Control));
                                  Inc(j);
                          end
                          else if (RUserList.Find(AUserList.Items[i]) = -1) then
                          begin
                                  AddButton(AUserList.Items[i], j);
                                  Inc(i);
                          end;
                  end;
          end;

          while (i < AUserList.Count) do
          begin
                  AddButton(AUserList.Items[i]);
                  Inc(i);
          end;

          while (j < RUserList.Count) do
          begin
                  AIndex:= UserList.FindItem(RUserList.Items[j]);
                  RemoveButton(TListButton(UserList.Items[AIndex].Control));
                  Inc(j);
          end;

          FreeNil(RUserList);
          RUserList:= AUserList;

          // update real share list.
          for i:= 0 to RShareList.Count-1 do TAStringList(RShareList.Items[i]).Free;
          FreeNil(RShareList);
          RShareList:= AShareList;

          // stop progress.
          updater:= False;
          updaterTime:= 0;
          TimerManager.RemoveTimer(TT_HOOK, TID_UPDATEPROGRESS, mainForm);
          Updating.StopAlphaAnimation;
          Updating.StartAlphaAnimation(Updating.Alpha, A_CLEAR, 2, 0.1, 4);
          Upff.StopProgress;

        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.ClearExclusive;
        (*/\/\/\/\/\/\/\/*)
end;


//##############################################################################
//##                         share external functions                         ##
//##############################################################################

{
function XP_NetGetShareInfo; external 'netapi32.dll' name 'NetShareGetInfo';
function XP_NetApiBufferFree; external 'netapi32.dll' name 'NetApiBufferFree';
}
function ME_NetGetShareInfo; external 'svrapi.dll' name 'NetShareGetInfo';

function NetGetShareInfo(const AUserName, AShareName: String; var AErr: Integer): TShareInfo;
var
  { XPShare: ^SHARE_INFO2; }
    MEShare: ^SHARE_INFO50;
    Used: Word;
    S: String;
begin
        case WindowsFamily of
          WINFAMILY_NT:
          begin
                {
                XPShare:= nil;

                S:= Copy(AShareName, Pos('\', Copy(AShareName, 2, MAX_INT)) + 2, MAX_INT);
                AErr:= XP_NetGetShareInfo(PChar(StringUpper('\\' + AUserName)), PChar(StringUpper(AShareName)), 2, XPShare);

                if (XPShare <> nil) then
                begin
                        Result.Local:= XPShare^.shi2_path;
                        Result.Remote:= XPShare^.shi2_netname;
                        Result.DevType:= XPShare^.shi2_type;
                        if (XPShare^.shi2_permissions and ACCESS_READ <> 0) then Result.DevAccess:= SA_READONLY;
                        if (XPShare^.shi2_permissions and ACCESS_WRITE <> 0) then Result.DevAccess:= SA_FULL;

                        XP_NetApiBufferFree(XPShare);
                end;
                }
          end;
          //
          WINFAMILY_9X:
          begin
                GetMem(MEShare, 512);

                S:= Copy(AShareName, Pos('\', Copy(AShareName, 3, MAX_INT)) + 3, MAX_INT);
                AErr:= ME_NetGetShareInfo(PChar(StringUpper('\\' + AUserName)), PChar(StringUpper(S)), 50, MeShare, 512, Used);

                if (MEShare <> nil) then
                begin
                        Result.Local:= MEShare^.shi50_path;
                        Result.Remote:= MEShare^.shi50_netname;
                        Result.DevType:= MEShare^.shi50_type;
                        Result.DevAccess:= MEShare^.shi50_flags;

                        FreeMem(MEShare);
                end;
          end;
          //
        end;
end;




//##############################################################################
//##                                 LISTPANEL                                ##
//##############################################################################


procedure TListPanel.ProcessMessage(Msg, WParam, LParam: Integer);
var AItem: TListboxItem;
    AIndex: Integer;
begin
      (*/\/\/\/\/\/\/\/*)
      (**) ThreadManager.SetExclusive;
      (*/\/\/\/\/\/\/\/*)

        case Msg of
          AM_MOUSE_DOWNL:
          begin
                if (dropped)and(droppedButton.FAddState = AS_ADDED)and(droppedButton.FDropState = DS_DROPPED) then UndropButton(droppedButton);
          end;
          //
          AM_MOUSE_DOWNR:
          begin
                AIndex:= UserList.FindItem(droppedButton);
                if (AIndex > -1) then
                begin
                        AItem:= UserList.Items[AIndex];
                        UserList.TopIndex:= AIndex - 1;
                end;
          end;
          //
        end;


        inherited;

      (*/\/\/\/\/\/\/\/*)
      (**) ThreadManager.ClearExclusive;
      (*/\/\/\/\/\/\/\/*)
end;




//##############################################################################
//##                                 LISTBUTTON                               ##
//##############################################################################


procedure TListButton.ProcessMessage(Msg, WParam, LParam: Integer);
var AItem: TListboxItem;
    AIndex: Integer;
begin
      (*/\/\/\/\/\/\/\/*)
      (**) ThreadManager.SetExclusive;
      (*/\/\/\/\/\/\/\/*)

        case Msg of
          AM_MOUSE_DOWNL:
          begin
                if (not dropped)and(FAddState = AS_ADDED)and(FDropState = DS_UNDROPPED) then
                begin
                        DropButton(Self);

                        AIndex:= UserList.FindItem(Self);
                        if (AIndex > -1) then
                        begin
                                AItem:= UserList.Items[AIndex];
                                UserList.TopIndex:= AIndex - 1;
                        end;
                end;
          end;
          //
          AM_MOUSE_DOWNR:
          begin
                AIndex:= UserList.FindItem(Self);
                if (AIndex > -1) then
                begin
                        AItem:= UserList.Items[AIndex];
                        UserList.TopIndex:= AIndex - 1;
                end;
          end;
          //
          AM_SIZE_ANIMATION_STOP:
          begin
                if (FAddState = AS_ADDING) then
                begin
                        FAddState:= AS_ADDED;
                end

                else if (FAddState = AS_REMOVING) then
                begin
                        if (FDropState <> DS_UNDROPPED) then
                        begin
                                dropped:= False;
                                droppedButton:= nil;
                                UserScroll.Value:= droppedScroll;

                                RemoveContainerChild(SharePan);
                                SharePan.Visible:= False;
                        end;

                        FAddState:= AS_REMOVED;
                        FDropState:= DS_UNDROPPED;

                        UserList.RemoveItem(UserList.FindItem(Self));

                        (*-----------*)
                        (**) FLayerManager.PostMessage(AM_BUTTON_FREE, Integer(Self), 0, mainForm);
                        (*-----------*)
                end

                else if (FDropState = DS_DROPPING) then
                begin
                        FDropState:= DS_DROPPED;
                end

                else if (FDropState = DS_UNDROPPING) then
                begin
                        dropped:= False;
                        droppedButton:= nil;
                        UserScroll.Value:= droppedScroll;

                        RemoveContainerChild(SharePan);
                        SharePan.Visible:= False;

                        FDropState:= DS_UNDROPPED;
                end;
          end;
          //
        end;


        inherited;

      (*/\/\/\/\/\/\/\/*)
      (**) ThreadManager.ClearExclusive;
      (*/\/\/\/\/\/\/\/*)
end;




//##############################################################################
//##                                  MAINFORM                                ##
//##############################################################################


procedure TMainForm.ProcessMessage(Msg, WParam, LParam: Integer);
begin
        case Msg of
          AM_FOOT_FREE:
          begin
                (*/\/\/\/\/\/\/\/*)
                (**) ThreadManager.SetExclusive;
                (*/\/\/\/\/\/\/\/*)

                  FreeNil(Foot);

                  // update the network users.
                  TimerManager.RunTimer(TT_THREAD, TID_UPDATENETWORK, mainForm);

                (*/\/\/\/\/\/\/\/*)
                (**) ThreadManager.ClearExclusive;
                (*/\/\/\/\/\/\/\/*)
          end;
          //
          AM_BUTTON_FREE: TListButton(WParam).Free;
          //
          AM_TIMER:
          begin
                case WParam of
                  TID_UPDATENETWORK: if (Foot = nil) then UpdateNetwork;
                  //
                  TID_UPDATEPROGRESS:
                  begin
                        (*/\/\/\/\/\/\/\/*)
                        (**) ThreadManager.SetExclusive;
                        (*/\/\/\/\/\/\/\/*)

                          if (updater)and(HMultimedia.timeGetTime - updaterTime >= 500) then
                          begin
                                  TimerManager.RemoveTimer(TT_HOOK, TID_UPDATEPROGRESS, mainForm);
                                  Updating.StopAlphaAnimation;
                                  Updating.StartAlphaAnimation(Updating.Alpha, A_OPAQUE, 2, 0.1, 4);
                                  Upff.StartProgress;
                          end;

                        (*/\/\/\/\/\/\/\/*)
                        (**) ThreadManager.ClearExclusive;
                        (*/\/\/\/\/\/\/\/*)
                  end;
                  //
                end;
          end;
          //
        end;


        inherited;
end;


function TMainForm.WindowProc(AHandle: LongWord; Msg, WParam, LParam: Integer): Integer;
begin
        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.SetExclusive;
        (*/\/\/\/\/\/\/\/*)

        case Msg of
          AM_KEY_DOWN: if (WParam = VK_F5) then TimerManager.RunTimer(TT_THREAD, TID_UPDATENETWORK, mainForm);
          //
          AM_MOUSE_WHEEL: UserScroll.Value:= UserScroll.Value - HighInt(WParam) div 6;
          //
        end;

        (*/\/\/\/\/\/\/\/*)
        (**) ThreadManager.ClearExclusive;
        (*/\/\/\/\/\/\/\/*)

        Result:= inherited WindowProc(AHandle, Msg, WParam, LParam);
end;


End.
